(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    334305,       7880]
NotebookOptionsPosition[    321284,       7653]
NotebookOutlinePosition[    321666,       7669]
CellTagsIndexPosition[    321623,       7666]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"\[Alpha]", "=", "1"}], ";", 
  RowBox[{"\[Beta]", "=", "1"}], ";", 
  RowBox[{"\[Gamma]", "=", "1"}], ";", 
  RowBox[{"\[Delta]", "=", "1"}], ";"}]], "Input",
 CellChangeTimes->{{3.8426999506924734`*^9, 3.842699960365472*^9}},
 CellLabel->
  "In[165]:=",ExpressionUUID->"f1254a11-41fb-47a9-ad36-2e6c545a3799"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p1eq", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"u", "[", "t", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "2"}], "}"}]}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{"6", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "2"]}], "+", "t"}]}]}]], "Input",
 CellChangeTimes->{{3.8426997697253585`*^9, 3.842699771668358*^9}, {
  3.8426998342139816`*^9, 3.842699836619982*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"723eb20b-91fa-4ba9-951d-c26584da6958"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["u", "\[Prime]\[Prime]",
    MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
  RowBox[{"t", "+", 
   RowBox[{"6", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"]}]}]}]], "Output",
 CellChangeTimes->{
  3.8426997866186924`*^9, 3.8426998372459817`*^9, 3.842699870608718*^9, {
   3.842699986356835*^9, 3.8426999972183867`*^9}, {3.8428727575749087`*^9, 
   3.8428727725800705`*^9}, 3.842943424527525*^9, 3.843555768738053*^9, 
   3.8437122621656103`*^9, 3.843904152943553*^9, 3.846660607702902*^9, 
   3.853231751103526*^9},
 CellLabel->"Out[1]=",ExpressionUUID->"cd89965d-ab0f-4d30-a1cc-65296b22f96d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p1eq", "//", "TeXForm"}]], "Input",
 CellChangeTimes->{{3.8532317521215243`*^9, 3.8532317573615437`*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"4289db51-8f97-4808-b9b0-ad3c9c5d2571"],

Cell["u''(t)=6 u(t)^2+t", "Output",
 CellChangeTimes->{3.8532317577155447`*^9},
 CellLabel->
  "Out[2]//TeXForm=",ExpressionUUID->"1dd87e5f-6d65-4c37-b3c5-f35d489ae9aa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p1sln", "=", 
  RowBox[{
   RowBox[{"u", "[", "t", "]"}], "/.", 
   RowBox[{"First", "@", 
    RowBox[{"NDSolve", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"p1eq", ",", 
        RowBox[{
         RowBox[{"u", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"u", "'"}], "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}], 
      ",", 
      RowBox[{"u", "[", "t", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0", ",", "1"}], "}"}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.8426939161313314`*^9, 3.842694006070348*^9}, {
  3.8426997651303577`*^9, 3.842699781773082*^9}, {3.8426998596469865`*^9, 
  3.842699875667718*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"5e037d62-d397-4259-b161-c781f9be6548"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   RowBox[{
    TagBox["InterpolatingFunction",
     "SummaryHead"], "[", 
    DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
     TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
             PaneBox[
              ButtonBox[
               DynamicBox[
                FEPrivate`FrontEndResource[
                "FEBitmaps", "SquarePlusIconMedium"]], 
               ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
               Evaluator -> Automatic, Method -> "Preemptive"], 
              Alignment -> {Center, Center}, ImageSize -> 
              Dynamic[{
                Automatic, 
                 3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                  Magnification])}]], 
             GraphicsBox[{{{{}, {}, 
                 TagBox[{
                   Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                   LineBox[CompressedData["
1:eJwVxn04FAYAx3Fus3l9aMPkMU6suanpuSfUMT+jF6noInlZL0Q45TUxRJS3
tXSo2zV5f+vMypHX8u68NN1OXN455+WO3JUIpZe1P77P56vvFXTUhyAjI2P5
qf8tGDl48xX5qNWnlTlCtLXoJMla+LPpoFkb8NS671qFq/xNMPDJh4vWjM6m
mFErWpa7QHWIBTWlc4q+satWE/dVGfvV2CDy9/3JESrAhJvp551WjccKb08K
NLVBjnCNaGmuh/GcfzAstuLEWFPlG/smcAhSnvdmMjwCmV/Fnm5FWURPV4iz
BaaqluZ1w9tBMLthuM3EFtGDWcfv1XDQPHxJwYxlj0Drs2fG+7oQOv7ivPpt
KtYv1iiGCHvAzGdc0bzlgj+uHbdb1uvFVKZtdPfaL0ib1TLUMOeCatwtW/Da
E0/SNP7J+ImHn7m9HQmOZ5GTPkU97N4HUWFXBtk8ADq1jaWDZ57iyK+qCzRy
MIoOttkNX+nHuZfyKa/dwzBEGKwrow9AFzrZVSUXoUlSv7BcxYfn+FuftNwo
EM3UL0n7nkF2LarUbjkWgz6Gx+rHBiGtdEYFOx7Mz09Ebrwfgqrvjtp9zlch
11lMU1EeAcXTQbXls2RYBbLL+tRHUVu03V9rIhXxibOmKjvHELT+LmzrrusI
bibRtazHYXuqiZJ8iA5/P4ZpltcEnHzftzP3ZuDHdY4RL24SDt/diS71uAlH
fkL4wh4Bmue97pBCGFCeM4sx4gswb2ISVDXKhJ58GI3rMYV4qRxdbJsFZjY9
7snkFFrCE23SONlg0Gwo8kFC5Dlav8lxzsOCXcxY2YoQ4keU0eq2fHSctDdM
TZyGSGPD0dy3ECuJeU7/Ks/A6OsP4pYvivEbcYgVmD6DYZokyeJBCYpfFRYf
0J/F1XYKMSX3LjSfraX8XjoLUeZeakFCGZSXJjcp7Z6D1zbGcg2rHH5xrFZh
1xxCz5NKgqbvQVtvw3XLYREuBKu55KRUgLoquJU9LsL05S9ZvRw2JiYcGi57
i+FW8Hj/D+8q0UfJkWsUi6G2RzBjSHmAA9z41Z2R81AYnE0QFVTjmzAJV/3D
PAJYYWOPCLWgOUoO7bixAGG521+66XUwyOUuFX37HCu73SwlpAaQZXbFxhc8
B79O2y609iE6maYVt8mLwDGt/p7IRrBtHvZsrl/E4vcrpV3bm6FvyE/h20tQ
NHAtI+p6C1YjeYELwxL4F3UN9Ke2Ysukk6XvKSkUTlO9y2Pb0B8TcF/vpRRJ
prxkdkY7RoyVFK0jXoDytMc1P6cDNUlzqx8/vgC3pyGCWMfBf7km3Rs=
                    "]]}, 
                  Annotation[#, "Charting`Private`Tag$2424#1"]& ]}}, {}}, {
              DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
               AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
               GridLines -> {None, None}, DisplayFunction -> Identity, 
               PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
               All, DisplayFunction -> Identity, AspectRatio -> 1, 
               Axes -> {False, False}, AxesLabel -> {None, None}, 
               AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
               Frame -> {{True, True}, {True, True}}, 
               FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
               Directive[
                 Opacity[0.5], 
                 Thickness[Tiny], 
                 RGBColor[0.368417, 0.506779, 0.709798]], 
               FrameTicks -> {{None, None}, {None, None}}, 
               GridLines -> {None, None}, GridLinesStyle -> Directive[
                 GrayLevel[0.5, 0.4]], ImageSize -> 
               Dynamic[{
                 Automatic, 
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                   Magnification])}], 
               Method -> {
                "DefaultBoundaryStyle" -> Automatic, 
                 "DefaultGraphicsInteraction" -> {
                  "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                   "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                 "DefaultMeshStyle" -> AbsolutePointSize[6], 
                 "ScalingFunctions" -> None, 
                 "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
               PlotRange -> {{0., 1.}, {0., 0.16968160482572475`}}, 
               PlotRangeClipping -> True, PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
             GridBox[{{
                RowBox[{
                  TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox[
                   RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "1.`"}], "}"}], "}"}], 
                   "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"scalar\"", "SummaryItem"]}]}}, 
              GridBoxAlignment -> {
               "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
              False, GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              GridBoxSpacings -> {
               "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
              BaseStyle -> {
               ShowStringCharacters -> False, NumberMarks -> False, 
                PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
           GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
           GridBoxItemSize -> {
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
           BaselinePosition -> {1, 1}], True -> GridBox[{{
             PaneBox[
              ButtonBox[
               DynamicBox[
                FEPrivate`FrontEndResource[
                "FEBitmaps", "SquareMinusIconMedium"]], 
               ButtonFunction :> (Typeset`open$$ = False), Appearance -> None,
                Evaluator -> Automatic, Method -> "Preemptive"], 
              Alignment -> {Center, Center}, ImageSize -> 
              Dynamic[{
                Automatic, 
                 3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                  Magnification])}]], 
             GraphicsBox[{{{{}, {}, 
                 TagBox[{
                   Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                   LineBox[CompressedData["
1:eJwVxn04FAYAx3Fus3l9aMPkMU6suanpuSfUMT+jF6noInlZL0Q45TUxRJS3
tXSo2zV5f+vMypHX8u68NN1OXN455+WO3JUIpZe1P77P56vvFXTUhyAjI2P5
qf8tGDl48xX5qNWnlTlCtLXoJMla+LPpoFkb8NS671qFq/xNMPDJh4vWjM6m
mFErWpa7QHWIBTWlc4q+satWE/dVGfvV2CDy9/3JESrAhJvp551WjccKb08K
NLVBjnCNaGmuh/GcfzAstuLEWFPlG/smcAhSnvdmMjwCmV/Fnm5FWURPV4iz
BaaqluZ1w9tBMLthuM3EFtGDWcfv1XDQPHxJwYxlj0Drs2fG+7oQOv7ivPpt
KtYv1iiGCHvAzGdc0bzlgj+uHbdb1uvFVKZtdPfaL0ib1TLUMOeCatwtW/Da
E0/SNP7J+ImHn7m9HQmOZ5GTPkU97N4HUWFXBtk8ADq1jaWDZ57iyK+qCzRy
MIoOttkNX+nHuZfyKa/dwzBEGKwrow9AFzrZVSUXoUlSv7BcxYfn+FuftNwo
EM3UL0n7nkF2LarUbjkWgz6Gx+rHBiGtdEYFOx7Mz09Ebrwfgqrvjtp9zlch
11lMU1EeAcXTQbXls2RYBbLL+tRHUVu03V9rIhXxibOmKjvHELT+LmzrrusI
bibRtazHYXuqiZJ8iA5/P4ZpltcEnHzftzP3ZuDHdY4RL24SDt/diS71uAlH
fkL4wh4Bmue97pBCGFCeM4sx4gswb2ISVDXKhJ58GI3rMYV4qRxdbJsFZjY9
7snkFFrCE23SONlg0Gwo8kFC5Dlav8lxzsOCXcxY2YoQ4keU0eq2fHSctDdM
TZyGSGPD0dy3ECuJeU7/Ks/A6OsP4pYvivEbcYgVmD6DYZokyeJBCYpfFRYf
0J/F1XYKMSX3LjSfraX8XjoLUeZeakFCGZSXJjcp7Z6D1zbGcg2rHH5xrFZh
1xxCz5NKgqbvQVtvw3XLYREuBKu55KRUgLoquJU9LsL05S9ZvRw2JiYcGi57
i+FW8Hj/D+8q0UfJkWsUi6G2RzBjSHmAA9z41Z2R81AYnE0QFVTjmzAJV/3D
PAJYYWOPCLWgOUoO7bixAGG521+66XUwyOUuFX37HCu73SwlpAaQZXbFxhc8
B79O2y609iE6maYVt8mLwDGt/p7IRrBtHvZsrl/E4vcrpV3bm6FvyE/h20tQ
NHAtI+p6C1YjeYELwxL4F3UN9Ke2Ysukk6XvKSkUTlO9y2Pb0B8TcF/vpRRJ
prxkdkY7RoyVFK0jXoDytMc1P6cDNUlzqx8/vgC3pyGCWMfBf7km3Rs=
                    "]]}, 
                  Annotation[#, "Charting`Private`Tag$2424#1"]& ]}}, {}}, {
              DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
               AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
               GridLines -> {None, None}, DisplayFunction -> Identity, 
               PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
               All, DisplayFunction -> Identity, AspectRatio -> 1, 
               Axes -> {False, False}, AxesLabel -> {None, None}, 
               AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
               Frame -> {{True, True}, {True, True}}, 
               FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
               Directive[
                 Opacity[0.5], 
                 Thickness[Tiny], 
                 RGBColor[0.368417, 0.506779, 0.709798]], 
               FrameTicks -> {{None, None}, {None, None}}, 
               GridLines -> {None, None}, GridLinesStyle -> Directive[
                 GrayLevel[0.5, 0.4]], ImageSize -> 
               Dynamic[{
                 Automatic, 
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                   Magnification])}], 
               Method -> {
                "DefaultBoundaryStyle" -> Automatic, 
                 "DefaultGraphicsInteraction" -> {
                  "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                   "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                 "DefaultMeshStyle" -> AbsolutePointSize[6], 
                 "ScalingFunctions" -> None, 
                 "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
               PlotRange -> {{0., 1.}, {0., 0.16968160482572475`}}, 
               PlotRangeClipping -> True, PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
             GridBox[{{
                RowBox[{
                  TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox[
                   RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "1.`"}], "}"}], "}"}], 
                   "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"scalar\"", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["3", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["False", "SummaryItem"]}]}}, 
              GridBoxAlignment -> {
               "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
              False, GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              GridBoxSpacings -> {
               "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
              BaseStyle -> {
               ShowStringCharacters -> False, NumberMarks -> False, 
                PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
           GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
           GridBoxItemSize -> {
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
           BaselinePosition -> {1, 1}]}, 
        Dynamic[Typeset`open$$], ImageSize -> Automatic]},
      "SummaryPanel"],
     DynamicModuleValues:>{}], "]"}],
   InterpolatingFunction[{{0., 1.}}, {
    5, 7, 2, {50}, {4}, 0, 0, 0, 0, Automatic, {}, {}, False}, CompressedData["
1:eJxTTMoPSmViYGBgBGIjBgRYeDlq5vwXUvYQWsteuzzoxdKgQvs73G8zmZ83
2Kvc2XB/s0qn/XaTucofLTrtvXo70/V8O+3vPS1dnZ3YaV9ol/R+RWmnPet0
P+NnnZ322h7quxM2ddoH/fzvdPtWp33lqhunQpm77P9O9ZeUn9Ft39h4LP2F
Tq89a67tto0H++xddaKabLUn2N88uoZLR3iGfW78/0lSv+fbN/5Z0dvycbG9
t+eli9VPl9vPWLLddtK2/fbzYwWfNp87Zp9oKfQj+vxp+4ldnaxSGRfsxZg0
JkRYXbKfU3lMajrPFXvFjylLr967am9/MIT7qP91+9iJLoVbDtywr0o0ub7Y
8Jb9DEMV28mLbttXfKtLnxtw1z5i982Jy//ds5dxkLoXEfbAvnuR++dY3Yf2
v1lKOZJZHtkX8N1QlVd6bP9U3Nr5tv0T+yjFeQnTY5/an9NirAuufmbvbJIy
m3/mc/sdtsd3nN72wv7xdfkTYXKv7HmLKq4/bH1tb8Fz8VnO2zf2Scs0v30P
eWdveFnkd7XWe3tILHywBwB8jb3d
    "], {Developer`PackedArrayForm, {0, 3, 6, 9, 12, 15, 18, 21, 24, 27, 30, 
     33, 36, 39, 42, 45, 48, 51, 54, 57, 60, 63, 66, 69, 72, 75, 78, 81, 84, 
     87, 90, 93, 96, 99, 102, 105, 108, 111, 114, 117, 120, 123, 126, 129, 
     132, 135, 138, 141, 144, 147, 150}, CompressedData["
1:eJx1yH1YywkAB/ClyDM956VFdjx6kXoK0Qsd9fsiqVx1Lslb2CFLVGOWlzwK
k1YnnbRGUZnero0ytiiVzJIWsWa7VlrbVMRNOOuG3PPcc//e58+P4/akyFgL
EonEJf2/z+KF5NFxzIDapam7LhevIkoUmy4UDVLx5d/PDXi0t1eePEL7792h
8Po+Nz5+LeGfkV38QaYjLNIiB0sj92GDuFxyd+pRgucateZQtwXait7uthxI
A2/J4rp0eR7hKHD28Gu2RW2CuFc0m4Pw6glrOkfzCN35O29m6WwxQ3vFediP
A4/4bT37F3IJgT42xHEMBf2RZ+nzwznYW2Xib9/JJdJ4LoS/EwXTZClVe37h
IFRywcDP5xJbRH+3M1ZQcP2HOGMFi4MvHWTtojYuEeSjMzVsp6BGGOXdz+Eg
rczuMck7n/AY052azaeghTuvjnaDgznt6ULbwnxieZwrQ2qgIPf4uEBNFwe3
t2aw943jEVm7pA9pc+xgn9j7aJ1lJqQ15uDXyYUE3yax4qh8GgSUjdNn8bKg
Xdi3TlRbTEwOMAVfuEhFe6GCPjj3DPoayt31x/jE9Um0cnHOTHwN+Elccy8b
BfQswchvZYTP2qgd8esdcG/GrhMBHjmYqWycPxLRTDj7+D4mz/TC5MPuE+ba
8sDILso6uUVJ3Ge7uDE/AeSpgjzq5yIsSL/jhxoDMcf8q4NJE4LwE8Jz7GE+
vEwb9ru0DhOF9RHW29Q/43RQmTblZTlUKWYLqtQHnPenR5UJqVj2ccrGQnEj
9G3uwfWGCGh6LQd8l+egq/t1SfVjGTSlz59yLGLw3YPAZ5EePJijXMcbn7Rh
8VXb1jwSHbx0qtFOUYwzzzOTtHEdyI6gdCZnJSHBTefLk17FUJWDpH3pM/ix
65dP/3oAE735sUyHSpir/tJ7TOxEmJ7dfIlIgbvvYYWsX4hTNCcbT70SF3d0
RC1LTYOk5O6Hli/VsDKSTC7RKmR7L25xbDoJeb9N+mVXEToXJL1Tt6pxyDlj
1Wf6aTxU2YaYmbdQM2WL8QjRhRdN3TL10Sx4W1yK/9AnwaSH+YKQmxoYEhgr
/eJykP517uFTfXdwYsCH3LW7B+QWsdXY2Fx4d54tcJvYgNtvchcMOfZCqD9Q
IrjNRZ3inP35W02wDprtlJ2oharpft/kPRdxzaVO/+5IM0KWOI63i+gDI+Zj
mtOxy1BX7vY3rJei3tNZNOKpg8k/NNkUeAWigbbjwk8yvLLThAtpeigZci9G
ZSm4wcb0uKZWTGGVXnqeb0DG5rDuTFYl2l60jNqL5bh5ZANrluolTCqr1anX
hLBXv6ZZ/vEEmeYfmScdBkCfr367eV4NwqxtK2PynmL8zrWrNyUPIujpsvOJ
TSL0RE0ry41WwHqIxt6peYX3CubWpo0S5N+wKlhZrQQpWitfJRnCMVEjjUWr
Q4VuKzvUV41oG/Lv3yRvsaicmXSwuxFqFaVkxasu3DvY+U3Wb4ScvjTMe08z
TFQ3haijB5zCBqcY12F8fBah9BwrRTx1UdKjq71INrduZv05jNjQjkyH2geY
faDdfV6LFj4FrAru/ff4B35zRVw=
     "]}, {Automatic}],
   Editable->False,
   SelectWithContents->True,
   Selectable->False], "[", "t", "]"}]], "Output",
 CellChangeTimes->{{3.8426939444243317`*^9, 3.842694006561348*^9}, 
   3.84269974298481*^9, 3.8426997867766914`*^9, {3.8426998562999873`*^9, 
   3.842699876276718*^9}, {3.8426999863988314`*^9, 3.842699997287386*^9}, {
   3.8428727578530235`*^9, 3.8428727726067724`*^9}, 3.8429434248624935`*^9, 
   3.843555769124055*^9, 3.843712262540694*^9, 3.8439041532265816`*^9, 
   3.846660608037902*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"268c1833-a1e6-4cd5-884f-d8563d3769dc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{"p1sln", ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.8426940287335978`*^9, 3.8426940389565983`*^9}, {
  3.84269972015781*^9, 3.8426997229958105`*^9}, {3.84269978491842*^9, 
  3.8426997855076914`*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"80025d57-69b2-4b39-b713-800172d55e34"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwVVmc4FX4DJRQqozRIIdGyklHid6yQUUQZ1c1ORkhDGiKjMuPayh7ZI3td
3IuUhvhLyU5I3RYa4u39cJ5zznM+nS/nOWK27kcdlrGwsPz8h/+zvsPkS9rU
MfJPsgSUGh9g1xLyGBJUAIuFkk/Wpiy1vSnxyeWC2mCRGnZjvu5XGxfe5ndZ
8jDUbyU+s7D+pWbQ1Vd2X9AMLK9VdORFeMm20M1ZSyKWELXX6HvduJks6NvF
2UhS4MRgdxt12kGmA3roNrE20Nc0kHYTkCfm9vMNUYL2KOj1oTiN7yN0LaGq
1mRHTIUITRkcUCdy4molP0TOQnWd/Ns3R7VJ8jLrhxIZLngte2x4RYke4Rz1
Tz8ueQ51Yrs69C2NSO1wd1ermQdMH66h/1IwIR7G9vonYz2RXJr+vW+lGZGk
zbb96DuP+OUfPJ5ZmJN3ssFaYYIXYDiYIc2OE4SaspEmceIiXH/H87q9Ok30
efNUG5MvQbSmK/NqhC1h8T1Qc3zwMi4JcfnkRDqQys9PFZkiV/DyYE33iykn
4kqhlAXb+IDtMIWjNMaVbH3GlBHNuIq433+HNHU9SHjhmh0mkjdAeISXfcu7
QA5uzsycOuOLKZcXjpf5L5MbbYl8zWY3cTrmziarB1eI5Y2xw2GzN/F7Qc1w
xPwaUVCSCrOM9YOxUDx7ua4v4f184YmEsj9Kty/9vnbAj0xnNXB96/OH47xc
deGsP0lddyTormAAaiv/2KT1BpGrXXH047UB2M7RUFP2+zY5Hji8TPxEIFZ9
cF2TohFCVs16+tYlB0GN0dRSvSGSfCiobQhWC4ax3JoBKed7pMWebcF0MBgC
d6VZp55EEe8eqveMyB2E16RT6mgxxDT0XWU17Q7SSHn1eos4IqMtORtgcxfB
lFU8v5clkPHyKs/NGSGIjp2PyI9LJk0uLCVTWqEw6xxh3PB/QBLFD32uGA/F
4C/n9ucaqcQk+o3zYclwjOwVKrZ1SCdSBuIPhdrD4X3WYe347QzCyeb6YeJM
BC7V2rDdrc4kp2sWS5vMIrHvRYKehloOMVwn/lIiKxKGeR9vvIzKJSqeul9C
ZiOxvEuILWD2IVm3M1LGIvYe4sXVqozGCsiywEdGjRP3EOuu0zF2roh8GX7t
uk05CucSC34YspeQJ/Fi+V/6ovA5Z4ynrLyU+HGWb78jSEWlyfUjJa4VZJfu
vdtlHlSIysl3+wZUku5A96m37VT8qG8oe5xVRbaxSeXLXIoBZ1OC8jmOWvJU
g3uVRVcMWjO4SwW168jFm5OufttiIbk+Wn4ktJ60/c2U6emOhc+d3T8d1JqI
u+qtiL8745C/VMhZe5RGNl61+SLpFwfPS+c/i6xqJmd/bi67IhsPm6hUIcuI
FrLqe6yiSGgCilwvPq7sZ5CKPRdj9cYSoH3I1Gu6to1QPEznPVUSoeD9IHVL
ejsp/sRbQ59MxFqd+1b9/o/J0cnbqs4Hk0GtFhF9FtFF/kieuR+dnIwAA4Oa
AxnPSKbDwcX678ng4Ze4adDwnMyOstJ40++jpJtV6eWylyT+nY9WxeID0Hbs
6Ci98IpoCFtmDh5LwV1nJ8VVQj1k2kqZg7MwBeIGqeGcrT1ky8wVu0LpVGzT
DnbnFf2PuJ9VkmAZSIWHvUSvx4p+Qr+d1UtdkYatsetCZzv7ycZcgaCde9Ow
oLSF3S3qDaFNfJs4ejcNHSu50k9KD5A19sW5WfvS0ZKr5GtJHSKOt7ZYqtin
4yHHOaqu6jCpSw/jeh6RDovdpxQCSoaJ/YiL88+JdOjPvea+nDJCKig7pAxi
MjBWieAXcWPEwjKt+MvXTDy2TXBonPtAmG/NuNOFsmB8Q1hR59YkCaJwOphq
ZeHZGHX1F/4pUm7nLlRJ/efr3xjWKk4TnnNqgVeVs1HV+VkqOW6GMPz7rZZf
z0GerJvVhvEv5CRHWEVVVg6OjVca2ap+Jd+C1fnOPsvBk1oHqaGYr0Q0LIfx
RCQXqTrF7y8ZfiPX4i7K3WvJhRxODph3fCfyBfzLhTnzQDtYf71gYY48lmFY
d8nlwVjLY2bV2XliXepdd8MyD3xLKdK0/+ZJWOWQx0heHiIDlW22V/4kk7TC
t9lG+bA+lCUmH/ibPOg9VLonugA3TZHH4bhIFC3+rhyrK0CqcxrH3clF8vRN
iSN1vAC07yFC/q5L5NfQBuF5xULse3Wq11mVBWbT74PqXxdi8r3DQpoJK1Yu
+Z3U3VIMFoeBuYBUNsSfNadI6RSDb8H0o+UMG7b1SFnznytGrpTwka/72EEe
9tm9bSjGl2UN2i497Kh5GFtRJVOCm2vXc+UILMcn05l6g2clmDzUurC+jhMK
XH1qZPRfnte9M3gtF3wamxvl5kpgrZKv89iVCyt2xtHWbSnFz6u9su1i3BBb
1KAPuZXiC31gmB6zEsdy4554rS6D3F9hemo2D5JP+Rs6ipWBZiu7J3MVL0bX
uHVZKJYhstaX544XL9yvaz5XO1UG41t/rv0V48Odo5+6VxSW4aZXgFXXPB8a
FjTfJBmWg2axYG1SswYSJp8nW0MeITPT8NHhuPUQ8tVVOZP2CE69HK5zg+vB
V5gawl31CB4n6vkUt2/Ab05TGZPRR7CPPpJ4pWYDXtCqvAb3VSC932RR7v1G
+Mj5Lf58X4HwpMGQMctNeMYrICCjXgVK4OzEMYooWtXcHF4eq8Lruv8+7gkV
RbVLW+UFlyrM32Aa2NWKIqPd27IutgrXhilW7RvE4O377oHepyp4FJhb3P9P
DFuZ2TvtEqtR/rRDsM1eHJef7Uf8jxqc5o6pU2BIgkem4v1jzlpMtySH+f+W
RGaYXOgf4VocO7zaRFxuO14abu+nHKzF3V1+hZTk7dj9RMBLIrYWq022tLV6
78BQOzO7TLkOFtyBzb4au6DbnMXT5VMP+v3FA34CMhgUFatYDK/H59i/Iw/N
ZHDhZvIJuYx68OvsCpCOkUEaonOjn9RDqd2hUWeDLP403NS0Em7A4KlprnFe
ORTXnrj0oaEBVg1cuiJie7DhEf8gK2sTcleoh1PO7MXJ0D9m4+ub4C/xfeBe
5F6k279/0ibVhN7qmGNLNXshta6mJsSiCSu/uTvdWa0AzUvWMetKmsDz4UM4
pUoBSsnm2VRZGiJlBcrl1ivBhpJ9KneQBmoUF2s0634E6G9KSJiiQadk07iV
/H5kK0X23P1Bw7IpH15bu/2Y4fExcONuRmLo9KhM235cajLaL6/UDNVuvvm2
cBWEis4K1Ic1Y67TJldAShWVo1pPn6u2IHpe+Kl2PPCfnt/XMN0WOO8pN1F5
AcwVNa43PNoC+5TNo/vY1aF8db9Nx5kW+I+EBr5SVUf1Wtk5WlQLbJfOFcUV
q6NGW0i0bLIFWzs9r7omaaA++4sXldqKHp7apOehWhhYJZNwNKUVF6ZfVPAU
amHhvEsjX14rBIw05T27tKCGCc6wplZcmSxJSeXRRmPf2/uB060oeyDukh+l
jSbO9vZL6nSsE46r8ks7iBbn+5ssZ+hYU72qufqNLsqnXFwoc3SoP6rm5f2r
i0wnlTo7Fga0Zg9rBonoIdCxz+qcAAPGyiJRffZ60LPlT7ylygCndhR1xVc9
PLcM3FgUykB44qeJPF59DOi5rWOTbkM24+0rV0dDzEqq8Ra6tcMpxks1p9EY
ZFSz/a53O5p5+10We40RdF/P1+lWO/ynFjVcPhljvYAZUzyhHdFJOdxBwiZQ
YnV5nkhvx+Fr0pLNV03g/TY+4vamDmSqfTQ4To5iIeIHr/3jDlD6j/tq9phi
2a98vk0SnZASzBs0PWiOTV2a3yHbiW3CxvEXrM2hkNbfa7+/E5DYeTrvqjkc
Dq1IKjLqREu8gOKxMnN0JNhKaF7qxLd7ChO5ohaIUBFUOdveiV8+T28eYbWE
8LUgu6qzT8DaXFXW3W0FpSXrStOip+g7r8HjU03B0wCFZ227noPD8Zk6R6Ud
RCI//nr4+QWcmqkLE3pn8XF+aLBXrhufrmiWyFq5I3O6rpMn/BX6dz6gOF7x
As/mHOb4eA+YeS3Bgc2XEXq2wjF1239glGx1b9S5hjn1/HEn3z5cXV74eN/7
m7ggT3+0vvU1iuSK/PsYtzBURA95KfYGZleKgnL+/cY/zj1JO33ewi+wS2Cc
PQS7NVYsOtYN4Ov3FLXF8XDopoudKd0wiM5d3vy5TfdwefPprSMnh7A/3kBr
x0YqpGaOrewzGsZ90ZO1irGxWMv7hZP+exhqVL/4P7cSwN6UVCyePIIbQWHC
Hy8nw0Whrp/LYBTXSkzEVnxMQf4h29TGuVGMK2+6FNmRhtmPQnwTsWMYNp6V
M0rKQIWpLhtVexwzkrtKs6uz4KsXmPJoYhyP18WcVe7Jgdg7/dcZge8x8MLI
z2J5HlSUA6iC8hNYrRCVQQsvwMktz3+xvpqASAf7Gjb+Ysx2ho16+H1A2p+f
I9m/ShDPTrlwdNsk3h1ctpbmWIa1gxXpy+iTcIsWf+g5XA6O635m+z2n4JDL
7z4bWQGWh5Ti0TXT8GLVP9+sUoXzicVha1qmkXzCeK+QWA0adt/m5D/3ESMb
SnmzN9aBX/+8lD/PDKyTtN+eW96AAekXr67Uz8D9pOWL+X1NKHmAbeOUT7j4
rufbgRIaThUr8W9e/Of3LGwxftKMm4FpfgN5n3H+w3HZvatbUTi5OYnHkIlW
067ecV06bt8PtB48zMSRjOvS/kZ02B/9JFFkwoSA8kC6qCkdwvX1JUbmTPBU
mXywptBxN+JEW6gtE+m8Q28/X6DDSSnhK/cVJrYeyk9QT6dja4CA3opsJgJN
TyTV/6Vjcd+11X25TAxYpv69zsZA/6ex7ux8Jj5Jr72lzsVApHn5KZ1SJtom
FH52/NuBpV1HvQLrmaAFG0V+2M3AwMuIB2yvmPCnbEk5YcVAddC83ateJnIU
dA7JWjNAPXB6Z8ZrJpZTXATZHRkwyJJ5pDnIxNJKO6lSTwZqvbse+00xEfp1
SUzwDgOx0ooRJjNM3JHjZp0LZ8BzNNlMjMn890Our+ihMrDD0HWI9oOJG/zm
IdGpDLCz9mRGzjNh6r+R62I2A8MVB5ytf//rJ/u7yLyAgXrnDFm5v0yYzO28
fqCMgTiRlbNLS0ycb+r1Eq1m4H8wC2Wd
       "]]},
     Annotation[#, "Charting`Private`Tag$2572#1"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->{852., Automatic},
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 1}, {0., 0.1696816030121187}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.842694039609598*^9, 3.8426997430848103`*^9, 3.8426997868216915`*^9, 
   3.8426998787087183`*^9, {3.842699986474831*^9, 3.842699997379386*^9}, {
   3.842872757895966*^9, 3.84287277265035*^9}, 3.8429434249175215`*^9, 
   3.8435557691980543`*^9, 3.8437122626056104`*^9, 3.8439041533025827`*^9, 
   3.8466606081269026`*^9},
 CellLabel->"Out[4]=",ExpressionUUID->"73a6ec9a-613e-4b99-aef8-43ded5b09174"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"gridres", "=", "100"}], ",", 
   RowBox[{"gridres", "<", "501"}], ",", 
   RowBox[{"gridres", "+=", "100"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"grid", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"t", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "0", ",", "1", ",", 
         RowBox[{"1", "/", "gridres"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"tab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"p1sln", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "grid"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"SetDirectory", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"StringJoin", "[", 
       RowBox[{"\"\<wolfram_sln/\>\"", ",", "\"\<P_I_sln_\>\"", ",", 
        RowBox[{"ToString", "[", "gridres", "]"}], ",", "\"\<.csv\>\""}], 
       "]"}], ",", "tab"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.84355487838768*^9, 3.843554895410679*^9}, 
   3.843637870955584*^9, {3.8436518489699364`*^9, 3.843651862123931*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"761d626e-7a86-4378-880c-c5c325483512"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p2eq", "=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"u", "[", "t", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "2"}], "}"}]}], "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{"2", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "3"]}], "+", 
    RowBox[{"t", " ", 
     RowBox[{"u", "[", "t", "]"}]}], "+", "\[Alpha]"}]}]}]], "Input",
 CellChangeTimes->{{3.8426997697253585`*^9, 3.842699771668358*^9}, {
   3.8426998221569815`*^9, 3.842699822259981*^9}, {3.84269992103925*^9, 
   3.8426999412142487`*^9}, 3.8426999954773855`*^9},
 CellLabel->"In[3]:=",ExpressionUUID->"a9124145-637c-45e5-991f-1c0c92e5f787"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["u", "\[Prime]\[Prime]",
    MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
  RowBox[{"\[Alpha]", "+", 
   RowBox[{"t", " ", 
    RowBox[{"u", "[", "t", "]"}]}], "+", 
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"]}]}]}]], "Output",
 CellChangeTimes->{
  3.8426997866186924`*^9, {3.8426999865118313`*^9, 3.8426999974443855`*^9}, {
   3.8428727579222565`*^9, 3.842872772677122*^9}, 3.842943424954492*^9, 
   3.843712262785611*^9, 3.843904153501583*^9, 3.846660608342903*^9, 
   3.8532318083370976`*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"c9fc5a55-6ff8-4047-a7ce-469a74939ff9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p2eq", "//", "TeXForm"}]], "Input",
 CellChangeTimes->{{3.8532318099090967`*^9, 3.8532318139450974`*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"4b3dc734-6b80-45e2-95e9-bc7078f49a4e"],

Cell["u''(t)=\\alpha +2 u(t)^3+t u(t)", "Output",
 CellChangeTimes->{3.8532318143050966`*^9},
 CellLabel->
  "Out[4]//TeXForm=",ExpressionUUID->"60c2ec2c-c71d-4918-9cab-15229819efed"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p2sln", "=", 
  RowBox[{
   RowBox[{"u", "[", "t", "]"}], "/.", 
   RowBox[{"First", "@", 
    RowBox[{"NDSolve", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"p2eq", ",", 
        RowBox[{
         RowBox[{"u", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"u", "'"}], "[", "0", "]"}], "\[Equal]", "0"}]}], "}"}], 
      ",", 
      RowBox[{"u", "[", "t", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0", ",", "1"}], "}"}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.8426939161313314`*^9, 3.842694006070348*^9}, {
  3.8426997651303577`*^9, 3.842699781773082*^9}, {3.842699978637831*^9, 
  3.842699982635831*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"c6c8dce6-0907-4d7c-92e5-041798d3d4b6"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   RowBox[{
    TagBox["InterpolatingFunction",
     "SummaryHead"], "[", 
    DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
     TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
             PaneBox[
              ButtonBox[
               DynamicBox[
                FEPrivate`FrontEndResource[
                "FEBitmaps", "SquarePlusIconMedium"]], 
               ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
               Evaluator -> Automatic, Method -> "Preemptive"], 
              Alignment -> {Center, Center}, ImageSize -> 
              Dynamic[{
                Automatic, 
                 3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                  Magnification])}]], 
             GraphicsBox[{{{{}, {}, 
                 TagBox[{
                   Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                   LineBox[CompressedData["
1:eJwVxn04FAYAx3E8We28lXntaenKepiu1YU2WT+zPSW002kTpm1elm5G3qK6
3CimRO460qOsREZDtxvn7RzK6zjOde7c3J0Tx8lLXkJrsfbH9/l8icFR1DA9
HR0d17f9b6Hciz1Pph58u7/9wy9ybbPXPXCak41dmuW1RhoR8UblejvC7kE/
xLeBrnUHLT9g2ERWCuFq33yQ6jiUlSa5hzdykPq9l1pADsZHwhvhoVlVyJLt
kb0i/ARywomEJkEteq1JJ4Nr4hA01PjHK89G5BVsZT4rpyMwMs806btmXGLL
h2ZUKVBz57Rb4x/DkXG9IqfsF1yQ5vtVVLciwm+w48q5TES6/RCiELVD8ZKi
TmtgYuVsNSF6pBNO31h2eM+zcTPDz2PBphvqexOHwuvzkDVmZWu+XwiDs8aE
c9duoyfL/C/Wp314J+flQjrjLgqY6mNHA0Rw5iSvrxooxBYev0Qa0g/x73Eu
6fbFKPJq8Ri8JIZP+H7SewMlkOlJa8qyn+LP1dEQs/NlsLA3i1vgSuCwyn1g
wSjHNmezizOiAYSRWJxsyiNIw2y/qh2SIsd/b8qHUg7y1gUlvn4jg08MiTh+
gwv9tmKakaEc66J3VtgeqsLBSE6ZyOxvrD/QvU+gy0Ny6piTkeMQJsV1L7Ys
1+CMwD7byk2BrkxVy7KiDqfDc53yg5W4yTLOitLjY/dKq10fQwX+2hTVlCwA
RZISP/nFMPr9b/dmlDTBUONMt5MM4/NEJ0qgtBk2G2JpwkA1BMQI4uC/Lci7
k83oUanRRDUN03zwBLk0d5cNUSNYaYtgtse0YtKDPlS2OILLPKt0f24bnpz0
tL2S+gzN1JWvFdYdWEy969trOAr6ee0t09hOXN0mK41kjiJjZ1Puqd4uFM/f
Lz5CHIOhnx3vzPFuWAwsp18rGYMtKzpzV1cPDOdUmww+0aBl2Zs0S+tFOKO0
eaRdA0dl/W7z9D5stnl9YvvRcSxae1ToU0U4tjScc0cxDopzjNxgXz+Uyi/r
fg6dgEGliURLEEPkUqDPn5hA1d43zUajYhwRJi85JmoRapz27ozkKSxjp4Vm
q1poWdz1D/gS0CjT3nuuT2LEk61OFgxgx6/CuaL3n+MCT01iP5aCrPNxUnLh
czxkW/LiG2Roy3N6dIs8BbtNKQMxokFw3Os7rWuncLiHoumSy0G0laRLPKdh
3iD+bFx3CEuJfZGTg9MwSwozz3JQYLvK1/XUtzNQMrleqR5KiOk/Vtq8mMFG
gqXP/VQV5A4GBLeEWaRcZeX2BwyjOk2ztLY2i4sZm70frgzjP/GD6h8=
                    "]]}, 
                  Annotation[#, "Charting`Private`Tag$2762#1"]& ]}}, {}}, {
              DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
               AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
               GridLines -> {None, None}, DisplayFunction -> Identity, 
               PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
               All, DisplayFunction -> Identity, AspectRatio -> 1, 
               Axes -> {False, False}, AxesLabel -> {None, None}, 
               AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
               Frame -> {{True, True}, {True, True}}, 
               FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
               Directive[
                 Opacity[0.5], 
                 Thickness[Tiny], 
                 RGBColor[0.368417, 0.506779, 0.709798]], 
               FrameTicks -> {{None, None}, {None, None}}, 
               GridLines -> {None, None}, GridLinesStyle -> Directive[
                 GrayLevel[0.5, 0.4]], ImageSize -> 
               Dynamic[{
                 Automatic, 
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                   Magnification])}], 
               Method -> {
                "DefaultBoundaryStyle" -> Automatic, 
                 "DefaultGraphicsInteraction" -> {
                  "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                   "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                 "DefaultMeshStyle" -> AbsolutePointSize[6], 
                 "ScalingFunctions" -> None, 
                 "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
               PlotRange -> {{0., 1.}, {0., 0.5303551184082235}}, 
               PlotRangeClipping -> True, PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
             GridBox[{{
                RowBox[{
                  TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox[
                   RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "1.`"}], "}"}], "}"}], 
                   "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"scalar\"", "SummaryItem"]}]}}, 
              GridBoxAlignment -> {
               "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
              False, GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              GridBoxSpacings -> {
               "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
              BaseStyle -> {
               ShowStringCharacters -> False, NumberMarks -> False, 
                PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
           GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
           GridBoxItemSize -> {
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
           BaselinePosition -> {1, 1}], True -> GridBox[{{
             PaneBox[
              ButtonBox[
               DynamicBox[
                FEPrivate`FrontEndResource[
                "FEBitmaps", "SquareMinusIconMedium"]], 
               ButtonFunction :> (Typeset`open$$ = False), Appearance -> None,
                Evaluator -> Automatic, Method -> "Preemptive"], 
              Alignment -> {Center, Center}, ImageSize -> 
              Dynamic[{
                Automatic, 
                 3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                  Magnification])}]], 
             GraphicsBox[{{{{}, {}, 
                 TagBox[{
                   Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                   LineBox[CompressedData["
1:eJwVxn04FAYAx3E8We28lXntaenKepiu1YU2WT+zPSW002kTpm1elm5G3qK6
3CimRO460qOsREZDtxvn7RzK6zjOde7c3J0Tx8lLXkJrsfbH9/l8icFR1DA9
HR0d17f9b6Hciz1Pph58u7/9wy9ybbPXPXCak41dmuW1RhoR8UblejvC7kE/
xLeBrnUHLT9g2ERWCuFq33yQ6jiUlSa5hzdykPq9l1pADsZHwhvhoVlVyJLt
kb0i/ARywomEJkEteq1JJ4Nr4hA01PjHK89G5BVsZT4rpyMwMs806btmXGLL
h2ZUKVBz57Rb4x/DkXG9IqfsF1yQ5vtVVLciwm+w48q5TES6/RCiELVD8ZKi
TmtgYuVsNSF6pBNO31h2eM+zcTPDz2PBphvqexOHwuvzkDVmZWu+XwiDs8aE
c9duoyfL/C/Wp314J+flQjrjLgqY6mNHA0Rw5iSvrxooxBYev0Qa0g/x73Eu
6fbFKPJq8Ri8JIZP+H7SewMlkOlJa8qyn+LP1dEQs/NlsLA3i1vgSuCwyn1g
wSjHNmezizOiAYSRWJxsyiNIw2y/qh2SIsd/b8qHUg7y1gUlvn4jg08MiTh+
gwv9tmKakaEc66J3VtgeqsLBSE6ZyOxvrD/QvU+gy0Ny6piTkeMQJsV1L7Ys
1+CMwD7byk2BrkxVy7KiDqfDc53yg5W4yTLOitLjY/dKq10fQwX+2hTVlCwA
RZISP/nFMPr9b/dmlDTBUONMt5MM4/NEJ0qgtBk2G2JpwkA1BMQI4uC/Lci7
k83oUanRRDUN03zwBLk0d5cNUSNYaYtgtse0YtKDPlS2OILLPKt0f24bnpz0
tL2S+gzN1JWvFdYdWEy969trOAr6ee0t09hOXN0mK41kjiJjZ1Puqd4uFM/f
Lz5CHIOhnx3vzPFuWAwsp18rGYMtKzpzV1cPDOdUmww+0aBl2Zs0S+tFOKO0
eaRdA0dl/W7z9D5stnl9YvvRcSxae1ToU0U4tjScc0cxDopzjNxgXz+Uyi/r
fg6dgEGliURLEEPkUqDPn5hA1d43zUajYhwRJi85JmoRapz27ozkKSxjp4Vm
q1poWdz1D/gS0CjT3nuuT2LEk61OFgxgx6/CuaL3n+MCT01iP5aCrPNxUnLh
czxkW/LiG2Roy3N6dIs8BbtNKQMxokFw3Os7rWuncLiHoumSy0G0laRLPKdh
3iD+bFx3CEuJfZGTg9MwSwozz3JQYLvK1/XUtzNQMrleqR5KiOk/Vtq8mMFG
gqXP/VQV5A4GBLeEWaRcZeX2BwyjOk2ztLY2i4sZm70frgzjP/GD6h8=
                    "]]}, 
                  Annotation[#, "Charting`Private`Tag$2762#1"]& ]}}, {}}, {
              DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
               AxesOrigin -> {0, 0}, FrameTicks -> {{{}, {}}, {{}, {}}}, 
               GridLines -> {None, None}, DisplayFunction -> Identity, 
               PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
               All, DisplayFunction -> Identity, AspectRatio -> 1, 
               Axes -> {False, False}, AxesLabel -> {None, None}, 
               AxesOrigin -> {0, 0}, DisplayFunction :> Identity, 
               Frame -> {{True, True}, {True, True}}, 
               FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
               Directive[
                 Opacity[0.5], 
                 Thickness[Tiny], 
                 RGBColor[0.368417, 0.506779, 0.709798]], 
               FrameTicks -> {{None, None}, {None, None}}, 
               GridLines -> {None, None}, GridLinesStyle -> Directive[
                 GrayLevel[0.5, 0.4]], ImageSize -> 
               Dynamic[{
                 Automatic, 
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                   Magnification])}], 
               Method -> {
                "DefaultBoundaryStyle" -> Automatic, 
                 "DefaultGraphicsInteraction" -> {
                  "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                   "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                 "DefaultMeshStyle" -> AbsolutePointSize[6], 
                 "ScalingFunctions" -> None, 
                 "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
               PlotRange -> {{0., 1.}, {0., 0.5303551184082235}}, 
               PlotRangeClipping -> True, PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
             GridBox[{{
                RowBox[{
                  TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox[
                   RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "1.`"}], "}"}], "}"}], 
                   "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"scalar\"", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["3", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["False", "SummaryItem"]}]}}, 
              GridBoxAlignment -> {
               "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
              False, GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              GridBoxSpacings -> {
               "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
              BaseStyle -> {
               ShowStringCharacters -> False, NumberMarks -> False, 
                PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
           GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
           GridBoxItemSize -> {
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
           BaselinePosition -> {1, 1}]}, 
        Dynamic[Typeset`open$$], ImageSize -> Automatic]},
      "SummaryPanel"],
     DynamicModuleValues:>{}], "]"}],
   InterpolatingFunction[{{0., 1.}}, {
    5, 7, 2, {35}, {4}, 0, 0, 0, 0, Automatic, {}, {}, False}, {{0., 
    0.00008381213964465798, 0.00016762427928931596`, 0.015414274069028988`, 
    0.03066092385876866, 0.04116568650353114, 0.05167044914829363, 
    0.062175211793056115`, 0.07560797871107834, 0.08904074562910055, 
    0.10247351254712278`, 0.115906279465145, 0.1406865397718121, 
    0.1654668000784792, 0.19024706038514627`, 0.21502732069181338`, 
    0.23980758099848046`, 0.2787684903932864, 0.31772939978809234`, 
    0.3566903091828983, 0.39565121857770424`, 0.43461212797251014`, 
    0.4735730373673161, 0.5192541393363452, 0.5649352413053744, 
    0.6106163432744036, 0.6562974452434328, 0.701978547212462, 
    0.7476596491814912, 0.7933407511505204, 0.8390218531195495, 
    0.8847029550885787, 0.9303840570576078, 0.9651920285288039, 1.}}, {
    Developer`PackedArrayForm, {0, 3, 6, 9, 12, 15, 18, 21, 24, 27, 30, 33, 
     36, 39, 42, 45, 48, 51, 54, 57, 60, 63, 66, 69, 72, 75, 78, 81, 84, 87, 
     90, 93, 96, 99, 102, 105}, CompressedData["
1:eJx1yHtQywEAB/BW6PGHRK5idyi7SaSYU6fta7GECrGSuqWynncqWsVsXa3V
JeqE+MOMktITKeXRMHrceqxaqTTLpCj0q4Ykzpy/ff78rAqN9eWSDAwMogz+
h4DX7G+1wIHBaGYevpI1sxSBZv/e9mBK+LXrfgx/7t+ngML491fyhgpIlBUY
Ke95kHE+Fw5Nl8dJ+j+SnMOmtTOgs9gyT8KV4k5/F9lc/8nfDPmd8j2wfGN/
pm5JERK8ki6s1r+042LoSg0bVr10p/KEUsRnLGZ76j+QFmTvUhYMp4Sjmsqe
KgT9cDUR6t/Rh0eOjI6A8MWmiX2B1dBofW9r9e907/Difrc4cAw9GoYVtbDq
P+Z+nEQgayznvjyVh4bXDnVX3R6CHlmYQjMksJWboJsT8REh0ealVzwB2cvI
0tmIwKiLjzWLlQ65o2xGavQcb6tOUGvnE6CMsRlTZmdhId+rtHJ+idYFAjtv
UwLW0j52cVYesmqa7LnBzaBHuaioCwlEOm2mcqou413tKUpbjgJB6Tbkk5YE
PE5ne6sTJaj2fOQolbWj51mrN49MYNEaQ/vksUKEhZRMK951wr9648v36wjE
hCdllmlvo+0p1VUerUJ3cdfHAXcCnwZ4Z8753oFzZs76m197cfbDrkaPYAI7
OFrJRZv7YGSfXy0W96P1ho2MJiIQb8mb272zDvyOU7klywexzD+iTllFoNT6
973Gwcewyz9SkVb/Bk8V3LjYEQIuN/ml+0OegTld1psyPoS7uu0Cr82TKFw/
Iu6UvICNOmCdZ5oWHHOR6kv+JJjy3DgxpRmytfyWGdthqBp3migXTkEya0qP
nVVgq/l3YUvHeyS2d4/a3phCSuaESaq5EjtiKAJO9ihShRki0oFp+BRcopL3
dCGuKGpOc+gj6PW6yltrdZAt2mD36q4KFmF7O6zcxhHM7lPXbviK6PaTaW9Z
r8D8nCHKd/0M4em+IknMNyTuNwsZMh1A8qA/S+s3gXzSaKDx2HeEJgUIjElq
DLt2swLaCGzji8NS63+AmTl8fWOkBuyCOV1l/SRqlMbNtKCfcMht8CubGQI5
JJ75uGYKgvDWqDD3X/gDonaN4g==
     "]}, {Automatic}],
   Editable->False,
   SelectWithContents->True,
   Selectable->False], "[", "t", "]"}]], "Output",
 CellChangeTimes->{{3.8426939444243317`*^9, 3.842694006561348*^9}, 
   3.84269974298481*^9, 3.8426997867766914`*^9, {3.842699986609831*^9, 
   3.8426999975153856`*^9}, {3.8428727579515266`*^9, 3.8428727727040644`*^9}, 
   3.842943425007492*^9, 3.84371226283461*^9, 3.8439041535425835`*^9, 
   3.846660608407902*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"55f3108a-ce9d-426e-a891-155dbc11c9b4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{"p2sln", ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.8426940287335978`*^9, 3.8426940389565983`*^9}, {
   3.84269972015781*^9, 3.8426997229958105`*^9}, {3.84269978491842*^9, 
   3.8426997855076914`*^9}, 3.8426999845168314`*^9},
 CellLabel->"In[8]:=",ExpressionUUID->"bb19a941-060a-4916-9229-f78d87008b78"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwVj2k4lQkDho+0SLK1IqRQiePUIKneRyFZqrEnOSF7QjWSJMuH7KlkD3Eo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       "]]},
     Annotation[#, "Charting`Private`Tag$2818#1"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 1}, {0., 0.5303551143633638}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.842694039609598*^9, 3.8426997430848103`*^9, 3.8426997868216915`*^9, {
   3.8426999867588315`*^9, 3.8426999975803857`*^9}, {3.8428727579955273`*^9, 
   3.842872772747548*^9}, 3.842943425075493*^9, 3.8437122629066105`*^9, 
   3.843904153598585*^9, 3.8466606084989014`*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"f76a0e58-0e22-4333-b434-55d93638d1ac"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"gridres", "=", "10"}], ",", 
   RowBox[{"gridres", "<", "110"}], ",", 
   RowBox[{"gridres", "+=", "10"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"grid", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"t", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "0", ",", "1", ",", 
         RowBox[{"1", "/", "gridres"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"tab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"p2sln", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "grid"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"SetDirectory", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"StringJoin", "[", 
       RowBox[{"\"\<wolfram_sln/\>\"", ",", "\"\<P_II_sln_\>\"", ",", 
        RowBox[{"ToString", "[", "gridres", "]"}], ",", "\"\<.csv\>\""}], 
       "]"}], ",", "tab"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.84355487838768*^9, 3.843554895410679*^9}, 
   3.843637870955584*^9, {3.8436518489699364`*^9, 3.843651862123931*^9}, {
   3.8437122175066123`*^9, 3.8437122446186204`*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"67aa16d0-6fae-471a-9419-87d1789187fa"],

Cell[BoxData[
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"gridres", "=", "100"}], ",", 
   RowBox[{"gridres", "<", "501"}], ",", 
   RowBox[{"gridres", "+=", "100"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"grid", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"t", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "0", ",", "1", ",", 
         RowBox[{"1", "/", "gridres"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"tab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"p2sln", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "grid"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"SetDirectory", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"StringJoin", "[", 
       RowBox[{"\"\<wolfram_sln/\>\"", ",", "\"\<P_II_sln_\>\"", ",", 
        RowBox[{"ToString", "[", "gridres", "]"}], ",", "\"\<.csv\>\""}], 
       "]"}], ",", "tab"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.84355487838768*^9, 3.843554895410679*^9}, 
   3.843637870955584*^9, {3.8436518489699364`*^9, 3.843651862123931*^9}, {
   3.8437122175066123`*^9, 3.8437122224826703`*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"ae4cb91a-cab6-4378-8906-7e5a9c9a5dc7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p3eq", "=", 
  RowBox[{
   RowBox[{"t", " ", 
    RowBox[{"u", "[", "t", "]"}], "*", 
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"u", "[", "t", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "2"}], "}"}]}], "]"}]}], "\[Equal]", 
   RowBox[{
    RowBox[{"t", " ", 
     SuperscriptBox[
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"u", "[", "t", "]"}], ",", "t"}], "]"}], "2"]}], "-", 
    RowBox[{
     RowBox[{"u", "[", "t", "]"}], " ", 
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"u", "[", "t", "]"}], ",", "t"}], "]"}]}], "+", 
    RowBox[{"\[Delta]", " ", "t"}], "+", 
    RowBox[{"\[Beta]", " ", 
     RowBox[{"u", "[", "t", "]"}]}], "+", 
    RowBox[{"\[Alpha]", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "3"]}], "+", 
    RowBox[{"\[Gamma]", " ", "t", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "4"]}]}]}]}]], "Input",
 CellChangeTimes->{{3.8426997697253585`*^9, 3.842699771668358*^9}, {
   3.8426998221569815`*^9, 3.842699822259981*^9}, {3.84269992103925*^9, 
   3.8426999412142487`*^9}, 3.8426999954773855`*^9, {3.8427004573822727`*^9, 
   3.8427005562612734`*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"dc4eb6dd-3625-4191-9689-58ac1ce443be"],

Cell[BoxData[
 RowBox[{
  RowBox[{"t", " ", 
   RowBox[{"u", "[", "t", "]"}], " ", 
   RowBox[{
    SuperscriptBox["u", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "\[Equal]", 
  RowBox[{
   RowBox[{"t", " ", "\[Delta]"}], "+", 
   RowBox[{"\[Beta]", " ", 
    RowBox[{"u", "[", "t", "]"}]}], "+", 
   RowBox[{"\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"]}], "+", 
   RowBox[{"t", " ", "\[Gamma]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "4"]}], "-", 
   RowBox[{
    RowBox[{"u", "[", "t", "]"}], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}], "+", 
   RowBox[{"t", " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "2"]}]}]}]], "Output",
 CellChangeTimes->{
  3.8426997866186924`*^9, {3.8426999865118313`*^9, 3.8426999974443855`*^9}, 
   3.8427005590182743`*^9, 3.842700601095189*^9, 3.842700651038751*^9, {
   3.8428727580225277`*^9, 3.8428727727773495`*^9}, 3.8429434251284924`*^9, 
   3.8437472597697477`*^9, 3.8439041537475834`*^9, 3.8466606089099016`*^9, 
   3.8527952132852736`*^9, 3.85323184233914*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"f5bd9531-2b52-4064-a10c-67794312579d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p3eq", "//", "TeXForm"}]], "Input",
 CellChangeTimes->{{3.853231836712139*^9, 3.853231846090139*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"5b67b51f-5610-467b-9887-c43a3c30aefc"],

Cell["\<\
t u(t) u''(t)=\\delta  t-u(t) u'(t)+t u'(t)^2+\\alpha  u(t)^3+\\beta  \
u(t)+\\gamma  t u(t)^4\
\>", "Output",
 CellChangeTimes->{{3.8532318401971397`*^9, 3.8532318471121387`*^9}},
 CellLabel->
  "Out[7]//TeXForm=",ExpressionUUID->"2d0eddbe-e80a-43a8-b08b-31461728f103"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p3sln", "=", 
  RowBox[{
   RowBox[{"u", "[", "t", "]"}], "/.", 
   RowBox[{"First", "@", 
    RowBox[{"NDSolve", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"p3eq", ",", 
        RowBox[{
         RowBox[{"u", "[", "1", "]"}], "\[Equal]", "1"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"u", "'"}], "[", "1", "]"}], "\[Equal]", "0"}]}], "}"}], 
      ",", 
      RowBox[{"u", "[", "t", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", 
        RowBox[{"1", "/", "4"}], ",", "2.1"}], "}"}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.8426939161313314`*^9, 3.842694006070348*^9}, {
   3.8426997651303577`*^9, 3.842699781773082*^9}, {3.842699978637831*^9, 
   3.842699982635831*^9}, 3.8427004592692733`*^9, {3.8427006077461886`*^9, 
   3.8427008183178144`*^9}, {3.8427008484961348`*^9, 3.84270090651987*^9}, {
   3.842872763532899*^9, 3.8428727667190256`*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"846fc4e1-aebb-4bdd-98c5-b229f645c49f"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   RowBox[{
    TagBox["InterpolatingFunction",
     "SummaryHead"], "[", 
    DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
     TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
             PaneBox[
              ButtonBox[
               DynamicBox[
                FEPrivate`FrontEndResource[
                "FEBitmaps", "SquarePlusIconMedium"]], 
               ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
               Evaluator -> Automatic, Method -> "Preemptive"], 
              Alignment -> {Center, Center}, ImageSize -> 
              Dynamic[{
                Automatic, 
                 3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                  Magnification])}]], 
             GraphicsBox[{{{{}, {}, 
                 TagBox[{
                   Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                   LineBox[CompressedData["
1:eJwBoQNe/CFib1JlAgAAADkAAAACAAAAjpp6Yvl00z+uXjuai4AgQLYEOLLJ
BdQ/MwlU6t97HEDw8xTf9vnVP3i+rCpNvxRA8NoAT1Tk1z/HN2/eTDcQQPYo
kaNB+Nk/Ao4YrzcRCkAht2Vqr+jbP4Q9F95t+wVAUqzeFa0C3j8+AwAK1skC
QKRMM4JtCeA/6DD/dnJ3AEAyY5myxP/gPx5E6o5/mP0/Q61R1eMK4j+b+Rqk
DMD6P2cXLDFDBOM/dg4UYtmh+D9t/Y2uuvjjPxrCXrCx8PY/9hZCHvoB5T8f
FV19wHD1P5JQGMd5+eU/VUAdt+dK9D+xvUBiwQXnP+mwaCUbRfM/s6bwHiEN
6D/kklUmXHPyP8evwhTBAuk/6pHKlBvT8T9e7Ob8KA3qP/KCizgwRvE/CEkt
HtEF6z9Uu+UZe93wPzXZxTFBE+w//sxd27SF8D9F5eVmyRvtPx6N8nO7RvA/
ZxEo1ZES7j8fnFYOxh7wPwxxvDUiHu8/xjq07lEG8D9ieLln+QvwPx41kuYR
APA/L3ZYxW2G8D//YbQSsQjwP76NIBxGC/E/TKrDeu8h8D9WtXmPPofxP1BB
Xc8JSPA/sPb7+5oN8j9FbQWJ/oDwP/v1QXmDkfI/sAuyTsTI8D9PBRkTjAzz
P/79frIOGvE/ZS4ZpviR8z9VSbJYQ4LxP4RnqlWFDvQ/x64dxCjz8T+VXv8V
noj0P7MXIvAqcfI/Z299zxoN9T+SRUBEEwzzP0KQjKW3iPU/mIB2HdWu8z/f
ysR0uA72P6QUymrDdPQ/hRWOYNmL9j8tMZObmEP1Px0eG12GBvc/AEPM/BMl
9j92QNFSl4v3P7UXSITiNfc/2HIYZcgH+D/mpT6PMlL4P/y+iHBdjvg/aCc4
hBSr+T8RybyMfhL5P3xmYN5nKPs/MOOBxb+N+T/jjl+5Yrj8PxAXcPdkE/o/
BtaH07ui/j/5Wu9FKpD6P6aSQfjAVQBA1FwypXsK+z+mMnf+ZngBQHB4nv0w
j/s/mS5I5+njAkAWpJtyBgv8P9ZdOdnvbgRAfenB4D+R/D+jPmKkLWgGQNXs
q18FFf0/Gt7QfCG9CEA3ACf76o/9P9Jb3IBdYQtAWi3LjzQV/j8YIYzuBvEO
QIdqAEGekf4/C8nXov6XEUB1wV7raxj/P1eSfchFpRRAVNaApsWc/z8wBzxG
9toYQJ79Gb8fDABAdgW4WiWpHkATB2y6ShsAQK5eO5qLgCBAyMO5yQ==
                    "]]}, 
                  Annotation[#, "Charting`Private`Tag$3067#1"]& ]}}, {}}, {
              DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
               AxesOrigin -> {0.25, 1.0000170714077465`}, 
               FrameTicks -> {{{}, {}}, {{}, {}}}, GridLines -> {None, None}, 
               DisplayFunction -> Identity, PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
               All, DisplayFunction -> Identity, AspectRatio -> 1, 
               Axes -> {False, False}, AxesLabel -> {None, None}, 
               AxesOrigin -> {0.25, 1.0000170714077465`}, DisplayFunction :> 
               Identity, Frame -> {{True, True}, {True, True}}, 
               FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
               Directive[
                 Opacity[0.5], 
                 Thickness[Tiny], 
                 RGBColor[0.368417, 0.506779, 0.709798]], 
               FrameTicks -> {{None, None}, {None, None}}, 
               GridLines -> {None, None}, GridLinesStyle -> Directive[
                 GrayLevel[0.5, 0.4]], ImageSize -> 
               Dynamic[{
                 Automatic, 
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                   Magnification])}], 
               Method -> {
                "DefaultBoundaryStyle" -> Automatic, 
                 "DefaultGraphicsInteraction" -> {
                  "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                   "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                 "DefaultMeshStyle" -> AbsolutePointSize[6], 
                 "ScalingFunctions" -> None, 
                 "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
               PlotRange -> {{0.25, 2.1}, {1.0000170714077465`, 
                8.25106508230905}}, PlotRangeClipping -> True, 
               PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
             GridBox[{{
                RowBox[{
                  TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox[
                   RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.25`", ",", "2.1`"}], "}"}], "}"}], 
                   "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"scalar\"", "SummaryItem"]}]}}, 
              GridBoxAlignment -> {
               "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
              False, GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              GridBoxSpacings -> {
               "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
              BaseStyle -> {
               ShowStringCharacters -> False, NumberMarks -> False, 
                PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
           GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
           GridBoxItemSize -> {
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
           BaselinePosition -> {1, 1}], True -> GridBox[{{
             PaneBox[
              ButtonBox[
               DynamicBox[
                FEPrivate`FrontEndResource[
                "FEBitmaps", "SquareMinusIconMedium"]], 
               ButtonFunction :> (Typeset`open$$ = False), Appearance -> None,
                Evaluator -> Automatic, Method -> "Preemptive"], 
              Alignment -> {Center, Center}, ImageSize -> 
              Dynamic[{
                Automatic, 
                 3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                  Magnification])}]], 
             GraphicsBox[{{{{}, {}, 
                 TagBox[{
                   Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                   LineBox[CompressedData["
1:eJwBoQNe/CFib1JlAgAAADkAAAACAAAAjpp6Yvl00z+uXjuai4AgQLYEOLLJ
BdQ/MwlU6t97HEDw8xTf9vnVP3i+rCpNvxRA8NoAT1Tk1z/HN2/eTDcQQPYo
kaNB+Nk/Ao4YrzcRCkAht2Vqr+jbP4Q9F95t+wVAUqzeFa0C3j8+AwAK1skC
QKRMM4JtCeA/6DD/dnJ3AEAyY5myxP/gPx5E6o5/mP0/Q61R1eMK4j+b+Rqk
DMD6P2cXLDFDBOM/dg4UYtmh+D9t/Y2uuvjjPxrCXrCx8PY/9hZCHvoB5T8f
FV19wHD1P5JQGMd5+eU/VUAdt+dK9D+xvUBiwQXnP+mwaCUbRfM/s6bwHiEN
6D/kklUmXHPyP8evwhTBAuk/6pHKlBvT8T9e7Ob8KA3qP/KCizgwRvE/CEkt
HtEF6z9Uu+UZe93wPzXZxTFBE+w//sxd27SF8D9F5eVmyRvtPx6N8nO7RvA/
ZxEo1ZES7j8fnFYOxh7wPwxxvDUiHu8/xjq07lEG8D9ieLln+QvwPx41kuYR
APA/L3ZYxW2G8D//YbQSsQjwP76NIBxGC/E/TKrDeu8h8D9WtXmPPofxP1BB
Xc8JSPA/sPb7+5oN8j9FbQWJ/oDwP/v1QXmDkfI/sAuyTsTI8D9PBRkTjAzz
P/79frIOGvE/ZS4ZpviR8z9VSbJYQ4LxP4RnqlWFDvQ/x64dxCjz8T+VXv8V
noj0P7MXIvAqcfI/Z299zxoN9T+SRUBEEwzzP0KQjKW3iPU/mIB2HdWu8z/f
ysR0uA72P6QUymrDdPQ/hRWOYNmL9j8tMZObmEP1Px0eG12GBvc/AEPM/BMl
9j92QNFSl4v3P7UXSITiNfc/2HIYZcgH+D/mpT6PMlL4P/y+iHBdjvg/aCc4
hBSr+T8RybyMfhL5P3xmYN5nKPs/MOOBxb+N+T/jjl+5Yrj8PxAXcPdkE/o/
BtaH07ui/j/5Wu9FKpD6P6aSQfjAVQBA1FwypXsK+z+mMnf+ZngBQHB4nv0w
j/s/mS5I5+njAkAWpJtyBgv8P9ZdOdnvbgRAfenB4D+R/D+jPmKkLWgGQNXs
q18FFf0/Gt7QfCG9CEA3ACf76o/9P9Jb3IBdYQtAWi3LjzQV/j8YIYzuBvEO
QIdqAEGekf4/C8nXov6XEUB1wV7raxj/P1eSfchFpRRAVNaApsWc/z8wBzxG
9toYQJ79Gb8fDABAdgW4WiWpHkATB2y6ShsAQK5eO5qLgCBAyMO5yQ==
                    "]]}, 
                  Annotation[#, "Charting`Private`Tag$3067#1"]& ]}}, {}}, {
              DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
               AxesOrigin -> {0.25, 1.0000170714077465`}, 
               FrameTicks -> {{{}, {}}, {{}, {}}}, GridLines -> {None, None}, 
               DisplayFunction -> Identity, PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
               All, DisplayFunction -> Identity, AspectRatio -> 1, 
               Axes -> {False, False}, AxesLabel -> {None, None}, 
               AxesOrigin -> {0.25, 1.0000170714077465`}, DisplayFunction :> 
               Identity, Frame -> {{True, True}, {True, True}}, 
               FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
               Directive[
                 Opacity[0.5], 
                 Thickness[Tiny], 
                 RGBColor[0.368417, 0.506779, 0.709798]], 
               FrameTicks -> {{None, None}, {None, None}}, 
               GridLines -> {None, None}, GridLinesStyle -> Directive[
                 GrayLevel[0.5, 0.4]], ImageSize -> 
               Dynamic[{
                 Automatic, 
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                   Magnification])}], 
               Method -> {
                "DefaultBoundaryStyle" -> Automatic, 
                 "DefaultGraphicsInteraction" -> {
                  "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                   "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                 "DefaultMeshStyle" -> AbsolutePointSize[6], 
                 "ScalingFunctions" -> None, 
                 "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
               PlotRange -> {{0.25, 2.1}, {1.0000170714077465`, 
                8.25106508230905}}, PlotRangeClipping -> True, 
               PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
             GridBox[{{
                RowBox[{
                  TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox[
                   RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.25`", ",", "2.1`"}], "}"}], "}"}], 
                   "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"scalar\"", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["3", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["False", "SummaryItem"]}]}}, 
              GridBoxAlignment -> {
               "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
              False, GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              GridBoxSpacings -> {
               "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
              BaseStyle -> {
               ShowStringCharacters -> False, NumberMarks -> False, 
                PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
           GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
           GridBoxItemSize -> {
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
           BaselinePosition -> {1, 1}]}, 
        Dynamic[Typeset`open$$], ImageSize -> Automatic]},
      "SummaryPanel"],
     DynamicModuleValues:>{}], "]"}],
   InterpolatingFunction[{{0.25, 2.1}}, {
    5, 7, 2, {228}, {4}, 0, 0, 0, 0, Automatic, {}, {}, 
     False}, CompressedData["
1:eJwdjXs41IkChn9ZOW2S0gVZhJrIVpRyhP1+ElI25HJyV6sjBw0bWaIWpTop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    "], {Developer`PackedArrayForm, CompressedData["
1:eJwl0QeLyAEAxuH/3dnr7D1u2HvveWdvZ2/Onmdvzjh7nb33nhERERERERER
kRURERHhkbeeL/D+IuMT4kaGBEHwKvi/MFKRlgyEk5Uc5CYfBYmkMMUoSRnK
U4mq1KA29YihEU1pQWva0YHOdKMnfejHQIYwnATGMJ5JTGUGs0hiPotYSjKr
WMsGNrONnexhP4c4ynFOcpqznOcil7nKdW5ym7vc5yGPecpzXvKGd3zgE1/4
xg9+8YdQB6ckDenJRBayk4u8FCCCaIpSgtKUoyJVqE4t6tKAhjShOa1oS3s6
0ZUe9CaeAQxmGP+Cj2YcE5nCdGYyh3ksZAnLWcka1rOJrexgN/s4yBGOcYJT
nOEcF7jEFa5xg1vc4R4PeMQTnvGC17zlPR/5zFe+85PfhIQGQQpSk46MZCYb
OclDfgoRRRGKU4qyVKAy1ahJHeoTS2Oa0ZI2xNGRLnSnF33pzyCGMoJRjGUC
k5lGIrOZywIWs4wVrGYdG9nCdnaxlwMc5i8Fj2xQ
     "], CompressedData["
1:eJxVlnc81e/7x4+ZdTgne2bvLdneV2QVklFZGZmVslUyEiojI6KSjMxQJKFy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     "]}, {Automatic}],
   Editable->False,
   SelectWithContents->True,
   Selectable->False], "[", "t", "]"}]], "Output",
 CellChangeTimes->{{3.8426939444243317`*^9, 3.842694006561348*^9}, 
   3.84269974298481*^9, 3.8426997867766914`*^9, {3.842699986609831*^9, 
   3.8426999975153856`*^9}, {3.8427006024651895`*^9, 
   3.8427006088621883`*^9}, {3.842700652549751*^9, 3.8427007319121237`*^9}, {
   3.8427007625997343`*^9, 3.842700818982815*^9}, {3.842700850033383*^9, 
   3.8427009075318704`*^9}, {3.842872758100527*^9, 3.842872772804067*^9}, 
   3.8429434251834917`*^9, 3.8437472599419065`*^9, 3.8439041537805834`*^9, 
   3.8466606089729023`*^9, {3.8527952135720487`*^9, 3.8527952316482153`*^9}},
 CellLabel->"Out[8]=",ExpressionUUID->"998cb801-7852-4b17-82af-19e97bc61018"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{"p3sln", ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", 
     RowBox[{"1", "/", "4"}], ",", "2.1"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0.8", ",", "5"}], "}"}]}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t\>\"", ",", "\"\<y(t)\>\""}], "}"}]}], ",", 
   RowBox[{"BaseStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"FontSize", "\[Rule]", "24"}], ",", "Bold"}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.8426940287335978`*^9, 3.8426940389565983`*^9}, {
   3.84269972015781*^9, 3.8426997229958105`*^9}, {3.84269978491842*^9, 
   3.8426997855076914`*^9}, 3.8426999845168314`*^9, 3.8427004612212744`*^9, 
   3.8427006838305225`*^9, {3.8427008309031625`*^9, 3.8427008993898706`*^9}, {
   3.842872756270136*^9, 3.842872790077813*^9}, {3.8466606151879025`*^9, 
   3.8466606470339494`*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"fdbe20bb-d3a0-4007-b92e-74e1db287c16"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJw92Xc81e/7B3B7byIZCQkNKYWS65ZRKUJoKJGRPQotTYSMhKKBSgmFyNY2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       "]]},
     Annotation[#, "Charting`Private`Tag$3147#1"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{
    FormBox["\"t\"", TraditionalForm], 
    FormBox["\"y(t)\"", TraditionalForm]},
  AxesOrigin->{0.25000003775510204`, 0.8},
  BaseStyle->{FontSize -> 24, Bold},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->{756., Automatic},
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0.25000003775510204`, 2.099999962244898}, {0.8, 5}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.842694039609598*^9, 3.8426997430848103`*^9, 3.8426997868216915`*^9, {
   3.8426999867588315`*^9, 3.8426999975803857`*^9}, 3.8427006103491898`*^9, {
   3.842700655874775*^9, 3.8427006848705225`*^9}, {3.8427007677216377`*^9, 
   3.8427009102888713`*^9}, {3.8428727582063026`*^9, 3.8428727914729495`*^9}, 
   3.842943425252492*^9, 3.8437472600289874`*^9, 3.8439041538335843`*^9, {
   3.846660609059902*^9, 3.8466606475769486`*^9}, {3.8527952138229218`*^9, 
   3.8527952327091446`*^9}},
 CellLabel->"Out[9]=",ExpressionUUID->"86ae64fe-547a-4688-858e-064cd12b6276"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"chebgrid", "[", 
    RowBox[{"a_", ",", "b_", ",", "n_"}], "]"}], ":=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      FractionBox[
       RowBox[{"a", "+", "b"}], "2"], "+", 
      RowBox[{
       FractionBox[
        RowBox[{"(", 
         RowBox[{"b", "-", "a"}], ")"}], "2"], 
       RowBox[{"Cos", "[", 
        FractionBox[
         RowBox[{"k", " ", "\[Pi]"}], "n"], "]"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "n", ",", "0", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.843903782385523*^9, 3.8439037981115246`*^9}, {
  3.8439038373255873`*^9, 3.843903967284567*^9}, {3.8439040182470093`*^9, 
  3.84390403705024*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"4417dc2c-ad9c-45f0-ae3c-95f065fc9faa"],

Cell[BoxData[
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"gridres", "=", "10"}], ",", 
   RowBox[{"gridres", "<", "110"}], ",", 
   RowBox[{"gridres", "+=", "10"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"grid", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"t", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", 
         RowBox[{"1", "/", "4"}], ",", "2.1", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"2.1", "-", 
            RowBox[{"1", "/", "4"}]}], ")"}], "/", "gridres"}]}], "}"}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"tab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"p3sln", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "grid"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"SetDirectory", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"StringJoin", "[", 
       RowBox[{"\"\<wolfram_sln/\>\"", ",", "\"\<P_III_sln_\>\"", ",", 
        RowBox[{"ToString", "[", "gridres", "]"}], ",", "\"\<.csv\>\""}], 
       "]"}], ",", "tab"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.84355487838768*^9, 3.843554895410679*^9}, 
   3.843637870955584*^9, {3.8436518489699364`*^9, 3.843651862123931*^9}, {
   3.8437122175066123`*^9, 3.8437122446186204`*^9}, {3.8437472392064486`*^9, 
   3.843747291520025*^9}, {3.8439041032805524`*^9, 3.8439041051045523`*^9}, {
   3.852795193170258*^9, 3.852795194714051*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"3cba97bd-6c5c-4826-8982-d14c219c128e"],

Cell[BoxData[
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"gridres", "=", "100"}], ",", 
   RowBox[{"gridres", "<", "1001"}], ",", 
   RowBox[{"gridres", "+=", "100"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"grid", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"t", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", 
         RowBox[{"1", "/", "4"}], ",", "2.1", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"2.1", "-", 
            RowBox[{"1", "/", "4"}]}], ")"}], "/", "gridres"}]}], "}"}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"tab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"p3sln", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "grid"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"SetDirectory", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"StringJoin", "[", 
       RowBox[{"\"\<wolfram_sln/\>\"", ",", "\"\<P_III_sln_\>\"", ",", 
        RowBox[{"ToString", "[", "gridres", "]"}], ",", "\"\<.csv\>\""}], 
       "]"}], ",", "tab"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.84355487838768*^9, 3.843554895410679*^9}, 
   3.843637870955584*^9, {3.8436518489699364`*^9, 3.843651862123931*^9}, {
   3.8437122175066123`*^9, 3.8437122224826703`*^9}, {3.8437472420893974`*^9, 
   3.843747252888752*^9}, 3.843747333103989*^9, 3.843904111576599*^9, {
   3.8527951962272863`*^9, 3.8527952015165973`*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"70a10a76-9c44-4f9e-8a68-a3836ad8c550"],

Cell[BoxData[
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"gridres", "=", "10"}], ",", 
   RowBox[{"gridres", "<", "110"}], ",", 
   RowBox[{"gridres", "+=", "10"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"grid", "=", 
     RowBox[{"chebgrid", "[", 
      RowBox[{
       RowBox[{"1", "/", "4"}], ",", "2.1", ",", "gridres"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"tab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"p3sln", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "grid"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"SetDirectory", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"StringJoin", "[", 
       RowBox[{
       "\"\<wolfram_sln/\>\"", ",", "\"\<P_III_chebgrid_sln_\>\"", ",", 
        RowBox[{"ToString", "[", "gridres", "]"}], ",", "\"\<.csv\>\""}], 
       "]"}], ",", "tab"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.84355487838768*^9, 3.843554895410679*^9}, 
   3.843637870955584*^9, {3.8436518489699364`*^9, 3.843651862123931*^9}, {
   3.8437122175066123`*^9, 3.8437122446186204`*^9}, {3.8437472392064486`*^9, 
   3.843747291520025*^9}, {3.8439040819784884`*^9, 3.843904120167554*^9}},
 CellLabel->"In[31]:=",ExpressionUUID->"ade83f27-c099-49d1-b9c3-f902500cf3a6"],

Cell[BoxData[
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"gridres", "=", "100"}], ",", 
   RowBox[{"gridres", "<", "501"}], ",", 
   RowBox[{"gridres", "+=", "100"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"grid", "=", 
     RowBox[{"chebgrid", "[", 
      RowBox[{
       RowBox[{"1", "/", "4"}], ",", "2.1", ",", "gridres"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"tab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"p3sln", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "grid"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"SetDirectory", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"StringJoin", "[", 
       RowBox[{
       "\"\<wolfram_sln/\>\"", ",", "\"\<P_III_chebgrid_sln_\>\"", ",", 
        RowBox[{"ToString", "[", "gridres", "]"}], ",", "\"\<.csv\>\""}], 
       "]"}], ",", "tab"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.84355487838768*^9, 3.843554895410679*^9}, 
   3.843637870955584*^9, {3.8436518489699364`*^9, 3.843651862123931*^9}, {
   3.8437122175066123`*^9, 3.8437122224826703`*^9}, {3.8437472420893974`*^9, 
   3.843747252888752*^9}, 3.843747333103989*^9, {3.843904099057583*^9, 
   3.843904131153615*^9}},
 CellLabel->"In[32]:=",ExpressionUUID->"27543429-2243-4c1c-a1c9-332d07379347"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p4eq", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"u", "[", "t", "]"}], "*", 
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"u", "[", "t", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "2"}], "}"}]}], "]"}]}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"1", "/", "2"}], "*", 
     SuperscriptBox[
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"u", "[", "t", "]"}], ",", "t"}], "]"}], "2"]}], "+", 
    "\[Beta]", "+", 
    RowBox[{"2", "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"t", "^", "2"}], "-", "\[Alpha]"}], ")"}], 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "2"]}], "+", 
    RowBox[{"4", "t", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "3"]}], "+", 
    RowBox[{
     RowBox[{"3", "/", "2"}], "*", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "4"]}]}]}]}]], "Input",
 CellChangeTimes->{{3.8426997697253585`*^9, 3.842699771668358*^9}, {
   3.8426998221569815`*^9, 3.842699822259981*^9}, {3.84269992103925*^9, 
   3.8426999412142487`*^9}, 3.8426999954773855`*^9, {3.8427004573822727`*^9, 
   3.8427005562612734`*^9}, {3.8428849106537285`*^9, 3.8428850019047613`*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"bc4f0fb1-dde7-41f0-9103-7e9f69a26eb8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"u", "[", "t", "]"}], " ", 
   RowBox[{
    SuperscriptBox["u", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "\[Equal]", 
  RowBox[{"\[Beta]", "+", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["t", "2"], "-", "\[Alpha]"}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"]}], "+", 
   RowBox[{"4", " ", "t", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"]}], "+", 
   FractionBox[
    RowBox[{"3", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "4"]}], "2"], "+", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "2"]}]}]}]], "Output",
 CellChangeTimes->{
  3.8426997866186924`*^9, {3.8426999865118313`*^9, 3.8426999974443855`*^9}, 
   3.8427005590182743`*^9, 3.842700601095189*^9, 3.842700651038751*^9, {
   3.8428727580225277`*^9, 3.8428727727773495`*^9}, {3.8428849847092485`*^9, 
   3.8428850322854195`*^9}, 3.8429434253074913`*^9, 3.8529540107179956`*^9, 
   3.853231859355139*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"0acc402e-f868-4fcd-a1ef-718be6d0c9fd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p4eq", "//", "TeXForm"}]], "Input",
 CellChangeTimes->{{3.853231861866139*^9, 3.8532318644011393`*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"a7507b9d-20a4-479b-8960-a5d0bcc6a969"],

Cell["\<\
u(t) u''(t)=\\beta +2 \\left(t^2-\\alpha \\right) u(t)^2+\\frac{1}{2} \
u'(t)^2+\\frac{3 u(t)^4}{2}+4 t u(t)^3\
\>", "Output",
 CellChangeTimes->{3.853231864740139*^9},
 CellLabel->
  "Out[9]//TeXForm=",ExpressionUUID->"6a8c82c3-6151-4afe-a32d-1473fdd3b90b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p4sln", "=", 
  RowBox[{
   RowBox[{"u", "[", "t", "]"}], "/.", 
   RowBox[{"First", "@", 
    RowBox[{"NDSolve", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"p4eq", ",", 
        RowBox[{
         RowBox[{"u", "[", "1", "]"}], "\[Equal]", "1"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"u", "'"}], "[", "1", "]"}], "\[Equal]", "0"}]}], "}"}], 
      ",", 
      RowBox[{"u", "[", "t", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", 
        RowBox[{"1", "/", "4"}], ",", 
        RowBox[{"7", "/", "4"}]}], "}"}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.8426939161313314`*^9, 3.842694006070348*^9}, {
   3.8426997651303577`*^9, 3.842699781773082*^9}, {3.842699978637831*^9, 
   3.842699982635831*^9}, 3.8427004592692733`*^9, {3.8427006077461886`*^9, 
   3.8427008183178144`*^9}, {3.8427008484961348`*^9, 3.84270090651987*^9}, {
   3.842872763532899*^9, 3.8428727667190256`*^9}, {3.8428850351101875`*^9, 
   3.8428851011648207`*^9}, {3.8428851370643525`*^9, 3.8428852247538605`*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"4caf64ff-f249-417e-b414-0f8fc022b08f"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   RowBox[{
    TagBox["InterpolatingFunction",
     "SummaryHead"], "[", 
    DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
     TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
             PaneBox[
              ButtonBox[
               DynamicBox[
                FEPrivate`FrontEndResource[
                "FEBitmaps", "SquarePlusIconMedium"]], 
               ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
               Evaluator -> Automatic, Method -> "Preemptive"], 
              Alignment -> {Center, Center}, ImageSize -> 
              Dynamic[{
                Automatic, 
                 3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                  Magnification])}]], 
             GraphicsBox[{{{{}, {}, 
                 TagBox[{
                   Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                   LineBox[CompressedData["
1:eJwBkQNu/CFib1JlAgAAADgAAAACAAAA3mtMGwAA0D954kG8DowSQOobiN2h
kNE/lnTxAwd9EECFcoCQ9kLTP4Bqski2YA1AI/0Q+oLY1D/uknaTa50KQPLh
RdgaZtY/hYb2hbtUCEBQbTenZRXYP9Hkmk9EOQZAsSzBLOin2T9E/ednk4gE
QKGSB6MdXNs/WW7bQsHxAkDDUvKNXgjdP02xIBDUlQFA50Z1L9eX3j+b8nWr
gncAQM1w2mCBJOA/q1tZ1GfI/j8oWEYFs+7gP8CBlhfr/vw/nGwEZOq04T99
RvouTWz7P1jUIDv7i+I/rHT2YWbk+T8VVontp1TjP3hGgr76m/g/GitQGC4u
5D+to5bFDlz3Pzctaf25A+U/YIkqbrVC9j9WSc694crlP0zrtoq9VvU/vLiR
9uKi5j+m2fKgG3H0PyRCoQqAbOc/RZB7Moex8z/THg+X9kboP9vx0tTs+PI/
myjP3XId6T+wOpS5b1nyP2RM2/+K5ek/vJXfUfvW8T91w0WafL7qP1LxLgeU
XPE/h1T8DwqJ6z9AK1cHfPvwP7ISBUCdT+w//MAavO6r8D8kJGzoCSftP+/0
G0jHZvA/mE8fbBLw7T/kLxsNKjbwP1POMGj0ye4/PybWQdAS8D8nepQe3J/v
P4zzKTbTAfA//h8i2K8z8D8ZYo+aIQLwP4wsKV3en/A/js/IRqcU8D8bRtbP
2gTxP92VTM7CN/A/NnasH9pn8T9OhenVyGvwP/XPsStG0/E/+GRhz0G58D+0
Nl0lgDfyP1r+BebLFvE/F8c32yak8j/3xshSg5XxP3tkuH6bCfM/C1OQlwwm
8j9rGGL/Em3zPz4P20ggz/I///U6PPfY8z+RJ0skB6nzP5TguWapPfQ/0IOD
I0CZ9D/M9GdNyKr0P5YGj5X7y/U/kR8/EeoV9T+9fPLTAjD3P1ZXvMLZefU/
QSHxQBK2+D+/uGgwNub1P3dOX7apqPo/KSe7i2BL9j/p3+PLAtD8Px+sNsSN
rvY/eA+cVRdP/z+5WuG4Jxr3P+lymWjlRgFAVBYym49+9z82Wd1AAhwDQJL7
sTlk6/c/DKi3/C+MBUBd91q1O1b4Pz5EXqYnjQhAKACqHuG5+D8fXlOxlRkM
QJcyKETzJfk/3Jm/CdSNEEAHckxX04r5P7cgPt8VshNAG9ufJiD4+T8MP7TF
VX4YQH4DcE9AJfo/YrX2U1WAG0C45sBp
                    "]]}, 
                  Annotation[#, "Charting`Private`Tag$3771#1"]& ]}}, {}}, {
              DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
               AxesOrigin -> {0.25, 1.0004455676819104`}, 
               FrameTicks -> {{{}, {}}, {{}, {}}}, GridLines -> {None, None}, 
               DisplayFunction -> Identity, PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
               All, DisplayFunction -> Identity, AspectRatio -> 1, 
               Axes -> {False, False}, AxesLabel -> {None, None}, 
               AxesOrigin -> {0.25, 1.0004455676819104`}, DisplayFunction :> 
               Identity, Frame -> {{True, True}, {True, True}}, 
               FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
               Directive[
                 Opacity[0.5], 
                 Thickness[Tiny], 
                 RGBColor[0.368417, 0.506779, 0.709798]], 
               FrameTicks -> {{None, None}, {None, None}}, 
               GridLines -> {None, None}, GridLinesStyle -> Directive[
                 GrayLevel[0.5, 0.4]], ImageSize -> 
               Dynamic[{
                 Automatic, 
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                   Magnification])}], 
               Method -> {
                "DefaultBoundaryStyle" -> Automatic, 
                 "DefaultGraphicsInteraction" -> {
                  "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                   "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                 "DefaultMeshStyle" -> AbsolutePointSize[6], 
                 "ScalingFunctions" -> None, 
                 "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
               PlotRange -> {{0.25, 1.75}, {1.0004455676819104`, 
                6.8753255004242835`}}, PlotRangeClipping -> True, 
               PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
             GridBox[{{
                RowBox[{
                  TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox[
                   RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.25`", ",", "1.75`"}], "}"}], "}"}], 
                   "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"scalar\"", "SummaryItem"]}]}}, 
              GridBoxAlignment -> {
               "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
              False, GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              GridBoxSpacings -> {
               "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
              BaseStyle -> {
               ShowStringCharacters -> False, NumberMarks -> False, 
                PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
           GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
           GridBoxItemSize -> {
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
           BaselinePosition -> {1, 1}], True -> GridBox[{{
             PaneBox[
              ButtonBox[
               DynamicBox[
                FEPrivate`FrontEndResource[
                "FEBitmaps", "SquareMinusIconMedium"]], 
               ButtonFunction :> (Typeset`open$$ = False), Appearance -> None,
                Evaluator -> Automatic, Method -> "Preemptive"], 
              Alignment -> {Center, Center}, ImageSize -> 
              Dynamic[{
                Automatic, 
                 3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                  Magnification])}]], 
             GraphicsBox[{{{{}, {}, 
                 TagBox[{
                   Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                   LineBox[CompressedData["
1:eJwBkQNu/CFib1JlAgAAADgAAAACAAAA3mtMGwAA0D954kG8DowSQOobiN2h
kNE/lnTxAwd9EECFcoCQ9kLTP4Bqski2YA1AI/0Q+oLY1D/uknaTa50KQPLh
RdgaZtY/hYb2hbtUCEBQbTenZRXYP9Hkmk9EOQZAsSzBLOin2T9E/ednk4gE
QKGSB6MdXNs/WW7bQsHxAkDDUvKNXgjdP02xIBDUlQFA50Z1L9eX3j+b8nWr
gncAQM1w2mCBJOA/q1tZ1GfI/j8oWEYFs+7gP8CBlhfr/vw/nGwEZOq04T99
RvouTWz7P1jUIDv7i+I/rHT2YWbk+T8VVontp1TjP3hGgr76m/g/GitQGC4u
5D+to5bFDlz3Pzctaf25A+U/YIkqbrVC9j9WSc694crlP0zrtoq9VvU/vLiR
9uKi5j+m2fKgG3H0PyRCoQqAbOc/RZB7Moex8z/THg+X9kboP9vx0tTs+PI/
myjP3XId6T+wOpS5b1nyP2RM2/+K5ek/vJXfUfvW8T91w0WafL7qP1LxLgeU
XPE/h1T8DwqJ6z9AK1cHfPvwP7ISBUCdT+w//MAavO6r8D8kJGzoCSftP+/0
G0jHZvA/mE8fbBLw7T/kLxsNKjbwP1POMGj0ye4/PybWQdAS8D8nepQe3J/v
P4zzKTbTAfA//h8i2K8z8D8ZYo+aIQLwP4wsKV3en/A/js/IRqcU8D8bRtbP
2gTxP92VTM7CN/A/NnasH9pn8T9OhenVyGvwP/XPsStG0/E/+GRhz0G58D+0
Nl0lgDfyP1r+BebLFvE/F8c32yak8j/3xshSg5XxP3tkuH6bCfM/C1OQlwwm
8j9rGGL/Em3zPz4P20ggz/I///U6PPfY8z+RJ0skB6nzP5TguWapPfQ/0IOD
I0CZ9D/M9GdNyKr0P5YGj5X7y/U/kR8/EeoV9T+9fPLTAjD3P1ZXvMLZefU/
QSHxQBK2+D+/uGgwNub1P3dOX7apqPo/KSe7i2BL9j/p3+PLAtD8Px+sNsSN
rvY/eA+cVRdP/z+5WuG4Jxr3P+lymWjlRgFAVBYym49+9z82Wd1AAhwDQJL7
sTlk6/c/DKi3/C+MBUBd91q1O1b4Pz5EXqYnjQhAKACqHuG5+D8fXlOxlRkM
QJcyKETzJfk/3Jm/CdSNEEAHckxX04r5P7cgPt8VshNAG9ufJiD4+T8MP7TF
VX4YQH4DcE9AJfo/YrX2U1WAG0C45sBp
                    "]]}, 
                  Annotation[#, "Charting`Private`Tag$3771#1"]& ]}}, {}}, {
              DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
               AxesOrigin -> {0.25, 1.0004455676819104`}, 
               FrameTicks -> {{{}, {}}, {{}, {}}}, GridLines -> {None, None}, 
               DisplayFunction -> Identity, PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
               All, DisplayFunction -> Identity, AspectRatio -> 1, 
               Axes -> {False, False}, AxesLabel -> {None, None}, 
               AxesOrigin -> {0.25, 1.0004455676819104`}, DisplayFunction :> 
               Identity, Frame -> {{True, True}, {True, True}}, 
               FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
               Directive[
                 Opacity[0.5], 
                 Thickness[Tiny], 
                 RGBColor[0.368417, 0.506779, 0.709798]], 
               FrameTicks -> {{None, None}, {None, None}}, 
               GridLines -> {None, None}, GridLinesStyle -> Directive[
                 GrayLevel[0.5, 0.4]], ImageSize -> 
               Dynamic[{
                 Automatic, 
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                   Magnification])}], 
               Method -> {
                "DefaultBoundaryStyle" -> Automatic, 
                 "DefaultGraphicsInteraction" -> {
                  "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                   "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                 "DefaultMeshStyle" -> AbsolutePointSize[6], 
                 "ScalingFunctions" -> None, 
                 "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
               PlotRange -> {{0.25, 1.75}, {1.0004455676819104`, 
                6.8753255004242835`}}, PlotRangeClipping -> True, 
               PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
             GridBox[{{
                RowBox[{
                  TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox[
                   RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.25`", ",", "1.75`"}], "}"}], "}"}], 
                   "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"scalar\"", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["3", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["False", "SummaryItem"]}]}}, 
              GridBoxAlignment -> {
               "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
              False, GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              GridBoxSpacings -> {
               "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
              BaseStyle -> {
               ShowStringCharacters -> False, NumberMarks -> False, 
                PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
           GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
           GridBoxItemSize -> {
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
           BaselinePosition -> {1, 1}]}, 
        Dynamic[Typeset`open$$], ImageSize -> Automatic]},
      "SummaryPanel"],
     DynamicModuleValues:>{}], "]"}],
   InterpolatingFunction[{{0.25, 1.75}}, {
    5, 7, 2, {258}, {4}, 0, 0, 0, 0, Automatic, {}, {}, 
     False}, CompressedData["
1:eJwtVHs41OsWrtDpokSiTuqQioZyElHUK1IqokJyKZE2xUZuJVTINRSSO7l2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    "], {Developer`PackedArrayForm, CompressedData["
1:eJwl02PYFgYYBeC3r6Vlt2wt28t2LVvLNpdt215c3nJbxtKybVv3d/XjPs//
c64nSaN2lduGCAQCIYMj+BKacEQgMtGISRzikZAkJCcVaUlPJrKSg9zk4xcK
U4ySlKE8lahKdWpRlwY0phktaE07OtKF7vSiL/0ZxFBGMJpxTGQK05nFXBaw
mGWsZDXr2MBmtrGdXezlXw5yhOOc5AznuMgVrnOLuzzgMc94yRve84mvBOk2
FGEJTySiEoPYxCUBiUlGStKQjoxkITu5yEsBClGUEpSmHBWpQjVqUof6NKIp
zWlF8OAd6Ew3etKH3xnIEIYzirFMYDLTmMkc5rOIpaxgFWv5k01s5W92sod/
OMBhjvEfp/mfC1zmGje5w30e8ZQXvOYdH/lCiKBA4AfC8CMRiUJ0YvET8UlE
UlKQmp/JQGaykZM85KcgRShOKcpSgcr8Sg1qU4+GNOE3WtKG9nSiKz3oTT8G
MJhhjGQM45nEVGYwm3ksZAnL+YM1rGcjW/iLHexmH/s5xFFOcIqznOcSV7nB
be7xkCc85xVv+cDnoO/PH5LQfAP8m4JJ
     "], CompressedData["
1:eJxV13c819/3AHAje8+87U1INpFe542s7L0zo+wRkhDZSkUokVWZZW/eb5HZ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     "]}, {Automatic}],
   Editable->False,
   SelectWithContents->True,
   Selectable->False], "[", "t", "]"}]], "Output",
 CellChangeTimes->{{3.8426939444243317`*^9, 3.842694006561348*^9}, 
   3.84269974298481*^9, 3.8426997867766914`*^9, {3.842699986609831*^9, 
   3.8426999975153856`*^9}, {3.8427006024651895`*^9, 
   3.8427006088621883`*^9}, {3.842700652549751*^9, 3.8427007319121237`*^9}, {
   3.8427007625997343`*^9, 3.842700818982815*^9}, {3.842700850033383*^9, 
   3.8427009075318704`*^9}, {3.842872758100527*^9, 3.842872772804067*^9}, {
   3.8428850521105127`*^9, 3.8428850700887947`*^9}, 3.842885101626334*^9, {
   3.84288514319666*^9, 3.842885150397394*^9}, {3.8428851813725824`*^9, 
   3.842885225271267*^9}, 3.842943425361492*^9, 3.852954014587205*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"a553b4bc-5844-4f3c-a821-2174c91dfdac"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{"p4sln", ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", 
     RowBox[{"1", "/", "4"}], ",", 
     RowBox[{"7", "/", "4"}]}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "10"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.8426940287335978`*^9, 3.8426940389565983`*^9}, {
   3.84269972015781*^9, 3.8426997229958105`*^9}, {3.84269978491842*^9, 
   3.8426997855076914`*^9}, 3.8426999845168314`*^9, 3.8427004612212744`*^9, 
   3.8427006838305225`*^9, {3.8427008309031625`*^9, 3.8427008993898706`*^9}, {
   3.842872756270136*^9, 3.842872790077813*^9}, {3.842885209531869*^9, 
   3.8428852409378653`*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"e0aa3449-abb6-458b-9f1a-38ea4f6cd778"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwdl3k8VO8Xx+179l1kCRFSWuznSVkKISmhKEpJC232KPENSYuylWwRkS1L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       "]]},
     Annotation[#, "Charting`Private`Tag$3919#1"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0.2500000306122449, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0.2500000306122449, 1.749999969387755}, {0, 10}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.842694039609598*^9, 3.8426997430848103`*^9, 3.8426997868216915`*^9, {
   3.8426999867588315`*^9, 3.8426999975803857`*^9}, 3.8427006103491898`*^9, {
   3.842700655874775*^9, 3.8427006848705225`*^9}, {3.8427007677216377`*^9, 
   3.8427009102888713`*^9}, {3.8428727582063026`*^9, 
   3.8428727914729495`*^9}, {3.842885184836104*^9, 3.842885241411756*^9}, 
   3.8429434254404926`*^9, 3.852954018294163*^9},
 CellLabel->"Out[4]=",ExpressionUUID->"51830756-95ae-435e-b13f-17839e039495"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p4sln", "/.", 
  RowBox[{"t", "\[Rule]", 
   RowBox[{"1", "/", "4"}]}]}]], "Input",
 CellChangeTimes->{{3.842943430948492*^9, 3.8429434309964924`*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"bb3a4a92-156b-4c76-b162-74fe2874262f"],

Cell[BoxData["4.636775557935619`"], "Output",
 CellChangeTimes->{3.8429434313094926`*^9},
 CellLabel->"Out[15]=",ExpressionUUID->"a2a2f12d-9536-49a5-9051-0a94693cdb22"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p4sln", "/.", 
  RowBox[{"t", "->", 
   RowBox[{"7", "/", "4"}]}]}]], "Input",
 CellChangeTimes->{{3.8428906210600166`*^9, 3.842890625490101*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"8d2730fa-b52f-4400-895f-2162a23b856b"],

Cell[BoxData["167.89351947538944`"], "Output",
 CellChangeTimes->{3.842890625884113*^9, 3.842943425575492*^9},
 CellLabel->"Out[14]=",ExpressionUUID->"efd68e15-45f2-4da7-8ce2-de64d272c6a1"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"gridres", "=", "100"}], ",", 
   RowBox[{"gridres", "<", "501"}], ",", 
   RowBox[{"gridres", "+=", "100"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"grid", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"t", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", 
         RowBox[{"1", "/", "4"}], ",", 
         RowBox[{"7", "/", "4"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"7", "/", "4"}], "-", 
            RowBox[{"1", "/", "4"}]}], ")"}], "/", "gridres"}]}], "}"}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"tab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"p4sln", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "grid"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"SetDirectory", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"StringJoin", "[", 
       RowBox[{"\"\<wolfram_sln/\>\"", ",", "\"\<P_IV_sln_\>\"", ",", 
        RowBox[{"ToString", "[", "gridres", "]"}], ",", "\"\<.csv\>\""}], 
       "]"}], ",", "tab"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.8529539822016125`*^9, 3.852953994860265*^9}, {
  3.852954025508279*^9, 3.852954042193038*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"6c4ec927-fe85-42ca-b158-03ec1b17c886"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"grid", "=", 
  RowBox[{"Table", "[", 
   RowBox[{"t", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", 
      RowBox[{"1", "/", "4"}], ",", 
      RowBox[{"7", "/", "4"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"7", "/", "4"}], "-", 
         RowBox[{"1", "/", "4"}]}], ")"}], "/", "301"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.842944147396206*^9, 3.8429441787894173`*^9}, {
  3.84295655634059*^9, 3.8429566060934267`*^9}},
 CellLabel->"In[33]:=",ExpressionUUID->"9515a4d7-8e2e-4e84-b9c2-32a7b6f0b79e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["1", "4"], ",", 
   FractionBox["307", "1204"], ",", 
   FractionBox["313", "1204"], ",", 
   FractionBox["319", "1204"], ",", 
   FractionBox["325", "1204"], ",", 
   FractionBox["331", "1204"], ",", 
   FractionBox["337", "1204"], ",", 
   FractionBox["49", "172"], ",", 
   FractionBox["349", "1204"], ",", 
   FractionBox["355", "1204"], ",", 
   FractionBox["361", "1204"], ",", 
   FractionBox["367", "1204"], ",", 
   FractionBox["373", "1204"], ",", 
   FractionBox["379", "1204"], ",", 
   FractionBox["55", "172"], ",", 
   FractionBox["391", "1204"], ",", 
   FractionBox["397", "1204"], ",", 
   FractionBox["403", "1204"], ",", 
   FractionBox["409", "1204"], ",", 
   FractionBox["415", "1204"], ",", 
   FractionBox["421", "1204"], ",", 
   FractionBox["61", "172"], ",", 
   FractionBox["433", "1204"], ",", 
   FractionBox["439", "1204"], ",", 
   FractionBox["445", "1204"], ",", 
   FractionBox["451", "1204"], ",", 
   FractionBox["457", "1204"], ",", 
   FractionBox["463", "1204"], ",", 
   FractionBox["67", "172"], ",", 
   FractionBox["475", "1204"], ",", 
   FractionBox["481", "1204"], ",", 
   FractionBox["487", "1204"], ",", 
   FractionBox["493", "1204"], ",", 
   FractionBox["499", "1204"], ",", 
   FractionBox["505", "1204"], ",", 
   FractionBox["73", "172"], ",", 
   FractionBox["517", "1204"], ",", 
   FractionBox["523", "1204"], ",", 
   FractionBox["529", "1204"], ",", 
   FractionBox["535", "1204"], ",", 
   FractionBox["541", "1204"], ",", 
   FractionBox["547", "1204"], ",", 
   FractionBox["79", "172"], ",", 
   FractionBox["13", "28"], ",", 
   FractionBox["565", "1204"], ",", 
   FractionBox["571", "1204"], ",", 
   FractionBox["577", "1204"], ",", 
   FractionBox["583", "1204"], ",", 
   FractionBox["589", "1204"], ",", 
   FractionBox["85", "172"], ",", 
   FractionBox["601", "1204"], ",", 
   FractionBox["607", "1204"], ",", 
   FractionBox["613", "1204"], ",", 
   FractionBox["619", "1204"], ",", 
   FractionBox["625", "1204"], ",", 
   FractionBox["631", "1204"], ",", 
   FractionBox["91", "172"], ",", 
   FractionBox["643", "1204"], ",", 
   FractionBox["649", "1204"], ",", 
   FractionBox["655", "1204"], ",", 
   FractionBox["661", "1204"], ",", 
   FractionBox["667", "1204"], ",", 
   FractionBox["673", "1204"], ",", 
   FractionBox["97", "172"], ",", 
   FractionBox["685", "1204"], ",", 
   FractionBox["691", "1204"], ",", 
   FractionBox["697", "1204"], ",", 
   FractionBox["703", "1204"], ",", 
   FractionBox["709", "1204"], ",", 
   FractionBox["715", "1204"], ",", 
   FractionBox["103", "172"], ",", 
   FractionBox["727", "1204"], ",", 
   FractionBox["733", "1204"], ",", 
   FractionBox["739", "1204"], ",", 
   FractionBox["745", "1204"], ",", 
   FractionBox["751", "1204"], ",", 
   FractionBox["757", "1204"], ",", 
   FractionBox["109", "172"], ",", 
   FractionBox["769", "1204"], ",", 
   FractionBox["775", "1204"], ",", 
   FractionBox["781", "1204"], ",", 
   FractionBox["787", "1204"], ",", 
   FractionBox["793", "1204"], ",", 
   FractionBox["799", "1204"], ",", 
   FractionBox["115", "172"], ",", 
   FractionBox["811", "1204"], ",", 
   FractionBox["19", "28"], ",", 
   FractionBox["823", "1204"], ",", 
   FractionBox["829", "1204"], ",", 
   FractionBox["835", "1204"], ",", 
   FractionBox["841", "1204"], ",", 
   FractionBox["121", "172"], ",", 
   FractionBox["853", "1204"], ",", 
   FractionBox["859", "1204"], ",", 
   FractionBox["865", "1204"], ",", 
   FractionBox["871", "1204"], ",", 
   FractionBox["877", "1204"], ",", 
   FractionBox["883", "1204"], ",", 
   FractionBox["127", "172"], ",", 
   FractionBox["895", "1204"], ",", 
   FractionBox["901", "1204"], ",", 
   FractionBox["907", "1204"], ",", 
   FractionBox["913", "1204"], ",", 
   FractionBox["919", "1204"], ",", 
   FractionBox["925", "1204"], ",", 
   FractionBox["133", "172"], ",", 
   FractionBox["937", "1204"], ",", 
   FractionBox["943", "1204"], ",", 
   FractionBox["949", "1204"], ",", 
   FractionBox["955", "1204"], ",", 
   FractionBox["961", "1204"], ",", 
   FractionBox["967", "1204"], ",", 
   FractionBox["139", "172"], ",", 
   FractionBox["979", "1204"], ",", 
   FractionBox["985", "1204"], ",", 
   FractionBox["991", "1204"], ",", 
   FractionBox["997", "1204"], ",", 
   FractionBox["1003", "1204"], ",", 
   FractionBox["1009", "1204"], ",", 
   FractionBox["145", "172"], ",", 
   FractionBox["1021", "1204"], ",", 
   FractionBox["1027", "1204"], ",", 
   FractionBox["1033", "1204"], ",", 
   FractionBox["1039", "1204"], ",", 
   FractionBox["1045", "1204"], ",", 
   FractionBox["1051", "1204"], ",", 
   FractionBox["151", "172"], ",", 
   FractionBox["1063", "1204"], ",", 
   FractionBox["1069", "1204"], ",", 
   FractionBox["25", "28"], ",", 
   FractionBox["1081", "1204"], ",", 
   FractionBox["1087", "1204"], ",", 
   FractionBox["1093", "1204"], ",", 
   FractionBox["157", "172"], ",", 
   FractionBox["1105", "1204"], ",", 
   FractionBox["1111", "1204"], ",", 
   FractionBox["1117", "1204"], ",", 
   FractionBox["1123", "1204"], ",", 
   FractionBox["1129", "1204"], ",", 
   FractionBox["1135", "1204"], ",", 
   FractionBox["163", "172"], ",", 
   FractionBox["1147", "1204"], ",", 
   FractionBox["1153", "1204"], ",", 
   FractionBox["1159", "1204"], ",", 
   FractionBox["1165", "1204"], ",", 
   FractionBox["1171", "1204"], ",", 
   FractionBox["1177", "1204"], ",", 
   FractionBox["169", "172"], ",", 
   FractionBox["1189", "1204"], ",", 
   FractionBox["1195", "1204"], ",", 
   FractionBox["1201", "1204"], ",", 
   FractionBox["1207", "1204"], ",", 
   FractionBox["1213", "1204"], ",", 
   FractionBox["1219", "1204"], ",", 
   FractionBox["175", "172"], ",", 
   FractionBox["1231", "1204"], ",", 
   FractionBox["1237", "1204"], ",", 
   FractionBox["1243", "1204"], ",", 
   FractionBox["1249", "1204"], ",", 
   FractionBox["1255", "1204"], ",", 
   FractionBox["1261", "1204"], ",", 
   FractionBox["181", "172"], ",", 
   FractionBox["1273", "1204"], ",", 
   FractionBox["1279", "1204"], ",", 
   FractionBox["1285", "1204"], ",", 
   FractionBox["1291", "1204"], ",", 
   FractionBox["1297", "1204"], ",", 
   FractionBox["1303", "1204"], ",", 
   FractionBox["187", "172"], ",", 
   FractionBox["1315", "1204"], ",", 
   FractionBox["1321", "1204"], ",", 
   FractionBox["1327", "1204"], ",", 
   FractionBox["31", "28"], ",", 
   FractionBox["1339", "1204"], ",", 
   FractionBox["1345", "1204"], ",", 
   FractionBox["193", "172"], ",", 
   FractionBox["1357", "1204"], ",", 
   FractionBox["1363", "1204"], ",", 
   FractionBox["1369", "1204"], ",", 
   FractionBox["1375", "1204"], ",", 
   FractionBox["1381", "1204"], ",", 
   FractionBox["1387", "1204"], ",", 
   FractionBox["199", "172"], ",", 
   FractionBox["1399", "1204"], ",", 
   FractionBox["1405", "1204"], ",", 
   FractionBox["1411", "1204"], ",", 
   FractionBox["1417", "1204"], ",", 
   FractionBox["1423", "1204"], ",", 
   FractionBox["1429", "1204"], ",", 
   FractionBox["205", "172"], ",", 
   FractionBox["1441", "1204"], ",", 
   FractionBox["1447", "1204"], ",", 
   FractionBox["1453", "1204"], ",", 
   FractionBox["1459", "1204"], ",", 
   FractionBox["1465", "1204"], ",", 
   FractionBox["1471", "1204"], ",", 
   FractionBox["211", "172"], ",", 
   FractionBox["1483", "1204"], ",", 
   FractionBox["1489", "1204"], ",", 
   FractionBox["1495", "1204"], ",", 
   FractionBox["1501", "1204"], ",", 
   FractionBox["1507", "1204"], ",", 
   FractionBox["1513", "1204"], ",", 
   FractionBox["217", "172"], ",", 
   FractionBox["1525", "1204"], ",", 
   FractionBox["1531", "1204"], ",", 
   FractionBox["1537", "1204"], ",", 
   FractionBox["1543", "1204"], ",", 
   FractionBox["1549", "1204"], ",", 
   FractionBox["1555", "1204"], ",", 
   FractionBox["223", "172"], ",", 
   FractionBox["1567", "1204"], ",", 
   FractionBox["1573", "1204"], ",", 
   FractionBox["1579", "1204"], ",", 
   FractionBox["1585", "1204"], ",", 
   FractionBox["37", "28"], ",", 
   FractionBox["1597", "1204"], ",", 
   FractionBox["229", "172"], ",", 
   FractionBox["1609", "1204"], ",", 
   FractionBox["1615", "1204"], ",", 
   FractionBox["1621", "1204"], ",", 
   FractionBox["1627", "1204"], ",", 
   FractionBox["1633", "1204"], ",", 
   FractionBox["1639", "1204"], ",", 
   FractionBox["235", "172"], ",", 
   FractionBox["1651", "1204"], ",", 
   FractionBox["1657", "1204"], ",", 
   FractionBox["1663", "1204"], ",", 
   FractionBox["1669", "1204"], ",", 
   FractionBox["1675", "1204"], ",", 
   FractionBox["1681", "1204"], ",", 
   FractionBox["241", "172"], ",", 
   FractionBox["1693", "1204"], ",", 
   FractionBox["1699", "1204"], ",", 
   FractionBox["1705", "1204"], ",", 
   FractionBox["1711", "1204"], ",", 
   FractionBox["1717", "1204"], ",", 
   FractionBox["1723", "1204"], ",", 
   FractionBox["247", "172"], ",", 
   FractionBox["1735", "1204"], ",", 
   FractionBox["1741", "1204"], ",", 
   FractionBox["1747", "1204"], ",", 
   FractionBox["1753", "1204"], ",", 
   FractionBox["1759", "1204"], ",", 
   FractionBox["1765", "1204"], ",", 
   FractionBox["253", "172"], ",", 
   FractionBox["1777", "1204"], ",", 
   FractionBox["1783", "1204"], ",", 
   FractionBox["1789", "1204"], ",", 
   FractionBox["1795", "1204"], ",", 
   FractionBox["1801", "1204"], ",", 
   FractionBox["1807", "1204"], ",", 
   FractionBox["259", "172"], ",", 
   FractionBox["1819", "1204"], ",", 
   FractionBox["1825", "1204"], ",", 
   FractionBox["1831", "1204"], ",", 
   FractionBox["1837", "1204"], ",", 
   FractionBox["1843", "1204"], ",", 
   FractionBox["43", "28"], ",", 
   FractionBox["265", "172"], ",", 
   FractionBox["1861", "1204"], ",", 
   FractionBox["1867", "1204"], ",", 
   FractionBox["1873", "1204"], ",", 
   FractionBox["1879", "1204"], ",", 
   FractionBox["1885", "1204"], ",", 
   FractionBox["1891", "1204"], ",", 
   FractionBox["271", "172"], ",", 
   FractionBox["1903", "1204"], ",", 
   FractionBox["1909", "1204"], ",", 
   FractionBox["1915", "1204"], ",", 
   FractionBox["1921", "1204"], ",", 
   FractionBox["1927", "1204"], ",", 
   FractionBox["1933", "1204"], ",", 
   FractionBox["277", "172"], ",", 
   FractionBox["1945", "1204"], ",", 
   FractionBox["1951", "1204"], ",", 
   FractionBox["1957", "1204"], ",", 
   FractionBox["1963", "1204"], ",", 
   FractionBox["1969", "1204"], ",", 
   FractionBox["1975", "1204"], ",", 
   FractionBox["283", "172"], ",", 
   FractionBox["1987", "1204"], ",", 
   FractionBox["1993", "1204"], ",", 
   FractionBox["1999", "1204"], ",", 
   FractionBox["2005", "1204"], ",", 
   FractionBox["2011", "1204"], ",", 
   FractionBox["2017", "1204"], ",", 
   FractionBox["289", "172"], ",", 
   FractionBox["2029", "1204"], ",", 
   FractionBox["2035", "1204"], ",", 
   FractionBox["2041", "1204"], ",", 
   FractionBox["2047", "1204"], ",", 
   FractionBox["2053", "1204"], ",", 
   FractionBox["2059", "1204"], ",", 
   FractionBox["295", "172"], ",", 
   FractionBox["2071", "1204"], ",", 
   FractionBox["2077", "1204"], ",", 
   FractionBox["2083", "1204"], ",", 
   FractionBox["2089", "1204"], ",", 
   FractionBox["2095", "1204"], ",", 
   FractionBox["2101", "1204"], ",", 
   FractionBox["7", "4"]}], "}"}]], "Output",
 CellChangeTimes->{{3.8429441493264494`*^9, 3.8429441792244186`*^9}, {
  3.84295656176759*^9, 3.842956608275427*^9}},
 CellLabel->"Out[33]=",ExpressionUUID->"d95a6f3c-e625-46b5-ba32-fa1c9b8448b1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tab", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"p4sln", "/.", 
     RowBox[{"t", "\[Rule]", "t1"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"t1", ",", "grid"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8429442108267965`*^9, 3.8429442180188427`*^9}},
 CellLabel->"In[34]:=",ExpressionUUID->"d1460756-0bb3-40ef-af98-48e075e10d88"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "4.636775557935619`", ",", "4.5224637574181745`", ",", "4.413292861578828`",
    ",", "4.308920979860285`", ",", "4.209036086103672`", ",", 
   "4.11335282148533`", ",", "4.021609708998662`", ",", "3.9335667077054195`",
    ",", "3.8490030654875027`", ",", "3.7677154060014617`", ",", 
   "3.689516081916306`", ",", "3.6142316586256316`", ",", 
   "3.541701604453591`", ",", "3.4717771147350946`", ",", 
   "3.404320061394835`", ",", "3.3392020513595284`", ",", 
   "3.2763035848554845`", ",", "3.2155133007893797`", ",", 
   "3.1567272989178616`", ",", "3.0998485155465687`", ",", 
   "3.044786193689459`", ",", "2.9914553535255304`", ",", 
   "2.939776360764972`", ",", "2.8896745055450546`", ",", 
   "2.841079624111198`", ",", "2.793925769652811`", ",", "2.748150895396664`",
    ",", "2.7036965678048297`", ",", "2.660507715566349`", ",", 
   "2.618532389985934`", ",", "2.577721542323027`", ",", 
   "2.5380288270742364`", ",", "2.499410429810829`", ",", 
   "2.4618248797136535`", ",", "2.425232913376251`", ",", 
   "2.3895973116045397`", ",", "2.354882789909127`", ",", 
   "2.321055854669612`", ",", "2.288084709656383`", ",", "2.255939136700471`",
    ",", "2.2245904086815127`", ",", "2.194011195737559`", ",", 
   "2.1641754807584754`", ",", "2.1350584882740904`", ",", 
   "2.106636603831144`", ",", "2.0788873129437544`", ",", 
   "2.0517891336776932`", ",", "2.0253215727046587`", ",", 
   "1.9994650470506183`", ",", "1.9742008572252818`", ",", 
   "1.9495111214490108`", ",", "1.925378743987799`", ",", 
   "1.901787367044696`", ",", "1.8787213328943533`", ",", 
   "1.8561656515768141`", ",", "1.8341059586495922`", ",", 
   "1.8125284940832032`", ",", "1.7914200597544023`", ",", 
   "1.770768004057237`", ",", "1.7505601828620043`", ",", 
   "1.7307849461404874`", ",", "1.711431105414459`", ",", 
   "1.692487915783111`", ",", "1.673945053329308`", ",", "1.655792597079159`",
    ",", "1.6380210150702421`", ",", "1.6206211326771909`", ",", 
   "1.603584130735439`", ",", "1.5869015245287317`", ",", 
   "1.570565143022141`", ",", "1.554567127451497`", ",", 
   "1.5388999069396474`", ",", "1.523556189698922`", ",", 
   "1.5085289560927775`", ",", "1.4938114375647782`", ",", 
   "1.4793971147544034`", ",", "1.4652797046541701`", ",", 
   "1.451453146875643`", ",", "1.4379116025571974`", ",", 
   "1.4246494389184443`", ",", "1.411661223086617`", ",", 
   "1.3989417181535928`", ",", "1.3864858691976207`", ",", 
   "1.3742888007089016`", ",", "1.3623458091108436`", ",", 
   "1.3506523541679913`", ",", "1.339204058743475`", ",", 
   "1.3279966996550903`", ",", "1.3170261969451529`", ",", 
   "1.3062886168616412`", ",", "1.2957801661554587`", ",", 
   "1.2854971809247624`", ",", "1.2754361269141767`", ",", 
   "1.2655935981022306`", ",", "1.2559663067212083`", ",", 
   "1.246551080477785`", ",", "1.2373448639231241`", ",", 
   "1.2283447106519416`", ",", "1.2195477782262012`", ",", 
   "1.2109513304297896`", ",", "1.2025527321387208`", ",", 
   "1.1943494429878874`", ",", "1.1863390192169376`", ",", 
   "1.1785191114301863`", ",", "1.170887457952728`", ",", 
   "1.1634418849061758`", ",", "1.1561803048363242`", ",", 
   "1.1491007133867739`", ",", "1.1422011864304131`", ",", 
   "1.1354798823211492`", ",", "1.1289350387927293`", ",", 
   "1.1225649670879596`", ",", "1.1163680511144716`", ",", 
   "1.110342751651172`", ",", "1.104487602995651`", ",", 
   "1.0988012077975056`", ",", "1.0932822359920293`", ",", 
   "1.0879294290561987`", ",", "1.0827415974962702`", ",", 
   "1.0777176162715578`", ",", "1.0728564235774287`", ",", 
   "1.068157025163877`", ",", "1.0636184925750223`", ",", 
   "1.0592399590534816`", ",", "1.0550206181670674`", ",", 
   "1.0509597283293284`", ",", "1.0470566117576756`", ",", 
   "1.043310650652641`", ",", "1.0397212865384526`", ",", 
   "1.036288023556032`", ",", "1.033010426648229`", ",", 
   "1.0298881208169068`", ",", "1.0269207925569654`", ",", 
   "1.0241081885014558`", ",", "1.0214501157585456`", ",", 
   "1.018946443107134`", ",", "1.016597099516278`", ",", 
   "1.0144020755619405`", ",", "1.012361424067188`", ",", 
   "1.0104752583693468`", ",", "1.0087437560122707`", ",", 
   "1.007167157991416`", ",", "1.0057457676738584`", ",", 
   "1.0044799524039638`", ",", "1.0033701451596047`", ",", 
   "1.0024168453578812`", ",", "1.0016206189360608`", ",", 
   "1.0009820999440175`", ",", "1.0005019902511014`", ",", 
   "1.0001810627092058`", ",", "1.000020159374862`", ",", 
   "1.0000202028982648`", ",", "1.0001821754454667`", ",", 
   "1.000507148267562`", ",", "1.0009962616710155`", ",", 
   "1.0016507366956997`", ",", "1.0024718762234328`", ",", 
   "1.003461063678076`", ",", "1.004619767271714`", ",", 
   "1.0059495417707098`", ",", "1.0074520310237005`", ",", 
   "1.0091289676520607`", ",", "1.0109821793377574`", ",", 
   "1.0130135905697482`", ",", "1.015225223691261`", ",", 
   "1.017619202330377`", ",", "1.0201977551091614`", ",", 
   "1.0229632185727973`", ",", "1.025918039995524`", ",", 
   "1.0290647821863543`", ",", "1.0324061255007713`", ",", 
   "1.0359448735758205`", ",", "1.0396839556649844`", ",", 
   "1.0436264325572313`", ",", "1.0477755002081555`", ",", 
   "1.0521344934700247`", ",", "1.0567068934180162`", ",", 
   "1.061496331605642`", ",", "1.0665065959244282`", ",", 
   "1.0717416351850595`", ",", "1.0772055663326132`", ",", 
   "1.0829026808978486`", ",", "1.0888374516919987`", ",", 
   "1.0950145396436917`", ",", "1.1014388014424503`", ",", 
   "1.108115298343421`", ",", "1.115049303351978`", ",", "1.12224631042077`", 
   ",", "1.1297120446323945`", ",", "1.1374524705995865`", ",", 
   "1.1454738034470748`", ",", "1.1537825206704644`", ",", 
   "1.1623853718899857`", ",", "1.1712893920232608`", ",", 
   "1.1805019150831821`", ",", "1.190030585614449`", ",", 
   "1.1998833745347717`", ",", "1.210068595207945`", ",", 
   "1.2205949169438812`", ",", "1.2314713841205471`", ",", 
   "1.2427074349375398`", ",", "1.2543129174763674`", ",", 
   "1.2662981128623403`", ",", "1.2786737571806093`", ",", 
   "1.2914510607523033`", ",", "1.3046417362926412`", ",", 
   "1.318258024572549`", ",", "1.3323127177700684`", ",", 
   "1.3468191938333811`", ",", "1.3617914465957512`", ",", 
   "1.3772441143433964`", ",", "1.3931925219167163`", ",", 
   "1.4096527161443944`", ",", "1.4266415011530686`", ",", 
   "1.4441764890704367`", ",", "1.4622761431809335`", ",", 
   "1.4809598265341657`", ",", "1.500247855911097`", ",", 
   "1.5201615544386242`", ",", "1.5407233188995182`", ",", 
   "1.561956679985045`", ",", "1.5838863730336585`", ",", 
   "1.6065384166798855`", ",", "1.6299401865524152`", ",", 
   "1.6541205119484768`", ",", "1.6791097603391443`", ",", 
   "1.7049399446643814`", ",", "1.7316448333371708`", ",", 
   "1.7592600604845445`", ",", "1.7878232683919602`", ",", 
   "1.8173742287683121`", ",", "1.8479550057418836`", ",", 
   "1.87961011765114`", ",", "1.9123867124933904`", ",", 
   "1.9463347570358007`", ",", "1.9815072534021443`", ",", 
   "2.017960465147215`", ",", "2.0557541706034983`", ",", 
   "2.0949519327698365`", ",", "2.1356214051514275`", ",", 
   "2.177834653337519`", ",", "2.2216685256413373`", ",", 
   "2.2672050398429056`", ",", "2.314531833714963`", ",", 
   "2.3637426324439654`", ",", "2.414937794514644`", ",", 
   "2.4682249036250203`", ",", "2.523719415479616`", ",", 
   "2.581545385649339`", ",", "2.641836283745913`", ",", "2.704735898443121`",
    ",", "2.7703993361369204`", ",", "2.838994160479371`", ",", 
   "2.9107016568504434`", ",", "2.9857182477316897`", ",", 
   "3.064257118845005`", ",", "3.146550004999585`", ",", 
   "3.2328492839024636`", ",", "3.3234302789745978`", ",", 
   "3.4185939334590123`", ",", "3.518669846479252`", ",", 
   "3.6240197520684796`", ",", "3.7350415221592232`", ",", 
   "3.852173782302569`", ",", "3.9759012471012944`", ",", 
   "4.106760902039196`", ",", "4.2453492828887285`", ",", 
   "4.392330881071804`", ",", "4.548448119952809`", ",", "4.714533092900277`",
    ",", "4.89152149653398`", ",", "5.080469248773189`", ",", 
   "5.2825723970954215`", ",", "5.499191159327226`", ",", 
   "5.731879028004509`", ",", "5.982418336093936`", ",", "6.252863964750312`",
    ",", "6.545597446226881`", ",", "6.863394527554028`", ",", 
   "7.209510202561855`", ",", "7.587786725881446`", ",", "8.002792234291926`",
    ",", "8.460000592442722`", ",", "8.966027478521376`", ",", 
   "9.528944373265634`", ",", "10.158702202108982`", ",", 
   "10.867711963164167`", ",", "11.671655027140009`", ",", 
   "12.590635955789368`", ",", "13.650860124476601`", ",", 
   "14.887137689858868`", ",", "16.34673080285813`", ",", 
   "18.095467788200494`", ",", "20.227852258322383`", ",", 
   "22.884584334654036`", ",", "26.28471801895725`", ",", 
   "30.78902385205985`", ",", "37.036702922388756`", ",", 
   "46.278202911691956`", ",", "61.335405034868735`", ",", 
   "90.20095168526626`", ",", "167.89351947538944`"}], "}"}]], "Output",
 CellChangeTimes->{{3.8429442041723366`*^9, 3.842944218461993*^9}, {
  3.84295656480659*^9, 3.8429566113264265`*^9}},
 CellLabel->"Out[34]=",ExpressionUUID->"32b3eb9d-8401-42fa-834f-33e44dade32e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";"}]], "Input",
 CellLabel->"In[21]:=",ExpressionUUID->"088fa4e1-2fb5-42fb-9ec4-c24bf2e68e49"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"StringJoin", "[", 
     RowBox[{"\"\<wolfram_sln/\>\"", ",", "\"\<p_IV_sln_\>\"", ",", 
      RowBox[{"ToString", "[", "301", "]"}], ",", "\"\<.csv\>\""}], "]"}], 
    ",", "tab"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.842944142036829*^9, 3.8429441444091735`*^9}, {
  3.8429441890471363`*^9, 3.8429442405416045`*^9}, {3.8429565536215916`*^9, 
  3.8429566015974274`*^9}},
 CellLabel->"In[35]:=",ExpressionUUID->"298ffe78-7899-4f60-9e12-ab2ab30bf8d1"],

Cell[BoxData["\<\"wolfram_sln/p_IV_sln_301.csv\"\>"], "Output",
 CellChangeTimes->{{3.842944245076592*^9, 3.8429442515859165`*^9}, {
  3.8429565675505915`*^9, 3.8429566142144284`*^9}},
 CellLabel->"Out[35]=",ExpressionUUID->"83d8b594-e4c9-426a-ae60-a807834c6d6e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p5eqinit", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"u", "''"}], "[", "t", "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"2", 
         RowBox[{"u", "[", "t", "]"}]}]], "+", 
       FractionBox["1", 
        RowBox[{
         RowBox[{"u", "[", "t", "]"}], "-", "1"}]]}], ")"}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"u", "'"}], "[", "t", "]"}], ")"}], "2"]}], "-", 
    RowBox[{
     FractionBox["1", "t"], "  ", 
     RowBox[{
      RowBox[{"u", "'"}], "[", "t", "]"}]}], "+", 
    RowBox[{
     FractionBox[
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"u", "[", "t", "]"}], "-", "1"}], ")"}], "2"], 
      SuperscriptBox["t", "2"]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"\[Alpha]", " ", 
        RowBox[{"u", "[", "t", "]"}]}], "+", 
       FractionBox["\[Beta]", 
        RowBox[{"u", "[", "t", "]"}]]}], ")"}]}], "+", 
    RowBox[{"\[Gamma]", " ", 
     FractionBox[
      RowBox[{"u", "[", "t", "]"}], "t"]}], "+", 
    RowBox[{"\[Delta]", " ", 
     FractionBox[
      RowBox[{
       RowBox[{"u", "[", "t", "]"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"u", "[", "t", "]"}], "+", "1"}], ")"}]}], 
      RowBox[{
       RowBox[{"u", "[", "t", "]"}], "-", "1"}]]}]}]}]}]], "Input",
 CellChangeTimes->{{3.8426997697253585`*^9, 3.842699771668358*^9}, {
   3.8426998221569815`*^9, 3.842699822259981*^9}, {3.84269992103925*^9, 
   3.8426999412142487`*^9}, 3.8426999954773855`*^9, {3.8427004573822727`*^9, 
   3.8427005562612734`*^9}, {3.8428849106537285`*^9, 
   3.8428850019047613`*^9}, {3.8456096592286105`*^9, 
   3.8456098601566105`*^9}, {3.84561016043217*^9, 3.8456103457502537`*^9}, {
   3.8456103771432543`*^9, 3.845610404592325*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"122920a9-b168-4f2b-8efb-af9ba94521ac"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["u", "\[Prime]\[Prime]",
    MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
  RowBox[{
   FractionBox[
    RowBox[{"\[Gamma]", " ", 
     RowBox[{"u", "[", "t", "]"}]}], "t"], "+", 
   FractionBox[
    RowBox[{"\[Delta]", " ", 
     RowBox[{"u", "[", "t", "]"}], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"u", "[", "t", "]"}]}], ")"}]}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     RowBox[{"u", "[", "t", "]"}]}]], "+", 
   FractionBox[
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"u", "[", "t", "]"}]}], ")"}], "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox["\[Beta]", 
        RowBox[{"u", "[", "t", "]"}]], "+", 
       RowBox[{"\[Alpha]", " ", 
        RowBox[{"u", "[", "t", "]"}]}]}], ")"}]}], 
    SuperscriptBox["t", "2"]], "-", 
   FractionBox[
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "t"], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"u", "[", "t", "]"}]}]], "+", 
      FractionBox["1", 
       RowBox[{"2", " ", 
        RowBox[{"u", "[", "t", "]"}]}]]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "2"]}]}]}]], "Output",
 CellChangeTimes->{3.8456117227695904`*^9, 3.8456247722006097`*^9, 
  3.8529726676704006`*^9, 3.8532318894761395`*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"759e5fa9-4c7d-4114-a0c3-896e099ce8b4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"2", 
           RowBox[{"u", "[", "t", "]"}]}]], "+", 
         FractionBox["1", 
          RowBox[{
           RowBox[{"u", "[", "t", "]"}], "-", "1"}]]}], ")"}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"u", "'"}], "[", "t", "]"}], ")"}], "2"]}], "-", 
      RowBox[{
       FractionBox["1", "t"], "  ", 
       RowBox[{
        RowBox[{"u", "'"}], "[", "t", "]"}]}], "+", 
      RowBox[{
       FractionBox[
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"u", "[", "t", "]"}], "-", "1"}], ")"}], "2"], 
        SuperscriptBox["t", "2"]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[Alpha]", " ", 
          RowBox[{"u", "[", "t", "]"}]}], "+", 
         FractionBox["\[Beta]", 
          RowBox[{"u", "[", "t", "]"}]]}], ")"}]}], "+", 
      RowBox[{"\[Gamma]", " ", 
       FractionBox[
        RowBox[{"u", "[", "t", "]"}], "t"]}], "+", 
      RowBox[{"\[Delta]", " ", 
       FractionBox[
        RowBox[{
         RowBox[{"u", "[", "t", "]"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"u", "[", "t", "]"}], "+", "1"}], ")"}]}], 
        RowBox[{
         RowBox[{"u", "[", "t", "]"}], "-", "1"}]]}]}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{"2", " ", 
      SuperscriptBox["t", "2"], 
      RowBox[{"u", "[", "t", "]"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"u", "[", "t", "]"}], "-", "1"}], ")"}]}], ")"}]}], "//", 
   "Expand"}], "//", "Simplify"}]], "Input",
 CellChangeTimes->{{3.845610518649831*^9, 3.845610552584831*^9}, {
  3.845610617156392*^9, 3.845610659520341*^9}, {3.845610992983054*^9, 
  3.8456110054320498`*^9}},
 CellLabel->
  "In[167]:=",ExpressionUUID->"4e171341-ea6f-463d-ab52-bd66b3af67fa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "2"}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{"4", "+", "t", "+", 
     SuperscriptBox["t", "2"]}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "3"]}], "-", 
  RowBox[{"6", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "4"]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "5"]}], "-", 
  RowBox[{
   SuperscriptBox["t", "2"], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "4"}], "-", "t", "+", 
     SuperscriptBox["t", "2"], "-", 
     RowBox[{"t", " ", 
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"u", "[", "t", "]"}], " ", 
   RowBox[{"(", 
    RowBox[{"6", "+", 
     RowBox[{"2", " ", "t", " ", 
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "+", 
     RowBox[{"3", " ", 
      SuperscriptBox["t", "2"], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.8426997866186924`*^9, {3.8426999865118313`*^9, 3.8426999974443855`*^9}, 
   3.8427005590182743`*^9, 3.842700601095189*^9, 3.842700651038751*^9, {
   3.8428727580225277`*^9, 3.8428727727773495`*^9}, {3.8428849847092485`*^9, 
   3.8428850322854195`*^9}, 3.8429434253074913`*^9, 3.84560990627561*^9, {
   3.845610322352254*^9, 3.845610346462254*^9}, {3.8456103790702534`*^9, 
   3.845610405167325*^9}, {3.8456105090413246`*^9, 3.8456105537908316`*^9}, {
   3.84561059151534*^9, 3.8456106610223727`*^9}, {3.8456109936100473`*^9, 
   3.845611005912055*^9}, 3.8456159141757708`*^9, 3.852972667930401*^9},
 CellLabel->
  "Out[167]=",ExpressionUUID->"d2be6132-12c6-477f-9503-d9303e6b4fa1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rhs", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "2"}], " ", "\[Beta]"}], "+", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", " ", "\[Alpha]"}], "+", "\[Beta]", "+", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{"\[Gamma]", "+", 
         RowBox[{"t", " ", "\[Delta]"}]}], ")"}]}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"]}], "-", 
   RowBox[{"6", " ", "\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "4"]}], "+", 
   RowBox[{"2", " ", "\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "5"]}], "-", 
   RowBox[{
    SuperscriptBox["t", "2"], " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{"\[Alpha]", "+", 
      RowBox[{"3", " ", "\[Beta]"}], "+", 
      RowBox[{"t", " ", "\[Gamma]"}], "-", 
      RowBox[{
       SuperscriptBox["t", "2"], " ", "\[Delta]"}], "+", 
      RowBox[{"t", " ", 
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+", 
   RowBox[{
    RowBox[{"u", "[", "t", "]"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"6", " ", "\[Beta]"}], "+", 
      RowBox[{"2", " ", "t", " ", 
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["t", "2"], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["u", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.8456157605617037`*^9, 3.8456157669757085`*^9}, 
   3.8456159196917715`*^9},
 CellLabel->"In[11]:=",ExpressionUUID->"6e2d2514-7a1f-4aec-8d75-d30d192fa14d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "2"}], " ", "\[Beta]"}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"3", " ", "\[Alpha]"}], "+", "\[Beta]", "+", 
     RowBox[{"t", " ", 
      RowBox[{"(", 
       RowBox[{"\[Gamma]", "+", 
        RowBox[{"t", " ", "\[Delta]"}]}], ")"}]}]}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "3"]}], "-", 
  RowBox[{"6", " ", "\[Alpha]", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "4"]}], "+", 
  RowBox[{"2", " ", "\[Alpha]", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "5"]}], "-", 
  RowBox[{
   SuperscriptBox["t", "2"], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
  RowBox[{"2", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "2"], " ", 
   RowBox[{"(", 
    RowBox[{"\[Alpha]", "+", 
     RowBox[{"3", " ", "\[Beta]"}], "+", 
     RowBox[{"t", " ", "\[Gamma]"}], "-", 
     RowBox[{
      SuperscriptBox["t", "2"], " ", "\[Delta]"}], "+", 
     RowBox[{"t", " ", 
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"u", "[", "t", "]"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"6", " ", "\[Beta]"}], "+", 
     RowBox[{"2", " ", "t", " ", 
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "+", 
     RowBox[{"3", " ", 
      SuperscriptBox["t", "2"], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.8456157693257046`*^9, {3.845615900004771*^9, 3.8456159210757737`*^9}, 
   3.852972668027401*^9, 3.8532318913471394`*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"92869792-570a-4f80-89ac-8489fe7d3fbd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p5eq", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"2", " ", 
       SuperscriptBox["t", "2"], 
       RowBox[{"u", "[", "t", "]"}], "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"u", "[", "t", "]"}], "-", "1"}], ")"}]}], ")"}], "*", 
     RowBox[{
      RowBox[{"u", "''"}], "[", "t", "]"}]}], "-", "rhs"}], "\[Equal]", 
   "0"}]}]], "Input",
 CellChangeTimes->{{3.84561067088834*^9, 3.8456106891163397`*^9}, 
   3.8456114613398123`*^9, {3.845615773446739*^9, 3.845615779910715*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"f2c49cd8-db47-4f54-a464-3650559eab29"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"2", " ", "\[Beta]"}], "-", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", " ", "\[Alpha]"}], "+", "\[Beta]", "+", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{"\[Gamma]", "+", 
         RowBox[{"t", " ", "\[Delta]"}]}], ")"}]}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"]}], "+", 
   RowBox[{"6", " ", "\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "4"]}], "-", 
   RowBox[{"2", " ", "\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "5"]}], "+", 
   RowBox[{
    SuperscriptBox["t", "2"], " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{"\[Alpha]", "+", 
      RowBox[{"3", " ", "\[Beta]"}], "+", 
      RowBox[{"t", " ", "\[Gamma]"}], "-", 
      RowBox[{
       SuperscriptBox["t", "2"], " ", "\[Delta]"}], "+", 
      RowBox[{"t", " ", 
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-", 
   RowBox[{
    RowBox[{"u", "[", "t", "]"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"6", " ", "\[Beta]"}], "+", 
      RowBox[{"2", " ", "t", " ", 
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["t", "2"], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["u", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}]}], ")"}]}], "+", 
   RowBox[{"2", " ", 
    SuperscriptBox["t", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"u", "[", "t", "]"}]}], ")"}], " ", 
    RowBox[{"u", "[", "t", "]"}], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}]}], "\[Equal]", 
  "0"}]], "Output",
 CellChangeTimes->{3.8456157803547044`*^9, 3.8529726681434*^9, 
  3.853231892722139*^9},
 CellLabel->"Out[12]=",ExpressionUUID->"78a83611-cbe0-433e-928e-71d26f089f47"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"2", " ", 
     SuperscriptBox["t", "2"], 
     RowBox[{"u", "[", "t", "]"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"u", "[", "t", "]"}], "-", "1"}], ")"}]}], ")"}], "*", 
   RowBox[{
    RowBox[{"u", "''"}], "[", "t", "]"}]}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.8456156872761574`*^9, 3.8456156906881733`*^9}},
 CellLabel->
  "In[170]:=",ExpressionUUID->"48bcf89e-de7e-4826-9af2-4af5538fafd3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "2"}], " ", 
   SuperscriptBox["t", "2"], " ", 
   RowBox[{"u", "[", "t", "]"}], " ", 
   RowBox[{
    SuperscriptBox["u", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox["t", "2"], " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "2"], " ", 
   RowBox[{
    SuperscriptBox["u", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.8456156910871873`*^9, 3.8529726682574005`*^9},
 CellLabel->
  "Out[170]=",ExpressionUUID->"d1e3dc61-77d2-4f2f-b951-d4f7105d106b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "rhs"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.845615901456771*^9, 3.8456159045177703`*^9}},
 CellLabel->
  "In[171]:=",ExpressionUUID->"fae9d2c1-4759-40f8-8821-cfcaf341d21c"],

Cell[BoxData[
 RowBox[{"2", "-", 
  RowBox[{"6", " ", 
   RowBox[{"u", "[", "t", "]"}]}], "+", 
  RowBox[{"8", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "2"]}], "+", 
  RowBox[{"2", " ", "t", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "2"]}], "-", 
  RowBox[{"2", " ", 
   SuperscriptBox["t", "2"], " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "2"]}], "-", 
  RowBox[{"8", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "3"]}], "-", 
  RowBox[{"2", " ", "t", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "3"]}], "-", 
  RowBox[{"2", " ", 
   SuperscriptBox["t", "2"], " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "3"]}], "+", 
  RowBox[{"6", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "4"]}], "-", 
  RowBox[{"2", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "5"]}], "-", 
  RowBox[{"2", " ", "t", " ", 
   RowBox[{"u", "[", "t", "]"}], " ", 
   RowBox[{
    SuperscriptBox["u", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{"2", " ", "t", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "2"], " ", 
   RowBox[{
    SuperscriptBox["u", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["t", "2"], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
  RowBox[{"3", " ", 
   SuperscriptBox["t", "2"], " ", 
   RowBox[{"u", "[", "t", "]"}], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}]}]], "Output",
 CellChangeTimes->{{3.8456159050497713`*^9, 3.8456159238727713`*^9}, 
   3.8529726683494005`*^9},
 CellLabel->
  "Out[171]=",ExpressionUUID->"b5ed8e51-27d0-4dd9-9215-cb6439a19a7a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "rhs"}], "==", 
   RowBox[{
    RowBox[{"2", " ", "\[Beta]"}], "-", 
    RowBox[{"6", " ", "\[Beta]", " ", 
     RowBox[{"u", "[", "t", "]"}]}], "+", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{"\[Alpha]", "+", 
       RowBox[{"3", " ", "\[Beta]"}], "+", 
       RowBox[{"t", " ", 
        RowBox[{"(", 
         RowBox[{"\[Gamma]", "-", 
          RowBox[{"t", " ", "\[Delta]"}]}], ")"}]}]}], ")"}], " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "2"]}], "-", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", " ", "\[Alpha]"}], "+", "\[Beta]", "+", 
       RowBox[{"t", " ", 
        RowBox[{"(", 
         RowBox[{"\[Gamma]", "+", 
          RowBox[{"t", " ", "\[Delta]"}]}], ")"}]}]}], ")"}], " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "3"]}], "+", 
    RowBox[{"6", " ", "\[Alpha]", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "4"]}], "-", 
    RowBox[{"2", " ", "\[Alpha]", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "5"]}], "-", 
    RowBox[{"2", " ", "t", " ", 
     RowBox[{"u", "[", "t", "]"}], " ", 
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"2", " ", "t", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "2"], " ", 
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["t", "2"], " ", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
    RowBox[{"3", " ", 
     SuperscriptBox["t", "2"], " ", 
     RowBox[{"u", "[", "t", "]"}], " ", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "2"]}]}]}], "//", 
  "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.8456246523280573`*^9, 3.8456246873600845`*^9}},
 CellLabel->
  "In[172]:=",ExpressionUUID->"30b6e305-6aa3-41a4-b6e8-cfcf3ded8d02"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.845624687734084*^9, 3.8529726684484005`*^9},
 CellLabel->
  "Out[172]=",ExpressionUUID->"ffe79fac-d1a6-44ad-934f-963c89b9da07"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rhs2", "=", 
  RowBox[{"-", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "\[Beta]"}], "-", 
     RowBox[{"6", " ", "\[Beta]", " ", 
      RowBox[{"u", "[", "t", "]"}]}], "+", 
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]", "+", 
        RowBox[{"3", " ", "\[Beta]"}], "+", 
        RowBox[{"t", " ", 
         RowBox[{"(", 
          RowBox[{"\[Gamma]", "-", 
           RowBox[{"t", " ", "\[Delta]"}]}], ")"}]}]}], ")"}], " ", 
      SuperscriptBox[
       RowBox[{"u", "[", "t", "]"}], "2"]}], "-", 
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"3", " ", "\[Alpha]"}], "+", "\[Beta]", "+", 
        RowBox[{"t", " ", 
         RowBox[{"(", 
          RowBox[{"\[Gamma]", "+", 
           RowBox[{"t", " ", "\[Delta]"}]}], ")"}]}]}], ")"}], " ", 
      SuperscriptBox[
       RowBox[{"u", "[", "t", "]"}], "3"]}], "+", 
     RowBox[{"6", " ", "\[Alpha]", " ", 
      SuperscriptBox[
       RowBox[{"u", "[", "t", "]"}], "4"]}], "-", 
     RowBox[{"2", " ", "\[Alpha]", " ", 
      SuperscriptBox[
       RowBox[{"u", "[", "t", "]"}], "5"]}], "-", 
     RowBox[{"2", " ", "t", " ", 
      RowBox[{"u", "[", "t", "]"}], " ", 
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "+", 
     RowBox[{"2", " ", "t", " ", 
      SuperscriptBox[
       RowBox[{"u", "[", "t", "]"}], "2"], " ", 
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["t", "2"], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
     RowBox[{"3", " ", 
      SuperscriptBox["t", "2"], " ", 
      RowBox[{"u", "[", "t", "]"}], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}]}], 
    ")"}]}]}]], "Input",
 CellChangeTimes->{{3.845624698415084*^9, 3.845624709527085*^9}},
 CellLabel->
  "In[173]:=",ExpressionUUID->"869f9fa3-d033-43a2-a62c-62c9dc0031a4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "2"}], "+", 
  RowBox[{"6", " ", 
   RowBox[{"u", "[", "t", "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{"4", "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", "t"}], ")"}], " ", "t"}]}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "2"]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{"4", "+", 
     RowBox[{"t", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "t"}], ")"}]}]}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "3"]}], "-", 
  RowBox[{"6", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "4"]}], "+", 
  RowBox[{"2", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "5"]}], "+", 
  RowBox[{"2", " ", "t", " ", 
   RowBox[{"u", "[", "t", "]"}], " ", 
   RowBox[{
    SuperscriptBox["u", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{"2", " ", "t", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "2"], " ", 
   RowBox[{
    SuperscriptBox["u", "\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["t", "2"], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
  RowBox[{"3", " ", 
   SuperscriptBox["t", "2"], " ", 
   RowBox[{"u", "[", "t", "]"}], " ", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}], "2"]}]}]], "Output",
 CellChangeTimes->{3.845624710303084*^9, 3.8529726685444*^9},
 CellLabel->
  "Out[173]=",ExpressionUUID->"f179be09-0ce2-4608-9eb2-3af39955fb00"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p5eq", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"2", " ", 
       SuperscriptBox["t", "2"], 
       RowBox[{"u", "[", "t", "]"}], "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"u", "[", "t", "]"}], "-", "1"}], ")"}]}], ")"}], "*", 
     RowBox[{
      RowBox[{"u", "''"}], "[", "t", "]"}]}], "-", "rhs"}], "\[Equal]", 
   "0"}]}]], "Input",
 CellChangeTimes->{{3.845624721246084*^9, 3.8456247500556107`*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"e91efe22-1e85-43f5-83d9-ff8bb59908c6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"2", " ", "\[Beta]"}], "-", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", " ", "\[Alpha]"}], "+", "\[Beta]", "+", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{"\[Gamma]", "+", 
         RowBox[{"t", " ", "\[Delta]"}]}], ")"}]}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"]}], "+", 
   RowBox[{"6", " ", "\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "4"]}], "-", 
   RowBox[{"2", " ", "\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "5"]}], "+", 
   RowBox[{
    SuperscriptBox["t", "2"], " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{"\[Alpha]", "+", 
      RowBox[{"3", " ", "\[Beta]"}], "+", 
      RowBox[{"t", " ", "\[Gamma]"}], "-", 
      RowBox[{
       SuperscriptBox["t", "2"], " ", "\[Delta]"}], "+", 
      RowBox[{"t", " ", 
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "-", 
   RowBox[{
    RowBox[{"u", "[", "t", "]"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"6", " ", "\[Beta]"}], "+", 
      RowBox[{"2", " ", "t", " ", 
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["t", "2"], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["u", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}]}], ")"}]}], "+", 
   RowBox[{"2", " ", 
    SuperscriptBox["t", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"u", "[", "t", "]"}]}], ")"}], " ", 
    RowBox[{"u", "[", "t", "]"}], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}]}], "\[Equal]", 
  "0"}]], "Output",
 CellChangeTimes->{{3.8456247237930837`*^9, 3.845624750638611*^9}, 
   3.852972668640401*^9, 3.8532318981451387`*^9},
 CellLabel->"Out[13]=",ExpressionUUID->"a9b9b43d-eca4-4e4a-953c-64fe4a687694"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p5eq", "//", "TeXForm"}]], "Input",
 CellChangeTimes->{{3.853231903497139*^9, 3.8532319080821395`*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"2d1e7ad9-d4c2-4f0a-9ca3-97172ef518b8"],

Cell["\<\
2 \\beta +2 t^2 (u(t)-1) u(t) u''(t)+2 u(t)^2 \\left(\\alpha +3 \\beta \
-\\delta  t^2+\\gamma  t+t u'(t)\\right)-u(t) \\left(6 \\beta +3 t^2 \
u'(t)^2+2 t u'(t)\\right)+t^2 u'(t)^2-2 u(t)^3 (3 \\alpha +\\beta +t (\\gamma \
+\\delta  t))-2 \\alpha  u(t)^5+6 \\alpha  u(t)^4=0\
\>", "Output",
 CellChangeTimes->{3.853231908521139*^9},
 CellLabel->
  "Out[14]//TeXForm=",ExpressionUUID->"a819a47b-dfe2-4a93-8bcd-d6ffdf432e33"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"2", " ", "\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"]}], "+", 
   RowBox[{"6", " ", "\[Beta]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"]}], "+", 
   RowBox[{"2", " ", "t", " ", "\[Gamma]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"]}], "-", 
   RowBox[{"2", " ", 
    SuperscriptBox["t", "2"], " ", "\[Delta]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"]}]}], "//", "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.84561603036656*^9, 3.845616032176557*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"00ce7c92-1666-4efc-8054-6125538695e9"],

Cell[BoxData[
 RowBox[{"2", " ", 
  RowBox[{"(", 
   RowBox[{"\[Alpha]", "+", 
    RowBox[{"3", " ", "\[Beta]"}], "+", 
    RowBox[{"t", " ", 
     RowBox[{"(", 
      RowBox[{"\[Gamma]", "-", 
       RowBox[{"t", " ", "\[Delta]"}]}], ")"}]}]}], ")"}], " ", 
  SuperscriptBox[
   RowBox[{"u", "[", "t", "]"}], "2"]}]], "Output",
 CellChangeTimes->{3.845616032603547*^9},
 CellLabel->"Out[6]=",ExpressionUUID->"7b739189-8a3e-46bf-a385-94c26a99c28e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"-", "6"}], " ", "\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"]}], "-", 
   RowBox[{"2", " ", "\[Beta]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"]}], "-", 
   RowBox[{"2", " ", "t", " ", "\[Gamma]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"]}], "-", 
   RowBox[{"2", " ", 
    SuperscriptBox["t", "2"], " ", "\[Delta]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"]}]}], "//", "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.845616232192181*^9, 3.8456162371861753`*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"742fe012-8275-4ef0-a1ac-de99e5d3fd3a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "2"}], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"3", " ", "\[Alpha]"}], "+", "\[Beta]", "+", 
    RowBox[{"t", " ", 
     RowBox[{"(", 
      RowBox[{"\[Gamma]", "+", 
       RowBox[{"t", " ", "\[Delta]"}]}], ")"}]}]}], ")"}], " ", 
  SuperscriptBox[
   RowBox[{"u", "[", "t", "]"}], "3"]}]], "Output",
 CellChangeTimes->{3.845616237850171*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"94dbfd52-d1e7-4fbf-8ad5-b50592da90ac"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p5eq", "/.", 
  RowBox[{"t", "\[Rule]", "1"}]}]], "Input",
 CellChangeTimes->{{3.8456128547349863`*^9, 3.8456128633420205`*^9}},
 CellLabel->"In[30]:=",ExpressionUUID->"7bb586a9-2501-4600-9a0e-ea71491594da"],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     RowBox[{"u", "[", "1", "]"}]}], ")"}], " ", 
   RowBox[{"u", "[", "1", "]"}], " ", 
   RowBox[{
    SuperscriptBox["u", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "1", "]"}]}], "\[Equal]", 
  RowBox[{
   RowBox[{"-", "2"}], "+", 
   RowBox[{"12", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "1", "]"}], "3"]}], "-", 
   RowBox[{"6", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "1", "]"}], "4"]}], "+", 
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "1", "]"}], "5"]}], "+", 
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "1", "]"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "4"}], "-", 
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "1", "]"}]}], ")"}]}], "-", 
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "1", "]"}], "2"], "+", 
   RowBox[{
    RowBox[{"u", "[", "1", "]"}], " ", 
    RowBox[{"(", 
     RowBox[{"6", "+", 
      RowBox[{"2", " ", 
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "1", "]"}]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["u", "\[Prime]",
          MultilineFunction->None], "[", "1", "]"}], "2"]}]}], 
     ")"}]}]}]}]], "Output",
 CellChangeTimes->{{3.8456128606040173`*^9, 3.8456128640779867`*^9}},
 CellLabel->"Out[30]=",ExpressionUUID->"f7712d5a-0a1f-40f2-ad5c-1491c0d96b2f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p5slninit", "=", 
  RowBox[{
   RowBox[{"u", "[", "t", "]"}], "/.", 
   RowBox[{"First", "@", 
    RowBox[{"NDSolve", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"p5eq", ",", 
        RowBox[{
         RowBox[{"u", "[", "0.9", "]"}], "\[Equal]", "2.979325765542575`"}], 
        ",", 
        RowBox[{
         RowBox[{"u", "[", "1.2", "]"}], "\[Equal]", "4.117945909429169`"}]}],
        "}"}], ",", 
      RowBox[{"u", "[", "t", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0.9", ",", "1.2"}], "}"}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.8426939161313314`*^9, 3.842694006070348*^9}, {
   3.8426997651303577`*^9, 3.842699781773082*^9}, {3.842699978637831*^9, 
   3.842699982635831*^9}, 3.8427004592692733`*^9, {3.8427006077461886`*^9, 
   3.8427008183178144`*^9}, {3.8427008484961348`*^9, 3.84270090651987*^9}, {
   3.842872763532899*^9, 3.8428727667190256`*^9}, {3.8428850351101875`*^9, 
   3.8428851011648207`*^9}, {3.8428851370643525`*^9, 
   3.8428852247538605`*^9}, {3.8456099132136106`*^9, 3.84560992271661*^9}, {
   3.845610024583664*^9, 3.845610036580663*^9}, {3.8456105019743233`*^9, 
   3.845610507269325*^9}, {3.8456106934233894`*^9, 3.8456106940484004`*^9}, {
   3.8456123730939584`*^9, 3.845612374408988*^9}, {3.845612710125719*^9, 
   3.8456127172707253`*^9}, {3.8456133973376493`*^9, 
   3.8456134041616507`*^9}, {3.845613473807605*^9, 3.845613506547773*^9}, {
   3.8456135429725857`*^9, 3.845613546098542*^9}, {3.8456136722543287`*^9, 
   3.845613681994297*^9}, {3.8456246273210564`*^9, 3.8456246354790573`*^9}, {
   3.845624776192647*^9, 3.845624776574648*^9}, {3.8456248665766773`*^9, 
   3.845624872863677*^9}, {3.8456287476157618`*^9, 3.845628752918765*^9}, {
   3.8456293143421016`*^9, 3.8456293306851025`*^9}},
 CellLabel->
  "In[175]:=",ExpressionUUID->"0550505e-dc10-4cfd-9535-6aeab4892221"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   RowBox[{
    TagBox["InterpolatingFunction",
     "SummaryHead"], "[", 
    DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
     TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
             PaneBox[
              ButtonBox[
               DynamicBox[
                FEPrivate`FrontEndResource[
                "FEBitmaps", "SquarePlusIconMedium"]], 
               ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
               Evaluator -> Automatic, Method -> "Preemptive"], 
              Alignment -> {Center, Center}, ImageSize -> 
              Dynamic[{
                Automatic, 
                 3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                  Magnification])}]], 
             GraphicsBox[{{{{}, {}, 
                 TagBox[{
                   Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                   LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAAY6SHz8zM7D+bPfm+qNUHQGScjfzc
9Ow/7d2p1qDSB0B0C0DbSyDtPwjQr5a/0AdAt3/O5dlI7T+siO0uS9AHQMzJ
00iccO0/wP6t9QzRB0DvioVdvZvtP7Y5prAz0wdARlETnv3D7T8uj4PzcdYH
QKuOTZCc7+0/JzakO0vbB0Diof7abxruP4qTu7Bk4QdATLqLUWJC7j9Gd4xk
RegHQMVJxXmzbe4/7Q49wwTxB0Bx3trNI5buP7xz+0Bk+gdA70hnesi97j9G
vCJ2tQQIQHsqoNjL6O4/4zvIeCoRCEA7EbVi7hDvP8GGaa35HQhACW92nm88
7z8ErVvaJy0IQKmirjIlZ+8/OQ/noF89CEB828Ly+Y7vP5T3to6tTQhAXYuD
ZC267z95W+H5p2AIQHJAIAKA4u8/370++ZdzCEBLtrSoGAfwPxh2MnV1iQhA
RbeUfIsc8D/ME93PTKAIQNm6YuaNMPA/AEKYgdm2CED0+QapP0bwP6QohPWq
0AhAqTuZAYFa8D/QnjSSE+oIQEfoZoZcbvA/v8zAlTkECUBs0Apk54PwPwjL
1xEAIglAK7uc1wGY8D+LCcw1IT8JQHHhBKTLrfA/beHp7jBgCUCgcqicL8Pw
PzD3Z4svgglAaQY6KyPX8D8y5Wr4SqMJQLnVoRLG7PA/FFO5OcHICUCjp/eP
+ADxP6fmy1847QlAdeSIOcUU8T/jfjp9ZhIKQM9c8DtBKvE/7U8fCWM8CkDC
10XUTD7xP+yJR8QjZQpAPI5xxQdU8T8ijtygFZMKQFBHi0xSaPE/QYIofrC/
CkBNa+D/NnzxP9DLxGIP7QpA0coLDMuR8T/9wnZMKSALQO8sJa7upfE/ntB1
k61RC0CUyhSpwbvxP4VBzPhiiQtAItM/0C7R8T824+gNOMILQEreWI0r5fE/
/PGi+TT5C0D5JEij1/rxPyMyZtcNNwxAQm4lTxMP8j+EC5rk83IMQHMiPifp
IvI/DGzOPcSvDEAsEi1YbjjyP7kv8h0s9AxAfgQKH4NM8j/hjHrYXDYNQFcy
vT5HYvI/feYm2MaADUAZy6uKpXfyP08YtTmjzA1AdWaIbJOL8j98ViCy/hUO
QFg9O6cwofI/PVs7FoNoDkDVFtx3XbXyPwE+cslsuA5A2StToTnL8j+a5MHn
SxIPQMarBfev4PI/Qh8PbgBuD0BNLqbitfTyPztWPHvLxg9AW+wcJ2sK8z/V
XAcZYBUQQAOtgQGwHvM/b5kYK9pFEEBox9UxMzPzP9CsvM7GeBBA1efHBA==

                    "]]}, 
                  Annotation[#, "Charting`Private`Tag$23328#1"]& ]}}, {}}, {
              DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
               AxesOrigin -> {0.9, 2.976705900787314}, 
               FrameTicks -> {{{}, {}}, {{}, {}}}, GridLines -> {None, None}, 
               DisplayFunction -> Identity, PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
               All, DisplayFunction -> Identity, AspectRatio -> 1, 
               Axes -> {False, False}, AxesLabel -> {None, None}, 
               AxesOrigin -> {0.9, 2.976705900787314}, DisplayFunction :> 
               Identity, Frame -> {{True, True}, {True, True}}, 
               FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
               Directive[
                 Opacity[0.5], 
                 Thickness[Tiny], 
                 RGBColor[0.368417, 0.506779, 0.709798]], 
               FrameTicks -> {{None, None}, {None, None}}, 
               GridLines -> {None, None}, GridLinesStyle -> Directive[
                 GrayLevel[0.5, 0.4]], ImageSize -> 
               Dynamic[{
                 Automatic, 
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                   Magnification])}], 
               Method -> {
                "DefaultBoundaryStyle" -> Automatic, 
                 "DefaultGraphicsInteraction" -> {
                  "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                   "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                 "DefaultMeshStyle" -> AbsolutePointSize[6], 
                 "ScalingFunctions" -> None, 
                 "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
               PlotRange -> {{0.9, 1.2}, {2.976705900787314, 
                4.117945890680133}}, PlotRangeClipping -> True, 
               PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
             GridBox[{{
                RowBox[{
                  TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox[
                   RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.9`", ",", "1.2`"}], "}"}], "}"}], 
                   "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"scalar\"", "SummaryItem"]}]}}, 
              GridBoxAlignment -> {
               "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
              False, GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              GridBoxSpacings -> {
               "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
              BaseStyle -> {
               ShowStringCharacters -> False, NumberMarks -> False, 
                PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
           GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
           GridBoxItemSize -> {
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
           BaselinePosition -> {1, 1}], True -> GridBox[{{
             PaneBox[
              ButtonBox[
               DynamicBox[
                FEPrivate`FrontEndResource[
                "FEBitmaps", "SquareMinusIconMedium"]], 
               ButtonFunction :> (Typeset`open$$ = False), Appearance -> None,
                Evaluator -> Automatic, Method -> "Preemptive"], 
              Alignment -> {Center, Center}, ImageSize -> 
              Dynamic[{
                Automatic, 
                 3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                  Magnification])}]], 
             GraphicsBox[{{{{}, {}, 
                 TagBox[{
                   Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                   LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAAY6SHz8zM7D+bPfm+qNUHQGScjfzc
9Ow/7d2p1qDSB0B0C0DbSyDtPwjQr5a/0AdAt3/O5dlI7T+siO0uS9AHQMzJ
00iccO0/wP6t9QzRB0DvioVdvZvtP7Y5prAz0wdARlETnv3D7T8uj4PzcdYH
QKuOTZCc7+0/JzakO0vbB0Diof7abxruP4qTu7Bk4QdATLqLUWJC7j9Gd4xk
RegHQMVJxXmzbe4/7Q49wwTxB0Bx3trNI5buP7xz+0Bk+gdA70hnesi97j9G
vCJ2tQQIQHsqoNjL6O4/4zvIeCoRCEA7EbVi7hDvP8GGaa35HQhACW92nm88
7z8ErVvaJy0IQKmirjIlZ+8/OQ/noF89CEB828Ly+Y7vP5T3to6tTQhAXYuD
ZC267z95W+H5p2AIQHJAIAKA4u8/370++ZdzCEBLtrSoGAfwPxh2MnV1iQhA
RbeUfIsc8D/ME93PTKAIQNm6YuaNMPA/AEKYgdm2CED0+QapP0bwP6QohPWq
0AhAqTuZAYFa8D/QnjSSE+oIQEfoZoZcbvA/v8zAlTkECUBs0Apk54PwPwjL
1xEAIglAK7uc1wGY8D+LCcw1IT8JQHHhBKTLrfA/beHp7jBgCUCgcqicL8Pw
PzD3Z4svgglAaQY6KyPX8D8y5Wr4SqMJQLnVoRLG7PA/FFO5OcHICUCjp/eP
+ADxP6fmy1847QlAdeSIOcUU8T/jfjp9ZhIKQM9c8DtBKvE/7U8fCWM8CkDC
10XUTD7xP+yJR8QjZQpAPI5xxQdU8T8ijtygFZMKQFBHi0xSaPE/QYIofrC/
CkBNa+D/NnzxP9DLxGIP7QpA0coLDMuR8T/9wnZMKSALQO8sJa7upfE/ntB1
k61RC0CUyhSpwbvxP4VBzPhiiQtAItM/0C7R8T824+gNOMILQEreWI0r5fE/
/PGi+TT5C0D5JEij1/rxPyMyZtcNNwxAQm4lTxMP8j+EC5rk83IMQHMiPifp
IvI/DGzOPcSvDEAsEi1YbjjyP7kv8h0s9AxAfgQKH4NM8j/hjHrYXDYNQFcy
vT5HYvI/feYm2MaADUAZy6uKpXfyP08YtTmjzA1AdWaIbJOL8j98ViCy/hUO
QFg9O6cwofI/PVs7FoNoDkDVFtx3XbXyPwE+cslsuA5A2StToTnL8j+a5MHn
SxIPQMarBfev4PI/Qh8PbgBuD0BNLqbitfTyPztWPHvLxg9AW+wcJ2sK8z/V
XAcZYBUQQAOtgQGwHvM/b5kYK9pFEEBox9UxMzPzP9CsvM7GeBBA1efHBA==

                    "]]}, 
                  Annotation[#, "Charting`Private`Tag$23328#1"]& ]}}, {}}, {
              DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
               AxesOrigin -> {0.9, 2.976705900787314}, 
               FrameTicks -> {{{}, {}}, {{}, {}}}, GridLines -> {None, None}, 
               DisplayFunction -> Identity, PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
               All, DisplayFunction -> Identity, AspectRatio -> 1, 
               Axes -> {False, False}, AxesLabel -> {None, None}, 
               AxesOrigin -> {0.9, 2.976705900787314}, DisplayFunction :> 
               Identity, Frame -> {{True, True}, {True, True}}, 
               FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
               Directive[
                 Opacity[0.5], 
                 Thickness[Tiny], 
                 RGBColor[0.368417, 0.506779, 0.709798]], 
               FrameTicks -> {{None, None}, {None, None}}, 
               GridLines -> {None, None}, GridLinesStyle -> Directive[
                 GrayLevel[0.5, 0.4]], ImageSize -> 
               Dynamic[{
                 Automatic, 
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                   Magnification])}], 
               Method -> {
                "DefaultBoundaryStyle" -> Automatic, 
                 "DefaultGraphicsInteraction" -> {
                  "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                   "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                 "DefaultMeshStyle" -> AbsolutePointSize[6], 
                 "ScalingFunctions" -> None, 
                 "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
               PlotRange -> {{0.9, 1.2}, {2.976705900787314, 
                4.117945890680133}}, PlotRangeClipping -> True, 
               PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
             GridBox[{{
                RowBox[{
                  TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox[
                   RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.9`", ",", "1.2`"}], "}"}], "}"}], 
                   "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"scalar\"", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["3", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["False", "SummaryItem"]}]}}, 
              GridBoxAlignment -> {
               "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
              False, GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              GridBoxSpacings -> {
               "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
              BaseStyle -> {
               ShowStringCharacters -> False, NumberMarks -> False, 
                PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
           GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
           GridBoxItemSize -> {
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
           BaselinePosition -> {1, 1}]}, 
        Dynamic[Typeset`open$$], ImageSize -> Automatic]},
      "SummaryPanel"],
     DynamicModuleValues:>{}], "]"}],
   InterpolatingFunction[{{0.9, 1.2}}, {
    5, 7, 2, {44}, {4}, 0, 0, 0, 0, Automatic, {}, {}, False}, CompressedData["
1:eJwBcQGO/iFib1JlAgAAAAEAAAAsAAAAzczMzMzM7D85ELHc3MzsP6ZTlezs
zOw/oFBRnunP7D+bTQ1Q5tLsP5ZKyQHj1ew/fymi4nzf7D9mMHQXZufsP003
RkxP7+w/ND4YgTj37D8bReq1If/sP+hSjh/0Du0/tmAyicYe7T+DbtbymC7t
P1F8elxrPu0/H4oexj1O7T9PTd1A0XrtP38QnLtkp+0/sNNaNvjT7T/glhmx
iwDuPxFa2CsfLe4/QR2XprJZ7j8hFKs1nZvuPwILv8SH3e4/4gHTU3If7z/D
+ObiXGHvP6Pv+nFHo+8/g+YOATLl7z+ybhFIjhPwP2WqBbjuRvA/GOb5J096
8D/LIe6Xr63wP35d4gcQ4fA/MZnWd3AU8T/k1Mrn0EfxP5cQv1cxe/E/Skyz
x5Gu8T+D6t6ysOfxP7yICp7PIPI/9CY2ie5Z8j8txWF0DZPyP2ZjjV8szPI/
TEtgya//8j8zMzMzMzPzP+Leumc=
    "], {Developer`PackedArrayForm, {0, 3, 6, 9, 12, 15, 18, 21, 24, 27, 30, 
     33, 36, 39, 42, 45, 48, 51, 54, 57, 60, 63, 66, 69, 72, 75, 78, 81, 84, 
     87, 90, 93, 96, 99, 102, 105, 108, 111, 114, 117, 120, 123, 126, 129, 
     132}, CompressedData["
1:eJwN0HkwXAccB/B17VvH2kjtEko3mE6iOhIxefvWxvsRlnGWTRylJY5qIyhV
lhIkrom1GcQ20oogRdTViKvCs7LRRhDWTVhXVcKISgUjU31/fP/5/PH9znyP
h8R4hytRKJRMMvlMjKgZR6Cd6pRiHDpJdNvTmEFjGMiK/nCqJn1pjiFdCJok
HOqS3K1In2TfGP6FdOP3CZqVgZMEw74jR430BN9PNoNJf+jpGx/dO0EM1mHa
vz/H4Ncxkykj0i8S1TaRJ0j3S8m4+gQD84a5/JdjCLzbjFUuEY8TkVVCuXcn
Bv282AkW6QudW2GJ5aNEYKNtVnI5BhNV1wcyRhFQLJyLK9aSEynX+51rRBjk
tIhhX46AmdLdW/vCYcLyc7HEXoiBo1XxiVTSe/raOdzBQUKQOPS1cxgGHRJ5
Mp30sQHJ1HZtP9HG3O5u/wyDNRcFKhhBIH71clJmlIz44NESfdwcA6T09qf9
wwiYdBfaZ8Q9Jp7IlJdvUjFQ6T/GjCMdxktF1w2biJrp3vXFZQ5cm86tdSFd
quVablcrJpqtA9iyXg50xbPrBaRzR9JfvZLew49Hv5FaVnIgaWkqOobcTeO0
LN3iPcXbDjx3z3tzoO/+3qAq+cPOonWjhcYofmh6IBjV4kABtb2IMYWAQBrQ
MBQ0i5f+EDwZIUch1+2xtWgOgQG3irPJI4v43w+TV0oqUKhXSepPXEGg6OSO
wb31v/BBlh6PkYrCNa6UPryBAOuUs8iQ8hovcAnTT76EwuyE9w5xgMBKTkvA
JmULl/vzvo9wQaHZ1bGpj06DqKrCWXPKW1y39o1s2QmFsCz22rIJDZpDjXKD
Ke/wLEXGmQR/FJZKsraO2dDAlG5gwFbdx18WpumMXUXB90Z6V5QPDbapWTlv
6e9xi2ZJ63wbCqIUoWI1ngYvQvSKQ9mH+J7fHbMKVQ5QE3oyb0pogALr/n/G
SpB91zfgQjgHysw6+BkjNKBHzKzP3VGB5B95Lb1mGDy49OcVsa46ODi6qWVa
UOG3C+XRcj0u1Lnf/lItWB0chbEUp2kaKAue7j6zs4G8wQYe/5E6zAVtBSuq
NEHs26JytJoH9unLbjIdDeDrhK5k/6QNo/oXS/zcbUFxaDOMJGnA5bWETrri
CKzyX/y8YAQQv/6dV9NrDZhgRM+b5h0FwRnNyMJzdvCtuXJGYgTZ63E61d9H
F073pLda5dmDl1qaoxNFC1oak+oT01ggYe4fojwH+KfVMp/7QAu6wqlfaczp
AxoXw63H+NAX8pHRWigdnP711PtCaAgbPe3j8wXO8CGqZWdppQ38AmQsO9AY
bIfOmk/7uMJJ3owtn8WAsMorgrjnbFhTWk7LLfMA1Y9Tsak9BjwTVXzTFWkC
OrvpMxEML3AoOyXvEx4BMJR6bPDMgIkNd1oYC+B/GxLbPQ==
     "]}, {Automatic}],
   Editable->False,
   SelectWithContents->True,
   Selectable->False], "[", "t", "]"}]], "Output",
 CellChangeTimes->{{3.8426939444243317`*^9, 3.842694006561348*^9}, 
   3.84269974298481*^9, 3.8426997867766914`*^9, {3.842699986609831*^9, 
   3.8426999975153856`*^9}, {3.8427006024651895`*^9, 
   3.8427006088621883`*^9}, {3.842700652549751*^9, 3.8427007319121237`*^9}, {
   3.8427007625997343`*^9, 3.842700818982815*^9}, {3.842700850033383*^9, 
   3.8427009075318704`*^9}, {3.842872758100527*^9, 3.842872772804067*^9}, {
   3.8428850521105127`*^9, 3.8428850700887947`*^9}, 3.842885101626334*^9, {
   3.84288514319666*^9, 3.842885150397394*^9}, {3.8428851813725824`*^9, 
   3.842885225271267*^9}, 3.842943425361492*^9, 3.8456099243736105`*^9, 
   3.8456104278403244`*^9, {3.845610510542324*^9, 3.8456105133878317`*^9}, 
   3.84561069568637*^9, 3.8456123749759283`*^9, 3.845612718154669*^9, 
   3.8456134054046445`*^9, {3.8456134798055735`*^9, 3.8456135073557663`*^9}, 
   3.845613703614783*^9, 3.8456246361140575`*^9, {3.8456247271285906`*^9, 
   3.8456247538116107`*^9}, 3.845624794565648*^9, 3.845624873976677*^9, 
   3.845628760995754*^9, 3.845629332116103*^9, 3.852972671127543*^9},
 CellLabel->
  "Out[175]=",ExpressionUUID->"32941b94-a53b-4233-b077-9bfeb9cfaee1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{"p5slninit", ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0.9", ",", "1.2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.8426940287335978`*^9, 3.8426940389565983`*^9}, {
   3.84269972015781*^9, 3.8426997229958105`*^9}, {3.84269978491842*^9, 
   3.8426997855076914`*^9}, 3.8426999845168314`*^9, 3.8427004612212744`*^9, 
   3.8427006838305225`*^9, {3.8427008309031625`*^9, 3.8427008993898706`*^9}, {
   3.842872756270136*^9, 3.842872790077813*^9}, {3.842885209531869*^9, 
   3.8428852409378653`*^9}, 3.84561341836567*^9, {3.8456134873978157`*^9, 
   3.8456135183475933`*^9}},
 CellLabel->
  "In[176]:=",ExpressionUUID->"68783b02-e947-47ad-bb44-cb98fde88075"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwV1nk41NsbAHC6MoxtSG5ljRa6FIk213siWUPI2ma7llL6ZSkhpSRkq1sq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       "]]},
     Annotation[#, "Charting`Private`Tag$23405#1"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0.9, 2.976700398265032},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->{660., Automatic},
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0.9, 1.2}, {2.976700398265032, 4.117945880179624}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.842694039609598*^9, 3.8426997430848103`*^9, 3.8426997868216915`*^9, {
   3.8426999867588315`*^9, 3.8426999975803857`*^9}, 3.8427006103491898`*^9, {
   3.842700655874775*^9, 3.8427006848705225`*^9}, {3.8427007677216377`*^9, 
   3.8427009102888713`*^9}, {3.8428727582063026`*^9, 
   3.8428727914729495`*^9}, {3.842885184836104*^9, 3.842885241411756*^9}, 
   3.8429434254404926`*^9, 3.8456134201016455`*^9, {3.845613482112604*^9, 
   3.845613519039561*^9}, 3.84561370465582*^9, 3.8456247561476097`*^9, 
   3.845624795721678*^9, 3.845624878717702*^9, 3.845628848950815*^9, 
   3.8456293343561225`*^9, 3.8529726736545973`*^9},
 CellLabel->
  "Out[176]=",ExpressionUUID->"3d22a487-d1bc-4558-9dbd-91389ef30692"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"gridres", "=", "100"}], ",", 
   RowBox[{"gridres", "<", "501"}], ",", 
   RowBox[{"gridres", "+=", "100"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"grid", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"t", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "0.9", ",", "1.2", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1.2", "-", "0.9"}], ")"}], "/", "gridres"}]}], "}"}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"tab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"p5slninit", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "grid"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"SetDirectory", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"StringJoin", "[", 
       RowBox[{"\"\<wolfram_sln/\>\"", ",", "\"\<P_V_sln_\>\"", ",", 
        RowBox[{"ToString", "[", "gridres", "]"}], ",", "\"\<.csv\>\""}], 
       "]"}], ",", "tab"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.84355487838768*^9, 3.843554895410679*^9}, 
   3.843637870955584*^9, {3.8436518489699364`*^9, 3.843651862123931*^9}, {
   3.8437122175066123`*^9, 3.8437122224826703`*^9}, {3.8465634204017496`*^9, 
   3.84656344559275*^9}, {3.8529726987270145`*^9, 3.852972734586028*^9}},
 CellLabel->
  "In[177]:=",ExpressionUUID->"daae875c-fdbd-4eb9-a7bb-63b06cc82039"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p6eqinit", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"u", "''"}], "[", "t", "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{
     FractionBox["1", "2"], 
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"u", "[", "t", "]"}]], "+", 
       FractionBox["1", 
        RowBox[{
         RowBox[{"u", "[", "t", "]"}], "-", "1"}]], "+", 
       FractionBox["1", 
        RowBox[{
         RowBox[{"u", "[", "t", "]"}], "-", "t"}]]}], ")"}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"u", "'"}], "[", "t", "]"}], ")"}], "2"]}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", "t"], "+", 
       FractionBox["1", 
        RowBox[{"t", "-", "1"}]], "+", 
       FractionBox["1", 
        RowBox[{
         RowBox[{"u", "[", "t", "]"}], "-", "t"}]]}], ")"}], "  ", 
     RowBox[{
      RowBox[{"u", "'"}], "[", "t", "]"}]}], "+", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"u", "[", "t", "]"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"u", "[", "t", "]"}], "-", "1"}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"u", "[", "t", "]"}], "-", "t"}], ")"}]}], 
      RowBox[{
       SuperscriptBox["t", "2"], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"t", "-", "1"}], ")"}], "2"]}]], 
     RowBox[{"(", 
      RowBox[{"\[Alpha]", "+", 
       RowBox[{"\[Beta]", " ", 
        FractionBox["t", 
         SuperscriptBox[
          RowBox[{"u", "[", "t", "]"}], "2"]]}], "+", 
       RowBox[{"\[Gamma]", 
        FractionBox[
         RowBox[{"t", "-", "1"}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"u", "[", "t", "]"}], "-", "1"}], ")"}], "2"]]}], "+", 
       RowBox[{"\[Delta]", 
        FractionBox[
         RowBox[{"t", 
          RowBox[{"(", 
           RowBox[{"t", "-", "1"}], ")"}]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"u", "[", "t", "]"}], "-", "t"}], ")"}], "2"]]}]}], 
      ")"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.845723158011434*^9, 3.845723310511427*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"b338f956-17f9-492a-a995-66b4320d0bcb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["u", "\[Prime]\[Prime]",
    MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"u", "[", "t", "]"}]}], ")"}], " ", 
     RowBox[{"u", "[", "t", "]"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "t"}], "+", 
       RowBox[{"u", "[", "t", "]"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"\[Alpha]", "+", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "\[Gamma]"}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"u", "[", "t", "]"}]}], ")"}], "2"]], "+", 
       FractionBox[
        RowBox[{"t", " ", "\[Beta]"}], 
        SuperscriptBox[
         RowBox[{"u", "[", "t", "]"}], "2"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "t", " ", "\[Delta]"}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "t"}], "+", 
           RowBox[{"u", "[", "t", "]"}]}], ")"}], "2"]]}], ")"}]}], 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
     SuperscriptBox["t", "2"]}]], "-", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "t"}]], "+", 
      FractionBox["1", "t"], "+", 
      FractionBox["1", 
       RowBox[{
        RowBox[{"-", "t"}], "+", 
        RowBox[{"u", "[", "t", "]"}]}]]}], ")"}], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}], "+", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"u", "[", "t", "]"}]}]], "+", 
      FractionBox["1", 
       RowBox[{"u", "[", "t", "]"}]], "+", 
      FractionBox["1", 
       RowBox[{
        RowBox[{"-", "t"}], "+", 
        RowBox[{"u", "[", "t", "]"}]}]]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "2"]}]}]}]], "Output",
 CellChangeTimes->{3.8457235625974264`*^9, 3.8532319431981926`*^9},
 CellLabel->"Out[15]=",ExpressionUUID->"528f52b3-595c-4c9a-99a2-d43599a10630"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], 
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"u", "[", "t", "]"}]], "+", 
         FractionBox["1", 
          RowBox[{
           RowBox[{"u", "[", "t", "]"}], "-", "1"}]], "+", 
         FractionBox["1", 
          RowBox[{
           RowBox[{"u", "[", "t", "]"}], "-", "t"}]]}], ")"}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"u", "'"}], "[", "t", "]"}], ")"}], "2"]}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", "t"], "+", 
         FractionBox["1", 
          RowBox[{"t", "-", "1"}]], "+", 
         FractionBox["1", 
          RowBox[{
           RowBox[{"u", "[", "t", "]"}], "-", "t"}]]}], ")"}], "  ", 
       RowBox[{
        RowBox[{"u", "'"}], "[", "t", "]"}]}], "+", 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"u", "[", "t", "]"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"u", "[", "t", "]"}], "-", "1"}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"u", "[", "t", "]"}], "-", "t"}], ")"}]}], 
        RowBox[{
         SuperscriptBox["t", "2"], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"t", "-", "1"}], ")"}], "2"]}]], 
       RowBox[{"(", 
        RowBox[{"\[Alpha]", "+", 
         RowBox[{"\[Beta]", " ", 
          FractionBox["t", 
           SuperscriptBox[
            RowBox[{"u", "[", "t", "]"}], "2"]]}], "+", 
         RowBox[{"\[Gamma]", 
          FractionBox[
           RowBox[{"t", "-", "1"}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"u", "[", "t", "]"}], "-", "1"}], ")"}], "2"]]}], "+", 
         RowBox[{"\[Delta]", 
          FractionBox[
           RowBox[{"t", 
            RowBox[{"(", 
             RowBox[{"t", "-", "1"}], ")"}]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"u", "[", "t", "]"}], "-", "t"}], ")"}], "2"]]}]}], 
        ")"}]}]}], ")"}], "*", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
    SuperscriptBox["t", "2"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"u", "[", "t", "]"}], "-", "t"}], ")"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"u", "[", "t", "]"}], "-", "1"}], ")"}], 
    RowBox[{"u", "[", "t", "]"}]}], "//", "ExpandAll"}], "//", 
  "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.8457235671354237`*^9, 3.8457236326614466`*^9}, {
   3.8457236667374506`*^9, 3.8457236921294546`*^9}, 3.8457237417626405`*^9},
 CellLabel->"In[8]:=",ExpressionUUID->"9e319868-0879-41c6-8b4b-358c9989fc9a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"\[Alpha]", "+", 
     RowBox[{"t", " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "t"}], ")"}], " ", "\[Alpha]"}], "-", "\[Gamma]", 
     "+", 
     RowBox[{"t", " ", 
      RowBox[{"(", 
       RowBox[{"\[Beta]", "+", "\[Gamma]", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "\[Delta]"}]}], 
       ")"}]}]}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "4"]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", "t"}], ")"}], " ", "\[Alpha]", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "5"]}], "+", 
  RowBox[{"\[Alpha]", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "6"]}], "-", 
  RowBox[{"t", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "3"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "+", "t"}], ")"}], " ", "\[Alpha]"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"\[Gamma]", "+", "\[Delta]"}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"2", " ", "t"}]}], ")"}], " ", 
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox["t", "3"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "\[Beta]"}], "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}]}], ")"}]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", "t", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{"\[Beta]", "-", "\[Delta]", "+", 
        RowBox[{"t", " ", 
         RowBox[{"(", 
          RowBox[{"\[Alpha]", "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"4", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "\[Gamma]"}], "+", 
           "\[Delta]"}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", 
        RowBox[{"2", " ", "t", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "3"}], "+", "t", "+", 
           SuperscriptBox["t", "2"]}], ")"}]}], "+", 
        RowBox[{"3", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", "t", " ", 
         RowBox[{
          SuperscriptBox["u", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], ")"}]}], 
  "-", 
  RowBox[{
   SuperscriptBox["t", "2"], " ", 
   RowBox[{"u", "[", "t", "]"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], " ", 
      RowBox[{"(", 
       RowBox[{"t", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           SuperscriptBox["t", "2"]}], ")"}], " ", 
         RowBox[{
          SuperscriptBox["u", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.8457235713554235`*^9, 3.8457236021214437`*^9, 3.8457236339374437`*^9, {
   3.845723668291444*^9, 3.8457236927214437`*^9}, 3.845723742982638*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"01823a2a-f012-40c5-9fd3-ecd48decd8bd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rhs6eq", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"\[Alpha]", "+", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{"4", "+", "t"}], ")"}], " ", "\[Alpha]"}], "-", "\[Gamma]", 
      "+", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{"\[Beta]", "+", "\[Gamma]", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "\[Delta]"}]}], 
        ")"}]}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "4"]}], "-", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "t"}], ")"}], " ", "\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "5"]}], "+", 
   RowBox[{"\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "6"]}], "-", 
   RowBox[{"t", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "+", "t"}], ")"}], " ", "\[Alpha]"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"\[Gamma]", "+", "\[Delta]"}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"2", " ", "t"}]}], ")"}], " ", 
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    SuperscriptBox["t", "3"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "\[Beta]"}], "+", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["u", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["1", "2"], " ", "t", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{"\[Beta]", "-", "\[Delta]", "+", 
         RowBox[{"t", " ", 
          RowBox[{"(", 
           RowBox[{"\[Alpha]", "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"4", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "\[Gamma]"}], "+", 
            "\[Delta]"}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{"2", "+", 
         RowBox[{"2", " ", "t", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "3"}], "+", "t", "+", 
            SuperscriptBox["t", "2"]}], ")"}]}], "+", 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", "t", " ", 
          RowBox[{
           SuperscriptBox["u", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], ")"}]}],
    "-", 
   RowBox[{
    SuperscriptBox["t", "2"], " ", 
    RowBox[{"u", "[", "t", "]"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{"t", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox["t", "2"]}], ")"}], " ", 
          RowBox[{
           SuperscriptBox["u", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.845723712341451*^9, 3.8457237494996376`*^9}, 
   3.845723786897374*^9, {3.84655836809342*^9, 3.8465583697074165`*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"2ccad468-4992-41f7-ad1b-01430b70821f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"\[Alpha]", "+", 
     RowBox[{"t", " ", 
      RowBox[{"(", 
       RowBox[{"4", "+", "t"}], ")"}], " ", "\[Alpha]"}], "-", "\[Gamma]", 
     "+", 
     RowBox[{"t", " ", 
      RowBox[{"(", 
       RowBox[{"\[Beta]", "+", "\[Gamma]", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "\[Delta]"}]}], 
       ")"}]}]}], ")"}], " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "4"]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", "t"}], ")"}], " ", "\[Alpha]", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "5"]}], "+", 
  RowBox[{"\[Alpha]", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "6"]}], "-", 
  RowBox[{"t", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "3"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "+", "t"}], ")"}], " ", "\[Alpha]"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"\[Gamma]", "+", "\[Delta]"}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"2", " ", "t"}]}], ")"}], " ", 
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox["t", "3"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "\[Beta]"}], "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "2"]}]}], ")"}]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", "t", " ", 
   SuperscriptBox[
    RowBox[{"u", "[", "t", "]"}], "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{"\[Beta]", "-", "\[Delta]", "+", 
        RowBox[{"t", " ", 
         RowBox[{"(", 
          RowBox[{"\[Alpha]", "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"4", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "\[Gamma]"}], "+", 
           "\[Delta]"}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", 
        RowBox[{"2", " ", "t", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "3"}], "+", "t", "+", 
           SuperscriptBox["t", "2"]}], ")"}]}], "+", 
        RowBox[{"3", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", "t", " ", 
         RowBox[{
          SuperscriptBox["u", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], ")"}]}], 
  "-", 
  RowBox[{
   SuperscriptBox["t", "2"], " ", 
   RowBox[{"u", "[", "t", "]"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], " ", 
      RowBox[{"(", 
       RowBox[{"t", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           SuperscriptBox["t", "2"]}], ")"}], " ", 
         RowBox[{
          SuperscriptBox["u", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.8457237217616377`*^9, 3.845723788135972*^9, 
  3.8465583704894176`*^9, 3.853231945651194*^9},
 CellLabel->"Out[16]=",ExpressionUUID->"2fac1535-79ca-41c9-9134-f1274f9db83a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
   SuperscriptBox["t", "2"], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"u", "[", "t", "]"}], "-", "t"}], ")"}], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"u", "[", "t", "]"}], "-", "1"}], ")"}], 
   RowBox[{"u", "[", "t", "]"}], "*", 
   RowBox[{
    RowBox[{"u", "''"}], "[", "t", "]"}]}], "\[Equal]", 
  RowBox[{
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{"\[Alpha]", "+", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{"4", "+", "t"}], ")"}], " ", "\[Alpha]"}], "-", "\[Gamma]", 
      "+", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{"\[Beta]", "+", "\[Gamma]", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "\[Delta]"}]}], 
        ")"}]}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "4"]}], "-", 
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "t"}], ")"}], " ", "\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "5"]}], "+", 
   RowBox[{"2", " ", "\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "6"]}], "-", 
   RowBox[{"2", " ", "t", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "+", "t"}], ")"}], " ", "\[Alpha]"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"\[Gamma]", "+", "\[Delta]"}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"2", " ", "t"}]}], ")"}], " ", 
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+", 
   RowBox[{
    SuperscriptBox["t", "3"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "\[Beta]"}], "+", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["u", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}]}], ")"}]}], "+", 
   RowBox[{"t", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{"\[Beta]", "-", "\[Delta]", "+", 
         RowBox[{"t", " ", 
          RowBox[{"(", 
           RowBox[{"\[Alpha]", "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"4", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "\[Gamma]"}], "+", 
            "\[Delta]"}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{"2", "+", 
         RowBox[{"2", " ", "t", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "3"}], "+", "t", "+", 
            SuperscriptBox["t", "2"]}], ")"}]}], "+", 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", "t", " ", 
          RowBox[{
           SuperscriptBox["u", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], ")"}]}],
    "-", 
   RowBox[{"2", " ", 
    SuperscriptBox["t", "2"], " ", 
    RowBox[{"u", "[", "t", "]"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{"t", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox["t", "2"]}], ")"}], " ", 
          RowBox[{
           SuperscriptBox["u", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{
  3.845723656692452*^9, {3.8457237007094436`*^9, 3.8457237603796473`*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"617de578-4954-4ead-b185-60eff2d96daa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
   SuperscriptBox["t", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     RowBox[{"u", "[", "t", "]"}]}], ")"}], " ", 
   RowBox[{"u", "[", "t", "]"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "t"}], "+", 
     RowBox[{"u", "[", "t", "]"}]}], ")"}], " ", 
   RowBox[{
    SuperscriptBox["u", "\[Prime]\[Prime]",
     MultilineFunction->None], "[", "t", "]"}]}], "\[Equal]", 
  RowBox[{
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{"\[Alpha]", "+", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{"4", "+", "t"}], ")"}], " ", "\[Alpha]"}], "-", "\[Gamma]", 
      "+", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{"\[Beta]", "+", "\[Gamma]", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "\[Delta]"}]}], 
        ")"}]}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "4"]}], "-", 
   RowBox[{"4", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "t"}], ")"}], " ", "\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "5"]}], "+", 
   RowBox[{"2", " ", "\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "6"]}], "-", 
   RowBox[{"2", " ", "t", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "+", "t"}], ")"}], " ", "\[Alpha]"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"\[Gamma]", "+", "\[Delta]"}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"2", " ", "t"}]}], ")"}], " ", 
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}], "+", 
   RowBox[{
    SuperscriptBox["t", "3"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "\[Beta]"}], "+", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["u", "\[Prime]",
          MultilineFunction->None], "[", "t", "]"}], "2"]}]}], ")"}]}], "+", 
   RowBox[{"t", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{"\[Beta]", "-", "\[Delta]", "+", 
         RowBox[{"t", " ", 
          RowBox[{"(", 
           RowBox[{"\[Alpha]", "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"4", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "\[Gamma]"}], "+", 
            "\[Delta]"}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{"2", "+", 
         RowBox[{"2", " ", "t", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "3"}], "+", "t", "+", 
            SuperscriptBox["t", "2"]}], ")"}]}], "+", 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", "t", " ", 
          RowBox[{
           SuperscriptBox["u", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], ")"}]}],
    "-", 
   RowBox[{"2", " ", 
    SuperscriptBox["t", "2"], " ", 
    RowBox[{"u", "[", "t", "]"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
       RowBox[{
        SuperscriptBox["u", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{"t", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox["t", "2"]}], ")"}], " ", 
          RowBox[{
           SuperscriptBox["u", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}]}]}], ")"}]}]}], 
     ")"}]}]}]}]], "Output",
 CellChangeTimes->{3.845723761874637*^9, 3.8532319480811944`*^9},
 CellLabel->"Out[17]=",ExpressionUUID->"af5c9109-d9bb-4b4b-8305-b2eaef8b73fd"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"c60", "=", 
   RowBox[{
    RowBox[{"-", 
     SuperscriptBox["t", "3"]}], " ", "\[Beta]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c61", "=", 
   RowBox[{"2", " ", 
    SuperscriptBox["t", "2"], " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "t"}], ")"}], " ", "\[Beta]"}]}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c62", "=", 
   RowBox[{
    RowBox[{"-", "t"}], " ", 
    RowBox[{"(", 
     RowBox[{"\[Beta]", "-", "\[Delta]", "+", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{"\[Alpha]", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"4", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "\[Gamma]"}], "+", 
         "\[Delta]"}], ")"}]}]}], ")"}]}]}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c63", "=", 
   RowBox[{"2", " ", "t", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", "t"}], ")"}], " ", "\[Alpha]"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"\[Gamma]", "+", "\[Delta]"}], ")"}]}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c64", "=", 
   RowBox[{"-", 
    RowBox[{"(", 
     RowBox[{"\[Alpha]", "+", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{"4", "+", "t"}], ")"}], " ", "\[Alpha]"}], "-", "\[Gamma]", 
      "+", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{"\[Beta]", "+", "\[Gamma]", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "\[Delta]"}]}], 
        ")"}]}]}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c65", "=", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "t"}], ")"}], " ", "\[Alpha]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c66", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
    SuperscriptBox["t", "3"]}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c67", "=", 
   RowBox[{
    RowBox[{"-", "t"}], " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "3"}], "+", "t", "+", 
         SuperscriptBox["t", "2"]}], ")"}]}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c68", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "t", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"2", " ", "t"}]}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c69", "=", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["1", "2"]}], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
    SuperscriptBox["t", "3"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c610", "=", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
    SuperscriptBox["t", "2"], " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "t"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c611", "=", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["3", "2"]}], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
    SuperscriptBox["t", "2"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c612", "=", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
    SuperscriptBox["t", "3"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c613", "=", 
   RowBox[{
    RowBox[{"-", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"]}], " ", 
    SuperscriptBox["t", "2"], " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "t"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c614", "=", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
    SuperscriptBox["t", "2"]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.8465592519898434`*^9, 3.846559550743046*^9}, {
  3.8465596909169936`*^9, 3.846559767356224*^9}, {3.846559822244845*^9, 
  3.846559876645814*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"da5d3b3f-5f92-4c6e-95c1-76e2f2e46395"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"c60", "=", 
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox["t", "3"]}], " ", "\[Beta]"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"c61", "=", 
     RowBox[{"2", " ", 
      SuperscriptBox["t", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "t"}], ")"}], " ", "\[Beta]"}]}], " ", ",", 
    "\[IndentingNewLine]", 
    RowBox[{"c62", "=", 
     RowBox[{
      RowBox[{"-", "t"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Beta]", "-", "\[Delta]", "+", 
        RowBox[{"t", " ", 
         RowBox[{"(", 
          RowBox[{"\[Alpha]", "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"4", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "\[Gamma]"}], "+", 
           "\[Delta]"}], ")"}]}]}], ")"}]}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"c63", "=", 
     RowBox[{"2", " ", "t", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "+", "t"}], ")"}], " ", "\[Alpha]"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"\[Gamma]", "+", "\[Delta]"}], ")"}]}]}], ")"}]}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"c64", "=", 
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]", "+", 
        RowBox[{"t", " ", 
         RowBox[{"(", 
          RowBox[{"4", "+", "t"}], ")"}], " ", "\[Alpha]"}], "-", "\[Gamma]", 
        "+", 
        RowBox[{"t", " ", 
         RowBox[{"(", 
          RowBox[{"\[Beta]", "+", "\[Gamma]", "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "\[Delta]"}]}], 
          ")"}]}]}], ")"}]}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"c65", "=", 
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "t"}], ")"}], " ", "\[Alpha]"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"c66", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
      SuperscriptBox["t", "3"]}]}], " ", ",", "\[IndentingNewLine]", 
    RowBox[{"c67", "=", 
     RowBox[{
      RowBox[{"-", "t"}], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"t", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "3"}], "+", "t", "+", 
           SuperscriptBox["t", "2"]}], ")"}]}]}], ")"}]}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"c68", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "t", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"2", " ", "t"}]}], ")"}]}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"c69", "=", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["1", "2"]}], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
      SuperscriptBox["t", "3"]}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"c610", "=", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
      SuperscriptBox["t", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "t"}], ")"}]}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"c611", "=", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["3", "2"]}], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
      SuperscriptBox["t", "2"]}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"c612", "=", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
      SuperscriptBox["t", "3"]}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"c613", "=", 
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"]}], " ", 
      SuperscriptBox["t", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "t"}], ")"}]}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"c614", "=", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
      SuperscriptBox["t", "2"]}]}]}], "}"}], "//", "TeXForm"}]], "Input",
 CellChangeTimes->{{3.8532332032511606`*^9, 3.853233246866669*^9}, {
  3.853233290066668*^9, 3.853233293416669*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"a6793fda-113f-4a41-b329-d6d4a7935e2e"],

Cell["\<\
\\left\\{\\beta  \\left(-t^3\\right),2 \\beta  t^2 (t+1),-t (\\beta -\\delta \
+t (\\alpha +\\delta +\\beta  (t+4)+\\gamma  (t-1))),2 t (\\alpha  \
(t+1)+\\beta  (t+1)+(t-1) (\\gamma +\\delta )),-\\alpha +\\gamma +\\alpha  \
(-t) (t+4)-t (\\beta +\\gamma +\\delta  (t-1)),2 \\alpha 
   (t+1),(t-1) t^3,-t \\left(t \\left(t^2+t-3\\right)+1\\right),(t-1) t (2 \
t-1),-\\frac{1}{2} (t-1)^2 t^3,(t-1)^2 t^2 (t+1),-\\frac{3}{2} (t-1)^2 \
t^2,(t-1)^2 t^3,-(t-1)^2 t^2 (t+1),(t-1)^2 t^2\\right\\}\
\>", "Output",
 CellChangeTimes->{{3.853233238290668*^9, 3.8532332472786694`*^9}, 
   3.8532332939426703`*^9},
 CellLabel->
  "Out[3]//TeXForm=",ExpressionUUID->"50b3e545-ebf3-4e9d-bc0d-bf8c554d9c59"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
     SuperscriptBox["t", "2"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"u", "[", "t", "]"}], "-", "t"}], ")"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"u", "[", "t", "]"}], "-", "1"}], ")"}], 
     RowBox[{"u", "[", "t", "]"}], "*", 
     RowBox[{
      RowBox[{"u", "''"}], "[", "t", "]"}]}], "-", "rhs6eq"}], "\[Equal]", 
   RowBox[{"c60", "+", 
    RowBox[{"c61", " ", 
     RowBox[{"u", "[", "t", "]"}]}], "+", 
    RowBox[{"c62", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "2"]}], "+", 
    RowBox[{"c63", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "3"]}], "+", 
    RowBox[{"c64", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "4"]}], "+", 
    RowBox[{"c65", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "5"]}], "-", 
    RowBox[{"\[Alpha]", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "6"]}], "+", 
    RowBox[{"c66", " ", 
     RowBox[{"u", "[", "t", "]"}], " ", 
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"c67", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "2"], " ", 
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"c68", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "3"], " ", 
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"c69", " ", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
    RowBox[{"c610", " ", 
     RowBox[{"u", "[", "t", "]"}], " ", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
    RowBox[{"c611", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
    RowBox[{"c612", " ", 
     RowBox[{"u", "[", "t", "]"}], " ", 
     RowBox[{
      SuperscriptBox["u", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"c613", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "2"], " ", 
     RowBox[{
      SuperscriptBox["u", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"c614", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "3"], " ", 
     RowBox[{
      SuperscriptBox["u", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}]}]}], "//", 
  "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.846558489194637*^9, 3.8465586322787805`*^9}, {
   3.846558701021073*^9, 3.846558701420024*^9}, {3.846558785092024*^9, 
   3.8465590352440577`*^9}, {3.8465590972920284`*^9, 3.846559156286298*^9}, 
   3.846559231465845*^9, {3.846559270142033*^9, 3.8465595426052294`*^9}, {
   3.846559717367992*^9, 3.8465598131138735`*^9}, {3.8465598925818152`*^9, 
   3.846559892747813*^9}},
 CellLabel->
  "In[249]:=",ExpressionUUID->"ad3cc4a7-43ab-4e4c-adac-9c53eea24e4a"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.8465591264410534`*^9, 3.8465591568352976`*^9}, 
   3.8465592339398446`*^9, {3.846559675066992*^9, 3.8465597197390223`*^9}, {
   3.846559785946816*^9, 3.846559813441815*^9}, {3.8465598800608444`*^9, 
   3.846559906386841*^9}},
 CellLabel->
  "Out[249]=",ExpressionUUID->"4f18b4e5-5f09-4280-8498-9d8d7841df98"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p6eq", "=", 
  RowBox[{
   RowBox[{"c60", "+", 
    RowBox[{"c61", " ", 
     RowBox[{"u", "[", "t", "]"}]}], "+", 
    RowBox[{"c62", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "2"]}], "+", 
    RowBox[{"c63", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "3"]}], "+", 
    RowBox[{"c64", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "4"]}], "+", 
    RowBox[{"c65", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "5"]}], "-", 
    RowBox[{"\[Alpha]", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "6"]}], "+", 
    RowBox[{"c66", " ", 
     RowBox[{"u", "[", "t", "]"}], " ", 
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"c67", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "2"], " ", 
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"c68", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "3"], " ", 
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"c69", " ", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
    RowBox[{"c610", " ", 
     RowBox[{"u", "[", "t", "]"}], " ", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
    RowBox[{"c611", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["u", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
    RowBox[{"c612", " ", 
     RowBox[{"u", "[", "t", "]"}], " ", 
     RowBox[{
      SuperscriptBox["u", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"c613", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "2"], " ", 
     RowBox[{
      SuperscriptBox["u", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}], "+", 
    RowBox[{"c614", " ", 
     SuperscriptBox[
      RowBox[{"u", "[", "t", "]"}], "3"], " ", 
     RowBox[{
      SuperscriptBox["u", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "t", "]"}]}]}], "\[Equal]", 
   "0"}]}]], "Input",
 CellChangeTimes->{{3.8465599471018467`*^9, 3.846559951460814*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"5a96df8c-461a-49b5-8acf-a005ac0c0048"],

Cell[BoxData[
 RowBox[{
  RowBox[{"c60", "+", 
   RowBox[{"c61", " ", 
    RowBox[{"u", "[", "t", "]"}]}], "+", 
   RowBox[{"c62", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"]}], "+", 
   RowBox[{"c63", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"]}], "+", 
   RowBox[{"c64", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "4"]}], "+", 
   RowBox[{"c65", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "5"]}], "-", 
   RowBox[{"\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "6"]}], "+", 
   RowBox[{"c66", " ", 
    RowBox[{"u", "[", "t", "]"}], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}], "+", 
   RowBox[{"c67", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}], "+", 
   RowBox[{"c68", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}], "+", 
   RowBox[{"c69", " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
   RowBox[{"c610", " ", 
    RowBox[{"u", "[", "t", "]"}], " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
   RowBox[{"c611", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"], " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
   RowBox[{"c612", " ", 
    RowBox[{"u", "[", "t", "]"}], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}], "+", 
   RowBox[{"c613", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}], "+", 
   RowBox[{"c614", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}]}], "\[Equal]", 
  "0"}]], "Output",
 CellChangeTimes->{3.8465599519308147`*^9, 3.8532319526901927`*^9, 
  3.853232683732055*^9},
 CellLabel->"Out[1]=",ExpressionUUID->"dd5ae8f0-3d1c-4c2e-bf11-d539a3dd3eae"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p6eq", "//", "TeXForm"}]], "Input",
 CellChangeTimes->{{3.853232697298581*^9, 3.853232713369581*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"09316a46-4952-4462-8567-66d819ea38ea"],

Cell["\<\
\\text{c60}+\\text{c61} u(t)+\\text{c610} u(t) u'(t)^2+\\text{c611} u(t)^2 \
u'(t)^2+\\text{c612} u(t) u''(t)+\\text{c613} u(t)^2 u''(t)+\\text{c614} \
u(t)^3 u''(t)+\\text{c62} u(t)^2+\\text{c63} u(t)^3+\\text{c64} \
u(t)^4+\\text{c65} u(t)^5+\\text{c66} u(t)
   u'(t)+\\text{c67} u(t)^2 u'(t)+\\text{c68} u(t)^3 u'(t)+\\text{c69} \
u'(t)^2-\\alpha  u(t)^6=0\
\>", "Output",
 CellChangeTimes->{{3.853232705979581*^9, 3.8532327139585814`*^9}},
 CellLabel->
  "Out[3]//TeXForm=",ExpressionUUID->"f8a6edff-8879-4146-a053-4670da909f35"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p6eq", "//", "TeXForm"}]], "Input",
 CellChangeTimes->{{3.853231955513212*^9, 3.853231957913212*^9}},
 CellLabel->"In[34]:=",ExpressionUUID->"07ca84d2-b24e-4b29-8edd-0dc3a9ad9735"],

Cell["\<\
-\\beta  t^3+(t-1)^2 t^3 u(t) u''(t)+(t-1) t^3 u(t) u'(t)-\\frac{1}{2} \
(t-1)^2 t^3 u'(t)^2+(t-1)^2 t^2 u(t)^3 u''(t)-(t-1)^2 t^2 (t+1) u(t)^2 \
u''(t)-\\frac{3}{2} (t-1)^2 t^2 u(t)^2 u'(t)^2-t \\left(t \
\\left(t^2+t-3\\right)+1\\right) u(t)^2 u'(t)+(t-1)^2 t^2
   (t+1) u(t) u'(t)^2+2 \\beta  t^2 (t+1) u(t)+(t-1) t (2 t-1) u(t)^3 \
u'(t)+u(t)^4 (-\\alpha +\\gamma +\\alpha  (-t) (t+4)-t (\\beta +\\gamma \
+\\delta  (t-1)))+2 t u(t)^3 (\\alpha  (t+1)+\\beta  (t+1)+(t-1) (\\gamma \
+\\delta ))-t u(t)^2 (\\beta -\\delta +t (\\alpha
   +\\delta +\\beta  (t+4)+\\gamma  (t-1)))-\\alpha  u(t)^6+2 \\alpha  (t+1) \
u(t)^5=0\
\>", "Output",
 CellChangeTimes->{3.8532319583632135`*^9},
 CellLabel->
  "Out[34]//TeXForm=",ExpressionUUID->"f084a9a5-5aa8-48f4-9cd5-c8fda76c8f37"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["p6eq"], "Input",
 CellLabel->
  "In[253]:=",ExpressionUUID->"916cf753-4cd3-4118-863d-0283196372e9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     SuperscriptBox["t", "3"]}], " ", "\[Beta]"}], "+", 
   RowBox[{"2", " ", 
    SuperscriptBox["t", "2"], " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "t"}], ")"}], " ", "\[Beta]", " ", 
    RowBox[{"u", "[", "t", "]"}]}], "-", 
   RowBox[{"t", " ", 
    RowBox[{"(", 
     RowBox[{"\[Beta]", "-", "\[Delta]", "+", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{"\[Alpha]", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"4", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "\[Gamma]"}], "+", 
         "\[Delta]"}], ")"}]}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"]}], "+", 
   RowBox[{"2", " ", "t", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", "t"}], ")"}], " ", "\[Alpha]"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", "t"}], ")"}], " ", "\[Beta]"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"\[Gamma]", "+", "\[Delta]"}], ")"}]}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "\[Alpha]"}], "-", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{"4", "+", "t"}], ")"}], " ", "\[Alpha]"}], "+", "\[Gamma]", 
      "-", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{"\[Beta]", "+", "\[Gamma]", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "\[Delta]"}]}], 
        ")"}]}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "4"]}], "+", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "t"}], ")"}], " ", "\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "5"]}], "-", 
   RowBox[{"\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "6"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", 
    SuperscriptBox["t", "3"], " ", 
    RowBox[{"u", "[", "t", "]"}], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}], "-", 
   RowBox[{"t", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "3"}], "+", "t", "+", 
         SuperscriptBox["t", "2"]}], ")"}]}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "t"}], ")"}], " ", "t", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"2", " ", "t"}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}], "-", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
    SuperscriptBox["t", "3"], " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
    SuperscriptBox["t", "2"], " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "t"}], ")"}], " ", 
    RowBox[{"u", "[", "t", "]"}], " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "2"]}], "-", 
   RowBox[{
    FractionBox["3", "2"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
    SuperscriptBox["t", "2"], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"], " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "t", "]"}], "2"]}], "+", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
    SuperscriptBox["t", "3"], " ", 
    RowBox[{"u", "[", "t", "]"}], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}], "-", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
    SuperscriptBox["t", "2"], " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", "t"}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "2"], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}], "+", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "t"}], ")"}], "2"], " ", 
    SuperscriptBox["t", "2"], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "t", "]"}], "3"], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]\[Prime]",
      MultilineFunction->None], "[", "t", "]"}]}]}], "\[Equal]", 
  "0"}]], "Output",
 CellChangeTimes->{3.8465600106839743`*^9},
 CellLabel->
  "Out[253]=",ExpressionUUID->"505247ad-55bb-428b-af14-369eb0a7b1dd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p6eq", "/.", 
  RowBox[{"t", "\[Rule]", "1"}]}]], "Input",
 CellChangeTimes->{{3.846560058531129*^9, 3.846560067748289*^9}},
 CellLabel->
  "In[258]:=",ExpressionUUID->"1070e0fd-3d60-4e88-81b6-986e93b9b3bf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "\[Beta]"}], "+", 
   RowBox[{"4", " ", "\[Beta]", " ", 
    RowBox[{"u", "[", "1", "]"}]}], "-", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"\[Alpha]", "+", 
      RowBox[{"6", " ", "\[Beta]"}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "1", "]"}], "2"]}], "+", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "\[Alpha]"}], "+", 
      RowBox[{"2", " ", "\[Beta]"}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "1", "]"}], "3"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "6"}], " ", "\[Alpha]"}], "-", "\[Beta]"}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "1", "]"}], "4"]}], "+", 
   RowBox[{"4", " ", "\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "1", "]"}], "5"]}], "-", 
   RowBox[{"\[Alpha]", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "1", "]"}], "6"]}]}], "\[Equal]", "0"}]], "Output",
 CellChangeTimes->{{3.8465600650722933`*^9, 3.8465600680743217`*^9}},
 CellLabel->
  "Out[258]=",ExpressionUUID->"456020fc-f1b3-4452-b54b-b09394775179"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p6eq", "/.", 
  RowBox[{"t", "\[Rule]", "2"}]}]], "Input",
 CellChangeTimes->{{3.8465601191418905`*^9, 3.8465601285638905`*^9}},
 CellLabel->
  "In[264]:=",ExpressionUUID->"2aab5a55-2670-464c-8bd7-f3c5c15a7c0f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "8"}], "+", 
   RowBox[{"24", " ", 
    RowBox[{"u", "[", "2", "]"}]}], "-", 
   RowBox[{"36", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "2", "]"}], "2"]}], "+", 
   RowBox[{"32", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "2", "]"}], "3"]}], "-", 
   RowBox[{"18", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "2", "]"}], "4"]}], "+", 
   RowBox[{"6", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "2", "]"}], "5"]}], "-", 
   SuperscriptBox[
    RowBox[{"u", "[", "2", "]"}], "6"], "+", 
   RowBox[{"8", " ", 
    RowBox[{"u", "[", "2", "]"}], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "2", "]"}]}], "-", 
   RowBox[{"14", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "2", "]"}], "2"], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "2", "]"}]}], "+", 
   RowBox[{"6", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "2", "]"}], "3"], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]",
      MultilineFunction->None], "[", "2", "]"}]}], "-", 
   RowBox[{"4", " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "2", "]"}], "2"]}], "+", 
   RowBox[{"12", " ", 
    RowBox[{"u", "[", "2", "]"}], " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "2", "]"}], "2"]}], "-", 
   RowBox[{"6", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "2", "]"}], "2"], " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["u", "\[Prime]",
       MultilineFunction->None], "[", "2", "]"}], "2"]}], "+", 
   RowBox[{"8", " ", 
    RowBox[{"u", "[", "2", "]"}], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]\[Prime]",
      MultilineFunction->None], "[", "2", "]"}]}], "-", 
   RowBox[{"12", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "2", "]"}], "2"], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]\[Prime]",
      MultilineFunction->None], "[", "2", "]"}]}], "+", 
   RowBox[{"4", " ", 
    SuperscriptBox[
     RowBox[{"u", "[", "2", "]"}], "3"], " ", 
    RowBox[{
     SuperscriptBox["u", "\[Prime]\[Prime]",
      MultilineFunction->None], "[", "2", "]"}]}]}], "\[Equal]", 
  "0"}]], "Output",
 CellChangeTimes->{{3.846560122463891*^9, 3.8465601288579206`*^9}},
 CellLabel->
  "Out[264]=",ExpressionUUID->"cad362ad-8ff7-44ca-9b51-404592e59095"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p6slninit", "=", 
  RowBox[{
   RowBox[{"u", "[", "t", "]"}], "/.", 
   RowBox[{"First", "@", 
    RowBox[{"NDSolve", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"p6eq", ",", 
        RowBox[{
         RowBox[{"u", "[", "1.2", "]"}], "\[Equal]", "2"}], ",", 
        RowBox[{
         RowBox[{"u", "[", "1.4", "]"}], "\[Equal]", "2"}]}], "}"}], ",", 
      RowBox[{"u", "[", "t", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "1.2", ",", "1.4"}], "}"}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.8426939161313314`*^9, 3.842694006070348*^9}, {
   3.8426997651303577`*^9, 3.842699781773082*^9}, {3.842699978637831*^9, 
   3.842699982635831*^9}, 3.8427004592692733`*^9, {3.8427006077461886`*^9, 
   3.8427008183178144`*^9}, {3.8427008484961348`*^9, 3.84270090651987*^9}, {
   3.842872763532899*^9, 3.8428727667190256`*^9}, {3.8428850351101875`*^9, 
   3.8428851011648207`*^9}, {3.8428851370643525`*^9, 
   3.8428852247538605`*^9}, {3.8456099132136106`*^9, 3.84560992271661*^9}, {
   3.845610024583664*^9, 3.845610036580663*^9}, {3.8456105019743233`*^9, 
   3.845610507269325*^9}, {3.8456106934233894`*^9, 3.8456106940484004`*^9}, {
   3.8456123730939584`*^9, 3.845612374408988*^9}, {3.845612710125719*^9, 
   3.8456127172707253`*^9}, {3.8456133973376493`*^9, 
   3.8456134041616507`*^9}, {3.845613473807605*^9, 3.845613506547773*^9}, {
   3.8456135429725857`*^9, 3.845613546098542*^9}, {3.8456136722543287`*^9, 
   3.845613681994297*^9}, {3.8456246273210564`*^9, 3.8456246354790573`*^9}, {
   3.845624776192647*^9, 3.845624776574648*^9}, {3.8456248665766773`*^9, 
   3.845624872863677*^9}, {3.8456287476157618`*^9, 3.845628752918765*^9}, {
   3.8456293143421016`*^9, 3.8456293306851025`*^9}, {3.846560101925289*^9, 
   3.846560105492797*^9}, {3.8465601390708914`*^9, 3.8465601681649227`*^9}, {
   3.8465612363038664`*^9, 3.8465612654308677`*^9}},
 CellLabel->
  "In[271]:=",ExpressionUUID->"a7917842-15aa-4d0c-a87c-e06f3d842086"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   RowBox[{
    TagBox["InterpolatingFunction",
     "SummaryHead"], "[", 
    DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
     TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
             PaneBox[
              ButtonBox[
               DynamicBox[
                FEPrivate`FrontEndResource[
                "FEBitmaps", "SquarePlusIconMedium"]], 
               ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
               Evaluator -> Automatic, Method -> "Preemptive"], 
              Alignment -> {Center, Center}, ImageSize -> 
              Dynamic[{
                Automatic, 
                 3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                  Magnification])}]], 
             GraphicsBox[{{{{}, {}, 
                 TagBox[{
                   Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                   LineBox[CompressedData["
1:eJwVk3lMVGcUxREkRaEIiAJTRiRETHEoyBBcih5pIYxQrQuCLELZphBgsEyC
DAJSBcHImKYDFgYRC0ijsgjI0lEQcNopTtUuUEhlKdjWoAKS973XlML3+vzj
5uYmJ79zc3Kva0LmkWRTExMTf6HedN0WZ1+plEGEvGOZ53noHv0wp97HINnw
ZK76Zx72stU7LT5m4JlmEDXU8/DQS/8ui2EQf2zpa2Uej+0+f7Q9SmXg8p0o
OiCSx5dZ71i/l8NgLHB4T6ofj9Y7IY8rixmET4hMjI483IcsXNzKGeQ9VE/W
/kehfvKhOrWOwcqae8290xS3R7PidK0MqkbEhhkjhWe796BHH4PC9dmyoi4K
+aWZ0utGBm7O3ZqaBoovYmwzxscY9GoNZpPlFPYrj6d9njOIUvxp1lxMEVZb
qNMQwX9E4uupophfP+Bmb0YQF/BqS2QGRU5uwc1DtgQpytmFTxIp+ma8Kr7a
RBCVEHvxVDRFrPikDZUQHJ5yjzgcRqGLbFhQ7CaoOj//4OVBipMpn8bxMoLO
c6t7kkIoHFK/eRUaQTA6YE12BFOo0p5O1CURNDhORoYHUfjtuxrnpCS4cjWL
SwukaNl4LEhbSHCtqCxfI8wOU6WyUTWB+Uqfc52g/10VOi69QqB3WVvVL/Ai
N5oOa28Q3Boa2Fot+PkUB8e49hCo5nf01Aj7LP+1xjTpe4IPnK6//uwoxeey
fsu2Xwm8Cwzh3ccp4vPNG8UzBK+n+W174gR9x96G8gUhj8pKyTo5Rek4uW9Y
Jsi8rMlJEfJRjO5KF1myMBFnjDllU9gMZ+WdcmTx/v7OsxMFFFb1u8XEncWG
Vrtb1hco9ErO9bQviz5xTJSvhiLdzyuwL4DFP2YZm3U1As/IcZsPsSidDpLq
b1BIEtrfvnSCxTW3OommkyLQuHxHlM4iXz2iXRqkOOCuVyXmssgNObKq9ycK
u3Nn6rpKWLRbrOpwnKTY3j4U/e5lFvODL+Ruc8I+z95SNdazsKwtqWgT7mvU
/EHH1G2Br/roX8VaHstLVmd23mdhzG/atijiMbEY0lL9Iwvim6P9xYOH410H
xaanLA7cDau46M8jMDs+9MQsC72hI0J5kIdEWlvWyAn8Z7b7K+N4KAbTYteZ
c+gfbKq+mcUj/aik/KwdB3tul/lsEQ991+moDa4cmp5LbLdW8bCyku1N8uLw
0lLkXdjMwybR4nyvPweJp9zueb/AK4uI9Qvl0PKwIjjxNx6l3Vrtt8c5lNzz
N5t8wWNKmZ8sl3NYdM5cefOv/wNtivNQ
                    "]]}, 
                  Annotation[#, "Charting`Private`Tag$85328#1"]& ]}}, {}}, {
              DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
               AxesOrigin -> {1.2, 1.8917045237412031`}, 
               FrameTicks -> {{{}, {}}, {{}, {}}}, GridLines -> {None, None}, 
               DisplayFunction -> Identity, PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
               All, DisplayFunction -> Identity, AspectRatio -> 1, 
               Axes -> {False, False}, AxesLabel -> {None, None}, 
               AxesOrigin -> {1.2, 1.8917045237412031`}, DisplayFunction :> 
               Identity, Frame -> {{True, True}, {True, True}}, 
               FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
               Directive[
                 Opacity[0.5], 
                 Thickness[Tiny], 
                 RGBColor[0.368417, 0.506779, 0.709798]], 
               FrameTicks -> {{None, None}, {None, None}}, 
               GridLines -> {None, None}, GridLinesStyle -> Directive[
                 GrayLevel[0.5, 0.4]], ImageSize -> 
               Dynamic[{
                 Automatic, 
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                   Magnification])}], 
               Method -> {
                "DefaultBoundaryStyle" -> Automatic, 
                 "DefaultGraphicsInteraction" -> {
                  "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                   "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                 "DefaultMeshStyle" -> AbsolutePointSize[6], 
                 "ScalingFunctions" -> None, 
                 "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
               PlotRange -> {{1.2, 1.4}, {1.8917045237412031`, 
                1.9999999904410368`}}, PlotRangeClipping -> True, 
               PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
             GridBox[{{
                RowBox[{
                  TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox[
                   RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"1.2`", ",", "1.4`"}], "}"}], "}"}], 
                   "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"scalar\"", "SummaryItem"]}]}}, 
              GridBoxAlignment -> {
               "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
              False, GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              GridBoxSpacings -> {
               "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
              BaseStyle -> {
               ShowStringCharacters -> False, NumberMarks -> False, 
                PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
           GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
           GridBoxItemSize -> {
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
           BaselinePosition -> {1, 1}], True -> GridBox[{{
             PaneBox[
              ButtonBox[
               DynamicBox[
                FEPrivate`FrontEndResource[
                "FEBitmaps", "SquareMinusIconMedium"]], 
               ButtonFunction :> (Typeset`open$$ = False), Appearance -> None,
                Evaluator -> Automatic, Method -> "Preemptive"], 
              Alignment -> {Center, Center}, ImageSize -> 
              Dynamic[{
                Automatic, 
                 3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                  Magnification])}]], 
             GraphicsBox[{{{{}, {}, 
                 TagBox[{
                   Directive[
                    Opacity[1.], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1]], 
                   LineBox[CompressedData["
1:eJwVk3lMVGcUxREkRaEIiAJTRiRETHEoyBBcih5pIYxQrQuCLELZphBgsEyC
DAJSBcHImKYDFgYRC0ijsgjI0lEQcNopTtUuUEhlKdjWoAKS973XlML3+vzj
5uYmJ79zc3Kva0LmkWRTExMTf6HedN0WZ1+plEGEvGOZ53noHv0wp97HINnw
ZK76Zx72stU7LT5m4JlmEDXU8/DQS/8ui2EQf2zpa2Uej+0+f7Q9SmXg8p0o
OiCSx5dZ71i/l8NgLHB4T6ofj9Y7IY8rixmET4hMjI483IcsXNzKGeQ9VE/W
/kehfvKhOrWOwcqae8290xS3R7PidK0MqkbEhhkjhWe796BHH4PC9dmyoi4K
+aWZ0utGBm7O3ZqaBoovYmwzxscY9GoNZpPlFPYrj6d9njOIUvxp1lxMEVZb
qNMQwX9E4uupophfP+Bmb0YQF/BqS2QGRU5uwc1DtgQpytmFTxIp+ma8Kr7a
RBCVEHvxVDRFrPikDZUQHJ5yjzgcRqGLbFhQ7CaoOj//4OVBipMpn8bxMoLO
c6t7kkIoHFK/eRUaQTA6YE12BFOo0p5O1CURNDhORoYHUfjtuxrnpCS4cjWL
SwukaNl4LEhbSHCtqCxfI8wOU6WyUTWB+Uqfc52g/10VOi69QqB3WVvVL/Ai
N5oOa28Q3Boa2Fot+PkUB8e49hCo5nf01Aj7LP+1xjTpe4IPnK6//uwoxeey
fsu2Xwm8Cwzh3ccp4vPNG8UzBK+n+W174gR9x96G8gUhj8pKyTo5Rek4uW9Y
Jsi8rMlJEfJRjO5KF1myMBFnjDllU9gMZ+WdcmTx/v7OsxMFFFb1u8XEncWG
Vrtb1hco9ErO9bQviz5xTJSvhiLdzyuwL4DFP2YZm3U1As/IcZsPsSidDpLq
b1BIEtrfvnSCxTW3OommkyLQuHxHlM4iXz2iXRqkOOCuVyXmssgNObKq9ycK
u3Nn6rpKWLRbrOpwnKTY3j4U/e5lFvODL+Ruc8I+z95SNdazsKwtqWgT7mvU
/EHH1G2Br/roX8VaHstLVmd23mdhzG/atijiMbEY0lL9Iwvim6P9xYOH410H
xaanLA7cDau46M8jMDs+9MQsC72hI0J5kIdEWlvWyAn8Z7b7K+N4KAbTYteZ
c+gfbKq+mcUj/aik/KwdB3tul/lsEQ991+moDa4cmp5LbLdW8bCyku1N8uLw
0lLkXdjMwybR4nyvPweJp9zueb/AK4uI9Qvl0PKwIjjxNx6l3Vrtt8c5lNzz
N5t8wWNKmZ8sl3NYdM5cefOv/wNtivNQ
                    "]]}, 
                  Annotation[#, "Charting`Private`Tag$85328#1"]& ]}}, {}}, {
              DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
               AxesOrigin -> {1.2, 1.8917045237412031`}, 
               FrameTicks -> {{{}, {}}, {{}, {}}}, GridLines -> {None, None}, 
               DisplayFunction -> Identity, PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
               All, DisplayFunction -> Identity, AspectRatio -> 1, 
               Axes -> {False, False}, AxesLabel -> {None, None}, 
               AxesOrigin -> {1.2, 1.8917045237412031`}, DisplayFunction :> 
               Identity, Frame -> {{True, True}, {True, True}}, 
               FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
               Directive[
                 Opacity[0.5], 
                 Thickness[Tiny], 
                 RGBColor[0.368417, 0.506779, 0.709798]], 
               FrameTicks -> {{None, None}, {None, None}}, 
               GridLines -> {None, None}, GridLinesStyle -> Directive[
                 GrayLevel[0.5, 0.4]], ImageSize -> 
               Dynamic[{
                 Automatic, 
                  3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                   Magnification])}], 
               Method -> {
                "DefaultBoundaryStyle" -> Automatic, 
                 "DefaultGraphicsInteraction" -> {
                  "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                   "Effects" -> {
                    "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                 "DefaultMeshStyle" -> AbsolutePointSize[6], 
                 "ScalingFunctions" -> None, 
                 "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
               PlotRange -> {{1.2, 1.4}, {1.8917045237412031`, 
                1.9999999904410368`}}, PlotRangeClipping -> True, 
               PlotRangePadding -> {{
                  Scaled[0.1], 
                  Scaled[0.1]}, {
                  Scaled[0.1], 
                  Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
             GridBox[{{
                RowBox[{
                  TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox[
                   RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"1.2`", ",", "1.4`"}], "}"}], "}"}], 
                   "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"scalar\"", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["3", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["\"Hermite\"", "SummaryItem"]}]}, {
                RowBox[{
                  TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                  "\[InvisibleSpace]", 
                  TagBox["False", "SummaryItem"]}]}}, 
              GridBoxAlignment -> {
               "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
              False, GridBoxItemSize -> {
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
              GridBoxSpacings -> {
               "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
              BaseStyle -> {
               ShowStringCharacters -> False, NumberMarks -> False, 
                PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
           GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
           GridBoxItemSize -> {
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
           BaselinePosition -> {1, 1}]}, 
        Dynamic[Typeset`open$$], ImageSize -> Automatic]},
      "SummaryPanel"],
     DynamicModuleValues:>{}], "]"}],
   InterpolatingFunction[{{1.2, 1.4}}, {
    5, 7, 2, {58}, {4}, 0, 0, 0, 0, Automatic, {}, {}, False}, CompressedData["
1:eJwB4QEe/iFib1JlAgAAAAEAAAA6AAAAMzMzMzMz8z8qSo6GOjPzPyJh6dlB
M/M/Yvjsv90z8z+hj/CleTTzP+Em9IsVNfM/Zel6Cew28z/oqwGHwjjzP2xu
iASZOvM/8DAPgm888z/3tRx9HEDzP/46KnjJQ/M/BcA3c3ZH8z8MRUVuI0vz
PxPKUmnQTvM/ZqKAG9VW8z+5eq7N2V7zPwxT3H/eZvM/XysKMuNu8z+yAzjk
53bzPwXcZZbsfvM/FnhpK5uJ8z8oFG3ASZTzPzmwcFX4nvM/Skx06qap8z9b
6Hd/VbTzP22EexQEv/M/fiB/qbLJ8z9qYfy00NfzP1aiecDu5fM/Q+P2ywz0
8z8vJHTXKgL0Pxtl8eJIEPQ/B6Zu7mYe9D/z5uv5hCz0P+AnaQWjOvQ/5yyq
IkVO9D/uMes/52H0P/Y2LF2JdfQ//TtteiuJ9D8EQa6XzZz0PwxG77RvsPQ/
E0sw0hHE9D8aUHHvs9f0PyFVsgxW6/Q/86dcdqcH9T/E+gbg+CP1P5VNsUlK
QPU/ZqBbs5tc9T838wUd7Xj1PwlGsIY+lfU/2pha8I+x9T+r6wRa4c31P3w+
r8My6vU/jXI6v/MR9j+epsW6tDn2P4IGlpANUPY/ZmZmZmZm9j/cr+7b
    "], {Developer`PackedArrayForm, {0, 3, 6, 9, 12, 15, 18, 21, 24, 27, 30, 
     33, 36, 39, 42, 45, 48, 51, 54, 57, 60, 63, 66, 69, 72, 75, 78, 81, 84, 
     87, 90, 93, 96, 99, 102, 105, 108, 111, 114, 117, 120, 123, 126, 129, 
     132, 135, 138, 141, 144, 147, 150, 153, 156, 159, 162, 165, 168, 171, 
     174}, CompressedData["
1:eJw9lHk41Hkcx2dIibHYXD0dm6PCiHEWPXy+IcfmHMcMYRWjg5JrRA9rIxuL
kghRIpEOZ+TI71fj2EhFS7mKVo5yTMI4f7/1177/fD2v/17P81Y8HsjkUCkU
ymPK/0NttxhVYVQJXJQl2tk5z0JmBB70hSTBuLj7qRxFAo/Tk3Yom2MhNpM3
0rbOJfXEX9cQNDz3dP9wyg8WCuDnCTLWSHhO4QRlD9NwmpQq82o/C1Wn4Iiz
QoLTAs0ou4mG1+ifq6ngsdCWum/P9JdIKPmNSqkpouH2w+m98w9YaFU2JrRk
loStAc9F9zvS8JPTZUVyHBa6cL3om84kCQm71AJqV8Rxrzh2o9svLJRb6zrx
+gsJIYJBBaMicXxgnnqits8V5bzK0o3+REJ8sYHwEydxvCspbSPjhityi05q
k31HQq1VVnNCqRiebJt/zGaLK/reNT8raCGh3qh9REFSDN9Wy4iNS3NBq+qc
NaV6EjLzu1vMgzfjVl2+MmXyLojrFmSZXkpC4UDWJP+DKM6jN18tvu2M5IcK
DtreJaFRbnGKaiaKD6qf0bWmO6M2riDmZhIJdDOLgAObNuEhFi3jYYZOaEOR
48BOLgn53Rq58n0i+MYXuWbSLCZaHA+TeelNwsQQ4OV1G3D/OlrI2EVHlLLG
706yIeH8r9N/0YuF8W2fQxeH6h1QrPrZPE9DEgKoJn51d4Twz6uCApLigKiH
x6q19pIwFfN+LP8eFT8xmPWpJt8ORapnpYVKkfAiuT8t+yQFf2aSkf5h2gaN
BguZu64Q8FaoYFbhPIGdFjQUBXscQUcCD7k1jhHg658lawWrWHD0HyYnxq3R
xtkY2cxuAlItwl3YKstYvTFz28wVK2Tam23+tokATbP7yfK7F7HGi5ScKw6W
6OrxCgWXJwScGVitvAQLmNHvLDtpVQtkef+SmFwRAX4glv4maA77GBbbFi5z
GGmnkFskMggIW3J6ydGexbT2Rl+3ajZD1szAEX48AZPCn1osZfgYVSeruy/N
FHVGMhoKIgigV2bGV2tOYhEJdD1q1CGUdqowWOwsAbLtmu2VgeNYy9dXbnNR
CAkedjFovgTocgLKk0dHsGARw9rLqoCOhiXqXTtKwP2fu0vbU4axcyAiyLxg
jBJJfvafzgSwpt9/7fh7ALPZZJbq+P0gMotiavfaEVBF2WoQ2dqDFUZZ9LjH
GyFJewuOjDUBWN6YHfG+A9vu47W6q+EAemqrM1RwmICIdLHb5q6NmO+OhcJ+
xf0oPM1g2ducgBvqyuHCHfEY9UI9p6BcH312NBRSW/ejGA+oHgvV0OpQnuDv
p4cKhZd5A5YE3P1Jn9TMbwVei5TSx4O66GLRsV+8bQh41hEacDm5EyrY+wpM
NHWQHub4OItJAK+ukme50gPST263OxppI+GKO9xgdwKib/ottSgOALcvr8na
k4FKDwTe6/YhIKa8XfBP7BCwS7az/dW00Izdw1Z+CAEvLbESpd5/oW+rSp7n
nn1oaHlmanS9i++UFqaxNAqYGD2p3peOXMseCSXlEACbd+Q8+DoB5WU9Ctx+
NfQocYhbW0XAmsF56TOVk3Bd0SNo7aIqkn06H2f7hoBgN6+8SPYMXOPlJC45
70WjHl6p6pMEJNtqeGyf4UMvJyNZ2mYPkg7TuWsgTsKyZcM+pDILeKJBVaPP
bmSUwhW4a5DQWtWs7G77A271S0iqZqqg+vHQjFh7EkpTFEwn/Oeg0fOshcio
MpK6TFfcHUcCI7QJfZuehzveN41vSCujI/aBImENJCiY7lz6cVwA7zzsX7B9
lJCGQJDwaJAEXY+M01c0FyGiPOaUipQS0krtI8j1n1R05ARgC4sQVDqVfalF
Ef0HETm5Uw==
     "]}, {Automatic}],
   Editable->False,
   SelectWithContents->True,
   Selectable->False], "[", "t", "]"}]], "Output",
 CellChangeTimes->{{3.8426939444243317`*^9, 3.842694006561348*^9}, 
   3.84269974298481*^9, 3.8426997867766914`*^9, {3.842699986609831*^9, 
   3.8426999975153856`*^9}, {3.8427006024651895`*^9, 
   3.8427006088621883`*^9}, {3.842700652549751*^9, 3.8427007319121237`*^9}, {
   3.8427007625997343`*^9, 3.842700818982815*^9}, {3.842700850033383*^9, 
   3.8427009075318704`*^9}, {3.842872758100527*^9, 3.842872772804067*^9}, {
   3.8428850521105127`*^9, 3.8428850700887947`*^9}, 3.842885101626334*^9, {
   3.84288514319666*^9, 3.842885150397394*^9}, {3.8428851813725824`*^9, 
   3.842885225271267*^9}, 3.842943425361492*^9, 3.8456099243736105`*^9, 
   3.8456104278403244`*^9, {3.845610510542324*^9, 3.8456105133878317`*^9}, 
   3.84561069568637*^9, 3.8456123749759283`*^9, 3.845612718154669*^9, 
   3.8456134054046445`*^9, {3.8456134798055735`*^9, 3.8456135073557663`*^9}, 
   3.845613703614783*^9, 3.8456246361140575`*^9, {3.8456247271285906`*^9, 
   3.8456247538116107`*^9}, 3.845624794565648*^9, 3.845624873976677*^9, 
   3.845628760995754*^9, 3.845629332116103*^9, 3.8465601074797955`*^9, {
   3.846560147338891*^9, 3.8465601692268915`*^9}, {3.8465612396248674`*^9, 
   3.8465612661198664`*^9}},
 CellLabel->
  "Out[271]=",ExpressionUUID->"7bb87abf-d212-4535-a6cc-74a5d09df477"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{"p6slninit", ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "1.2", ",", "1.4"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.8426940287335978`*^9, 3.8426940389565983`*^9}, {
   3.84269972015781*^9, 3.8426997229958105`*^9}, {3.84269978491842*^9, 
   3.8426997855076914`*^9}, 3.8426999845168314`*^9, 3.8427004612212744`*^9, 
   3.8427006838305225`*^9, {3.8427008309031625`*^9, 3.8427008993898706`*^9}, {
   3.842872756270136*^9, 3.842872790077813*^9}, {3.842885209531869*^9, 
   3.8428852409378653`*^9}, 3.84561341836567*^9, {3.8456134873978157`*^9, 
   3.8456135183475933`*^9}, 3.846560113917823*^9, {3.846560172186924*^9, 
   3.8465601740769525`*^9}},
 CellLabel->
  "In[272]:=",ExpressionUUID->"2ca2def9-e47b-43ee-9ff7-82a09adb656b"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJwV2Hk4lN8XAHDJlopSll9JEpUIWZKlDskSKdlKRPatZEspRZItkYgWppJC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       "]]},
     Annotation[#, "Charting`Private`Tag$85592#1"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{1.2, 1.8916911897336426`},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}, {Automatic, 
     Charting`ScaledFrameTicks[{Identity, Identity}]}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->{887., Automatic},
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{1.2, 1.4}, {1.8916911897336426`, 1.9999999893616587`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.846560114804827*^9, 3.8465601746599803`*^9, {3.846561242310869*^9, 
   3.8465612680478992`*^9}},
 CellLabel->
  "Out[272]=",ExpressionUUID->"2e84784c-611f-4e1b-93d0-e67d3446e72e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"gridres", "=", "100"}], ",", 
   RowBox[{"gridres", "<", "501"}], ",", 
   RowBox[{"gridres", "+=", "100"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"grid", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"t", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "1.2", ",", "1.4", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1.4", "-", "1.2"}], ")"}], "/", "gridres"}]}], "}"}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"tab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"p6slninit", ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "grid"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"SetDirectory", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"StringJoin", "[", 
       RowBox[{"\"\<wolfram_sln/\>\"", ",", "\"\<P_VI_sln_\>\"", ",", 
        RowBox[{"ToString", "[", "gridres", "]"}], ",", "\"\<.csv\>\""}], 
       "]"}], ",", "tab"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.84355487838768*^9, 3.843554895410679*^9}, 
   3.843637870955584*^9, {3.8436518489699364`*^9, 3.843651862123931*^9}, {
   3.8437122175066123`*^9, 3.8437122224826703`*^9}, {3.8465634204017496`*^9, 
   3.84656344559275*^9}},
 CellLabel->
  "In[274]:=",ExpressionUUID->"a379991e-8845-49dd-8b36-8425852443a1"]
},
WindowSize->{1904, 997},
WindowMargins->{{-8, Automatic}, {Automatic, 0}},
TaggingRules->{"TryRealOnly" -> False},
FrontEndVersion->"12.0 for Microsoft Windows (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 344, 8, 28, "Input",ExpressionUUID->"f1254a11-41fb-47a9-ad36-2e6c545a3799"],
Cell[CellGroupData[{
Cell[927, 32, 520, 14, 28, "Input",ExpressionUUID->"723eb20b-91fa-4ba9-951d-c26584da6958"],
Cell[1450, 48, 677, 15, 32, "Output",ExpressionUUID->"cd89965d-ab0f-4d30-a1cc-65296b22f96d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2164, 68, 207, 3, 28, "Input",ExpressionUUID->"4289db51-8f97-4808-b9b0-ad3c9c5d2571"],
Cell[2374, 73, 169, 3, 46, "Output",ExpressionUUID->"1dd87e5f-6d65-4c37-b3c5-f35d489ae9aa"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2580, 81, 794, 21, 28, "Input",ExpressionUUID->"5e037d62-d397-4259-b161-c781f9be6548"],
Cell[3377, 104, 16349, 316, 71, "Output",ExpressionUUID->"268c1833-a1e6-4cd5-884f-d8563d3769dc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19763, 425, 391, 8, 28, "Input",ExpressionUUID->"80025d57-69b2-4b39-b713-800172d55e34"],
Cell[20157, 435, 7378, 141, 540, "Output",ExpressionUUID->"73a6ec9a-613e-4b99-aef8-43ded5b09174"]
}, Open  ]],
Cell[27550, 579, 1250, 30, 105, "Input",ExpressionUUID->"761d626e-7a86-4378-880c-c5c325483512"],
Cell[CellGroupData[{
Cell[28825, 613, 669, 17, 28, "Input",ExpressionUUID->"a9124145-637c-45e5-991f-1c0c92e5f787"],
Cell[29497, 632, 676, 16, 32, "Output",ExpressionUUID->"c9fc5a55-6ff8-4047-a7ce-469a74939ff9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30210, 653, 207, 3, 28, "Input",ExpressionUUID->"4b3dc734-6b80-45e2-95e9-bc7078f49a4e"],
Cell[30420, 658, 183, 3, 46, "Output",ExpressionUUID->"60c2ec2c-c71d-4918-9cab-15229819efed"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30640, 666, 792, 21, 28, "Input",ExpressionUUID->"c6c8dce6-0907-4d7c-92e5-041798d3d4b6"],
Cell[31435, 689, 15858, 307, 71, "Output",ExpressionUUID->"55f3108a-ce9d-426e-a891-155dbc11c9b4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[47330, 1001, 417, 8, 28, "Input",ExpressionUUID->"bb19a941-060a-4916-9229-f78d87008b78"],
Cell[47750, 1011, 5390, 108, 239, "Output",ExpressionUUID->"f76a0e58-0e22-4333-b434-55d93638d1ac"]
}, Open  ]],
Cell[53155, 1122, 1303, 31, 105, "Input",ExpressionUUID->"67aa16d0-6fae-471a-9419-87d1789187fa"],
Cell[54461, 1155, 1306, 31, 105, "Input",ExpressionUUID->"ae4cb91a-cab6-4378-8906-7e5a9c9a5dc7"],
Cell[CellGroupData[{
Cell[55792, 1190, 1259, 34, 28, "Input",ExpressionUUID->"dc4eb6dd-3625-4191-9689-58ac1ce443be"],
Cell[57054, 1226, 1306, 33, 32, "Output",ExpressionUUID->"f5bd9531-2b52-4064-a10c-67794312579d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[58397, 1264, 203, 3, 28, "Input",ExpressionUUID->"5b67b51f-5610-467b-9887-c43a3c30aefc"],
Cell[58603, 1269, 280, 6, 46, "Output",ExpressionUUID->"2d0eddbe-e80a-43a8-b08b-31461728f103"]
}, Open  ]],
Cell[CellGroupData[{
Cell[58920, 1280, 1002, 24, 28, "Input",ExpressionUUID->"846fc4e1-aebb-4bdd-98c5-b229f645c49f"],
Cell[59925, 1306, 24308, 447, 71, "Output",ExpressionUUID->"998cb801-7852-4b17-82af-19e97bc61018"]
}, Open  ]],
Cell[CellGroupData[{
Cell[84270, 1758, 1016, 23, 28, "Input",ExpressionUUID->"fdbe20bb-d3a0-4007-b92e-74e1db287c16"],
Cell[85289, 1783, 10790, 195, 539, "Output",ExpressionUUID->"86ae64fe-547a-4688-858e-064cd12b6276"]
}, Open  ]],
Cell[96094, 1981, 826, 23, 46, "Input",ExpressionUUID->"4417dc2c-ad9c-45f0-ae3c-95f065fc9faa"],
Cell[96923, 2006, 1589, 37, 105, "Input",ExpressionUUID->"3cba97bd-6c5c-4826-8982-d14c219c128e"],
Cell[98515, 2045, 1590, 37, 105, "Input",ExpressionUUID->"70a10a76-9c44-4f9e-8a68-a3836ad8c550"],
Cell[100108, 2084, 1358, 31, 105, "Input",ExpressionUUID->"ade83f27-c099-49d1-b9c3-f902500cf3a6"],
Cell[101469, 2117, 1384, 32, 105, "Input",ExpressionUUID->"27543429-2243-4c1c-a1c9-332d07379347"],
Cell[CellGroupData[{
Cell[102878, 2153, 1279, 35, 28, "Input",ExpressionUUID->"bc4f0fb1-dde7-41f0-9103-7e9f69a26eb8"],
Cell[104160, 2190, 1242, 33, 52, "Output",ExpressionUUID->"0acc402e-f868-4fcd-a1ef-718be6d0c9fd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[105439, 2228, 205, 3, 28, "Input",ExpressionUUID->"a7507b9d-20a4-479b-8960-a5d0bcc6a969"],
Cell[105647, 2233, 268, 6, 46, "Output",ExpressionUUID->"6a8c82c3-6151-4afe-a32d-1473fdd3b90b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[105952, 2244, 1133, 26, 28, "Input",ExpressionUUID->"4caf64ff-f249-417e-b414-0f8fc022b08f"],
Cell[107088, 2272, 25596, 470, 71, "Output",ExpressionUUID->"a553b4bc-5844-4f3c-a821-2174c91dfdac"]
}, Open  ]],
Cell[CellGroupData[{
Cell[132721, 2747, 773, 16, 28, "Input",ExpressionUUID->"e0aa3449-abb6-458b-9f1a-38ea4f6cd778"],
Cell[133497, 2765, 10958, 197, 257, "Output",ExpressionUUID->"51830756-95ae-435e-b13f-17839e039495"]
}, Open  ]],
Cell[CellGroupData[{
Cell[144492, 2967, 254, 5, 28, "Input",ExpressionUUID->"bb3a4a92-156b-4c76-b162-74fe2874262f"],
Cell[144749, 2974, 168, 2, 32, "Output",ExpressionUUID->"a2a2f12d-9536-49a5-9051-0a94693cdb22"]
}, Open  ]],
Cell[CellGroupData[{
Cell[144954, 2981, 249, 5, 28, "Input",ExpressionUUID->"8d2730fa-b52f-4400-895f-2162a23b856b"],
Cell[145206, 2988, 189, 2, 32, "Output",ExpressionUUID->"efd68e15-45f2-4da7-8ce2-de64d272c6a1"]
}, Open  ]],
Cell[145410, 2993, 1420, 36, 105, "Input",ExpressionUUID->"6c4ec927-fe85-42ca-b158-03ec1b17c886"],
Cell[CellGroupData[{
Cell[146855, 3033, 580, 16, 28, "Input",ExpressionUUID->"9515a4d7-8e2e-4e84-b9c2-32a7b6f0b79e"],
Cell[147438, 3051, 11499, 307, 301, "Output",ExpressionUUID->"d95a6f3c-e625-46b5-ba32-fa1c9b8448b1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[158974, 3363, 374, 9, 28, "Input",ExpressionUUID->"d1460756-0bb3-40ef-af98-48e075e10d88"],
Cell[159351, 3374, 9182, 151, 223, "Output",ExpressionUUID->"32b3eb9d-8401-42fa-834f-33e44dade32e"]
}, Open  ]],
Cell[168548, 3528, 202, 4, 28, "Input",ExpressionUUID->"088fa4e1-2fb5-42fb-9ec4-c24bf2e68e49"],
Cell[CellGroupData[{
Cell[168775, 3536, 574, 11, 67, "Input",ExpressionUUID->"298ffe78-7899-4f60-9e12-ab2ab30bf8d1"],
Cell[169352, 3549, 263, 3, 32, "Output",ExpressionUUID->"83d8b594-e4c9-426a-ae60-a807834c6d6e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[169652, 3557, 1918, 55, 51, "Input",ExpressionUUID->"122920a9-b168-4f2b-8efb-af9ba94521ac"],
Cell[171573, 3614, 1663, 52, 64, "Output",ExpressionUUID->"759e5fa9-4c7d-4114-a0c3-896e099ce8b4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[173273, 3671, 1936, 60, 52, "Input",ExpressionUUID->"4e171341-ea6f-463d-ab52-bd66b3af67fa"],
Cell[175212, 3733, 2103, 57, 36, "Output",ExpressionUUID->"d2be6132-12c6-477f-9503-d9303e6b4fa1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[177352, 3795, 1978, 58, 32, "Input",ExpressionUUID->"6e2d2514-7a1f-4aec-8d75-d30d192fa14d"],
Cell[179333, 3855, 1948, 58, 36, "Output",ExpressionUUID->"92869792-570a-4f80-89ac-8489fe7d3fbd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[181318, 3918, 633, 17, 32, "Input",ExpressionUUID->"f2c49cd8-db47-4f54-a464-3650559eab29"],
Cell[181954, 3937, 2280, 67, 36, "Output",ExpressionUUID->"78a83611-cbe0-433e-928e-71d26f089f47"]
}, Open  ]],
Cell[CellGroupData[{
Cell[184271, 4009, 489, 14, 32, "Input",ExpressionUUID->"48bcf89e-de7e-4826-9af2-4af5538fafd3"],
Cell[184763, 4025, 640, 18, 32, "Output",ExpressionUUID->"d1e3dc61-77d2-4f2f-b951-d4f7105d106b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[185440, 4048, 226, 5, 28, "Input",ExpressionUUID->"fae9d2c1-4759-40f8-8821-cfcaf341d21c"],
Cell[185669, 4055, 1856, 57, 32, "Output",ExpressionUUID->"b5ed8e51-27d0-4dd9-9215-cb6439a19a7a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[187562, 4117, 2118, 61, 28, "Input",ExpressionUUID->"30b6e305-6aa3-41a4-b6e8-cfcf3ded8d02"],
Cell[189683, 4180, 180, 3, 32, "Output",ExpressionUUID->"ffe79fac-d1a6-44ad-934f-963c89b9da07"]
}, Open  ]],
Cell[CellGroupData[{
Cell[189900, 4188, 2158, 61, 32, "Input",ExpressionUUID->"869f9fa3-d033-43a2-a62c-62c9dc0031a4"],
Cell[192061, 4251, 1676, 53, 32, "Output",ExpressionUUID->"f179be09-0ce2-4608-9eb2-3af39955fb00"]
}, Open  ]],
Cell[CellGroupData[{
Cell[193774, 4309, 560, 16, 32, "Input",ExpressionUUID->"e91efe22-1e85-43f5-83d9-ff8bb59908c6"],
Cell[194337, 4327, 2309, 67, 36, "Output",ExpressionUUID->"a9b9b43d-eca4-4e4a-953c-64fe4a687694"]
}, Open  ]],
Cell[CellGroupData[{
Cell[196683, 4399, 206, 3, 28, "Input",ExpressionUUID->"2d1e7ad9-d4c2-4f0a-9ca3-97172ef518b8"],
Cell[196892, 4404, 434, 8, 46, "Output",ExpressionUUID->"a819a47b-dfe2-4a93-8bcd-d6ffdf432e33"]
}, Open  ]],
Cell[CellGroupData[{
Cell[197363, 4417, 684, 17, 28, "Input",ExpressionUUID->"00ce7c92-1666-4efc-8054-6125538695e9"],
Cell[198050, 4436, 448, 12, 32, "Output",ExpressionUUID->"7b739189-8a3e-46bf-a385-94c26a99c28e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[198535, 4453, 707, 18, 28, "Input",ExpressionUUID->"742fe012-8275-4ef0-a1ac-de99e5d3fd3a"],
Cell[199245, 4473, 466, 13, 32, "Output",ExpressionUUID->"94dbfd52-d1e7-4fbf-8ad5-b50592da90ac"]
}, Open  ]],
Cell[CellGroupData[{
Cell[199748, 4491, 231, 4, 28, "Input",ExpressionUUID->"7bb586a9-2501-4600-9a0e-ea71491594da"],
Cell[199982, 4497, 1615, 50, 36, "Output",ExpressionUUID->"f7712d5a-0a1f-40f2-ad5c-1491c0d96b2f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[201634, 4552, 1875, 36, 28, "Input",ExpressionUUID->"0550505e-dc10-4cfd-9535-6aeab4892221"],
Cell[203512, 4590, 16946, 326, 71, "Output",ExpressionUUID->"32941b94-a53b-4233-b077-9bfeb9cfaee1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[220495, 4921, 709, 13, 28, "Input",ExpressionUUID->"68783b02-e947-47ad-bb44-cb98fde88075"],
Cell[221207, 4936, 6994, 134, 423, "Output",ExpressionUUID->"3d22a487-d1bc-4558-9dbd-91389ef30692"]
}, Open  ]],
Cell[228216, 5073, 1485, 35, 105, "Input",ExpressionUUID->"daae875c-fdbd-4eb9-a7bb-63b06cc82039"],
Cell[CellGroupData[{
Cell[229726, 5112, 2229, 72, 50, "Input",ExpressionUUID->"b338f956-17f9-492a-a995-66b4320d0bcb"],
Cell[231958, 5186, 2549, 82, 65, "Output",ExpressionUUID->"528f52b3-595c-4c9a-99a2-d43599a10630"]
}, Open  ]],
Cell[CellGroupData[{
Cell[234544, 5273, 2800, 86, 50, "Input",ExpressionUUID->"9e319868-0879-41c6-8b4b-358c9989fc9a"],
Cell[237347, 5361, 4518, 142, 68, "Output",ExpressionUUID->"01823a2a-f012-40c5-9fd3-ecd48decd8bd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[241902, 5508, 4655, 142, 81, "Input",ExpressionUUID->"2ccad468-4992-41f7-ad1b-01430b70821f"],
Cell[246560, 5652, 4465, 141, 68, "Output",ExpressionUUID->"2fac1535-79ca-41c9-9134-f1274f9db83a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[251062, 5798, 4995, 155, 55, "Input",ExpressionUUID->"617de578-4954-4ead-b185-60eff2d96daa"],
Cell[256060, 5955, 5074, 157, 56, "Output",ExpressionUUID->"af5c9109-d9bb-4b4b-8305-b2eaef8b73fd"]
}, Open  ]],
Cell[261149, 6115, 4757, 162, 336, "Input",ExpressionUUID->"da5d3b3f-5f92-4c6e-95c1-76e2f2e46395"],
Cell[CellGroupData[{
Cell[265931, 6281, 4861, 148, 355, "Input",ExpressionUUID->"a6793fda-113f-4a41-b329-d6d4a7935e2e"],
Cell[270795, 6431, 701, 12, 62, "Output",ExpressionUUID->"50b3e545-ebf3-4e9d-bc0d-bf8c554d9c59"]
}, Open  ]],
Cell[CellGroupData[{
Cell[271533, 6448, 3413, 97, 48, "Input",ExpressionUUID->"ad3cc4a7-43ab-4e4c-adac-9c53eea24e4a"],
Cell[274949, 6547, 362, 6, 32, "Output",ExpressionUUID->"4f18b4e5-5f09-4280-8498-9d8d7841df98"]
}, Open  ]],
Cell[CellGroupData[{
Cell[275348, 6558, 2603, 75, 28, "Input",ExpressionUUID->"5a96df8c-461a-49b5-8acf-a005ac0c0048"],
Cell[277954, 6635, 2532, 75, 32, "Output",ExpressionUUID->"dd5ae8f0-3d1c-4c2e-bf11-d539a3dd3eae"]
}, Open  ]],
Cell[CellGroupData[{
Cell[280523, 6715, 203, 3, 28, "Input",ExpressionUUID->"09316a46-4952-4462-8567-66d819ea38ea"],
Cell[280729, 6720, 543, 10, 62, "Output",ExpressionUUID->"f8a6edff-8879-4146-a053-4670da909f35"]
}, Open  ]],
Cell[CellGroupData[{
Cell[281309, 6735, 204, 3, 28, "Input",ExpressionUUID->"07ca84d2-b24e-4b29-8edd-0dc3a9ad9735"],
Cell[281516, 6740, 784, 14, 78, "Output",ExpressionUUID->"f084a9a5-5aa8-48f4-9cd5-c8fda76c8f37"]
}, Open  ]],
Cell[CellGroupData[{
Cell[282337, 6759, 113, 2, 28, "Input",ExpressionUUID->"916cf753-4cd3-4118-863d-0283196372e9"],
Cell[282453, 6763, 5590, 179, 68, "Output",ExpressionUUID->"505247ad-55bb-428b-af14-369eb0a7b1dd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[288080, 6947, 231, 5, 28, "Input",ExpressionUUID->"1070e0fd-3d60-4e88-81b6-986e93b9b3bf"],
Cell[288314, 6954, 1140, 34, 32, "Output",ExpressionUUID->"456020fc-f1b3-4452-b54b-b09394775179"]
}, Open  ]],
Cell[CellGroupData[{
Cell[289491, 6993, 235, 5, 28, "Input",ExpressionUUID->"2aab5a55-2670-464c-8bd7-f3c5c15a7c0f"],
Cell[289729, 7000, 2470, 75, 32, "Output",ExpressionUUID->"cad362ad-8ff7-44ca-9b51-404592e59095"]
}, Open  ]],
Cell[CellGroupData[{
Cell[292236, 7080, 1978, 36, 28, "Input",ExpressionUUID->"a7917842-15aa-4d0c-a87c-e06f3d842086"],
Cell[294217, 7118, 17690, 337, 71, "Output",ExpressionUUID->"7bb87abf-d212-4535-a6cc-74a5d09df477"]
}, Open  ]],
Cell[CellGroupData[{
Cell[311944, 7460, 783, 14, 28, "Input",ExpressionUUID->"2ca2def9-e47b-43ee-9ff7-82a09adb656b"],
Cell[312730, 7476, 7097, 137, 562, "Output",ExpressionUUID->"2e84784c-611f-4e1b-93d0-e67d3446e72e"]
}, Open  ]],
Cell[319842, 7616, 1438, 35, 105, "Input",ExpressionUUID->"a379991e-8845-49dd-8b36-8425852443a1"]
}
]
*)

